/* manager.c generated by valac 0.56.17, the Vala compiler
 * generated from manager.vala, do not modify */

/*
 * This file is part of budgie-desktop.
 *
 * Copyright Budgie Desktop Developers
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 */

#include "budgie-private.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include "plugin.h"
#include <libpeas/peas.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	BUDGIE_DESKTOP_MANAGER_0_PROPERTY,
	BUDGIE_DESKTOP_MANAGER_NUM_PROPERTIES
};
static GParamSpec* budgie_desktop_manager_properties[BUDGIE_DESKTOP_MANAGER_NUM_PROPERTIES];
enum  {
	BUDGIE_DESKTOP_MANAGER_PANELS_CHANGED_SIGNAL,
	BUDGIE_DESKTOP_MANAGER_PANEL_DELETED_SIGNAL,
	BUDGIE_DESKTOP_MANAGER_PANEL_ADDED_SIGNAL,
	BUDGIE_DESKTOP_MANAGER_NUM_SIGNALS
};
static guint budgie_desktop_manager_signals[BUDGIE_DESKTOP_MANAGER_NUM_SIGNALS] = {0};

static gpointer budgie_desktop_manager_parent_class = NULL;

static GList* budgie_desktop_manager_real_get_panels (BudgieDesktopManager* self);
static guint budgie_desktop_manager_real_slots_available (BudgieDesktopManager* self);
static guint budgie_desktop_manager_real_slots_used (BudgieDesktopManager* self);
static void budgie_desktop_manager_real_set_placement (BudgieDesktopManager* self,
                                                const gchar* uuid,
                                                BudgiePanelPosition position);
static void budgie_desktop_manager_real_set_transparency (BudgieDesktopManager* self,
                                                   const gchar* uuid,
                                                   BudgiePanelTransparency transparency);
static void budgie_desktop_manager_real_set_autohide (BudgieDesktopManager* self,
                                               const gchar* uuid,
                                               BudgieAutohidePolicy policy);
static void budgie_desktop_manager_real_set_dock_mode (BudgieDesktopManager* self,
                                                const gchar* uuid,
                                                gboolean dock_mode);
static void budgie_desktop_manager_real_set_size (BudgieDesktopManager* self,
                                           const gchar* uuid,
                                           gint size);
static void budgie_desktop_manager_real_set_spacing (BudgieDesktopManager* self,
                                              const gchar* uuid,
                                              gint spacing);
static void budgie_desktop_manager_real_create_new_panel (BudgieDesktopManager* self);
static void budgie_desktop_manager_real_delete_panel (BudgieDesktopManager* self,
                                               const gchar* uuid);
static GList* budgie_desktop_manager_real_get_panel_plugins (BudgieDesktopManager* self);
static GList* budgie_desktop_manager_real_get_raven_plugins (BudgieDesktopManager* self);
static void budgie_desktop_manager_real_rescan_panel_plugins (BudgieDesktopManager* self);
static void budgie_desktop_manager_real_rescan_raven_plugins (BudgieDesktopManager* self);
static void g_cclosure_user_marshal_VOID__STRING_OBJECT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static GType budgie_desktop_manager_get_type_once (void);

static GList*
budgie_desktop_manager_real_get_panels (BudgieDesktopManager* self)
{
	GList* result;
#line 19 "../src/lib/manager.vala"
	result = NULL;
#line 19 "../src/lib/manager.vala"
	return result;
#line 92 "manager.c"
}

GList*
budgie_desktop_manager_get_panels (BudgieDesktopManager* self)
{
	BudgieDesktopManagerClass* _klass_;
#line 18 "../src/lib/manager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 18 "../src/lib/manager.vala"
	_klass_ = BUDGIE_DESKTOP_MANAGER_GET_CLASS (self);
#line 18 "../src/lib/manager.vala"
	if (_klass_->get_panels) {
#line 18 "../src/lib/manager.vala"
		return _klass_->get_panels (self);
#line 107 "manager.c"
	}
#line 18 "../src/lib/manager.vala"
	return NULL;
#line 111 "manager.c"
}

static guint
budgie_desktop_manager_real_slots_available (BudgieDesktopManager* self)
{
	guint _tmp0_ = 0U;
#line 22 "../src/lib/manager.vala"
	g_critical ("Type `%s' does not implement abstract method `budgie_desktop_manager_slots_available'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 22 "../src/lib/manager.vala"
	return _tmp0_;
#line 122 "manager.c"
}

guint
budgie_desktop_manager_slots_available (BudgieDesktopManager* self)
{
	BudgieDesktopManagerClass* _klass_;
#line 22 "../src/lib/manager.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 22 "../src/lib/manager.vala"
	_klass_ = BUDGIE_DESKTOP_MANAGER_GET_CLASS (self);
#line 22 "../src/lib/manager.vala"
	if (_klass_->slots_available) {
#line 22 "../src/lib/manager.vala"
		return _klass_->slots_available (self);
#line 137 "manager.c"
	}
#line 22 "../src/lib/manager.vala"
	return 0U;
#line 141 "manager.c"
}

static guint
budgie_desktop_manager_real_slots_used (BudgieDesktopManager* self)
{
	guint _tmp0_ = 0U;
#line 23 "../src/lib/manager.vala"
	g_critical ("Type `%s' does not implement abstract method `budgie_desktop_manager_slots_used'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 23 "../src/lib/manager.vala"
	return _tmp0_;
#line 152 "manager.c"
}

guint
budgie_desktop_manager_slots_used (BudgieDesktopManager* self)
{
	BudgieDesktopManagerClass* _klass_;
#line 23 "../src/lib/manager.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 23 "../src/lib/manager.vala"
	_klass_ = BUDGIE_DESKTOP_MANAGER_GET_CLASS (self);
#line 23 "../src/lib/manager.vala"
	if (_klass_->slots_used) {
#line 23 "../src/lib/manager.vala"
		return _klass_->slots_used (self);
#line 167 "manager.c"
	}
#line 23 "../src/lib/manager.vala"
	return 0U;
#line 171 "manager.c"
}

static void
budgie_desktop_manager_real_set_placement (BudgieDesktopManager* self,
                                           const gchar* uuid,
                                           BudgiePanelPosition position)
{
#line 24 "../src/lib/manager.vala"
	g_critical ("Type `%s' does not implement abstract method `budgie_desktop_manager_set_placement'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 24 "../src/lib/manager.vala"
	return;
#line 183 "manager.c"
}

void
budgie_desktop_manager_set_placement (BudgieDesktopManager* self,
                                      const gchar* uuid,
                                      BudgiePanelPosition position)
{
	BudgieDesktopManagerClass* _klass_;
#line 24 "../src/lib/manager.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/lib/manager.vala"
	_klass_ = BUDGIE_DESKTOP_MANAGER_GET_CLASS (self);
#line 24 "../src/lib/manager.vala"
	if (_klass_->set_placement) {
#line 24 "../src/lib/manager.vala"
		_klass_->set_placement (self, uuid, position);
#line 200 "manager.c"
	}
}

static void
budgie_desktop_manager_real_set_transparency (BudgieDesktopManager* self,
                                              const gchar* uuid,
                                              BudgiePanelTransparency transparency)
{
#line 25 "../src/lib/manager.vala"
	g_critical ("Type `%s' does not implement abstract method `budgie_desktop_manager_set_transparency'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 25 "../src/lib/manager.vala"
	return;
#line 213 "manager.c"
}

void
budgie_desktop_manager_set_transparency (BudgieDesktopManager* self,
                                         const gchar* uuid,
                                         BudgiePanelTransparency transparency)
{
	BudgieDesktopManagerClass* _klass_;
#line 25 "../src/lib/manager.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/lib/manager.vala"
	_klass_ = BUDGIE_DESKTOP_MANAGER_GET_CLASS (self);
#line 25 "../src/lib/manager.vala"
	if (_klass_->set_transparency) {
#line 25 "../src/lib/manager.vala"
		_klass_->set_transparency (self, uuid, transparency);
#line 230 "manager.c"
	}
}

static void
budgie_desktop_manager_real_set_autohide (BudgieDesktopManager* self,
                                          const gchar* uuid,
                                          BudgieAutohidePolicy policy)
{
#line 26 "../src/lib/manager.vala"
	g_critical ("Type `%s' does not implement abstract method `budgie_desktop_manager_set_autohide'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 26 "../src/lib/manager.vala"
	return;
#line 243 "manager.c"
}

void
budgie_desktop_manager_set_autohide (BudgieDesktopManager* self,
                                     const gchar* uuid,
                                     BudgieAutohidePolicy policy)
{
	BudgieDesktopManagerClass* _klass_;
#line 26 "../src/lib/manager.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/lib/manager.vala"
	_klass_ = BUDGIE_DESKTOP_MANAGER_GET_CLASS (self);
#line 26 "../src/lib/manager.vala"
	if (_klass_->set_autohide) {
#line 26 "../src/lib/manager.vala"
		_klass_->set_autohide (self, uuid, policy);
#line 260 "manager.c"
	}
}

static void
budgie_desktop_manager_real_set_dock_mode (BudgieDesktopManager* self,
                                           const gchar* uuid,
                                           gboolean dock_mode)
{
#line 27 "../src/lib/manager.vala"
	g_critical ("Type `%s' does not implement abstract method `budgie_desktop_manager_set_dock_mode'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 27 "../src/lib/manager.vala"
	return;
#line 273 "manager.c"
}

void
budgie_desktop_manager_set_dock_mode (BudgieDesktopManager* self,
                                      const gchar* uuid,
                                      gboolean dock_mode)
{
	BudgieDesktopManagerClass* _klass_;
#line 27 "../src/lib/manager.vala"
	g_return_if_fail (self != NULL);
#line 27 "../src/lib/manager.vala"
	_klass_ = BUDGIE_DESKTOP_MANAGER_GET_CLASS (self);
#line 27 "../src/lib/manager.vala"
	if (_klass_->set_dock_mode) {
#line 27 "../src/lib/manager.vala"
		_klass_->set_dock_mode (self, uuid, dock_mode);
#line 290 "manager.c"
	}
}

static void
budgie_desktop_manager_real_set_size (BudgieDesktopManager* self,
                                      const gchar* uuid,
                                      gint size)
{
#line 28 "../src/lib/manager.vala"
	g_critical ("Type `%s' does not implement abstract method `budgie_desktop_manager_set_size'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 28 "../src/lib/manager.vala"
	return;
#line 303 "manager.c"
}

void
budgie_desktop_manager_set_size (BudgieDesktopManager* self,
                                 const gchar* uuid,
                                 gint size)
{
	BudgieDesktopManagerClass* _klass_;
#line 28 "../src/lib/manager.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/lib/manager.vala"
	_klass_ = BUDGIE_DESKTOP_MANAGER_GET_CLASS (self);
#line 28 "../src/lib/manager.vala"
	if (_klass_->set_size) {
#line 28 "../src/lib/manager.vala"
		_klass_->set_size (self, uuid, size);
#line 320 "manager.c"
	}
}

static void
budgie_desktop_manager_real_set_spacing (BudgieDesktopManager* self,
                                         const gchar* uuid,
                                         gint spacing)
{
#line 29 "../src/lib/manager.vala"
	g_critical ("Type `%s' does not implement abstract method `budgie_desktop_manager_set_spacing'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 29 "../src/lib/manager.vala"
	return;
#line 333 "manager.c"
}

void
budgie_desktop_manager_set_spacing (BudgieDesktopManager* self,
                                    const gchar* uuid,
                                    gint spacing)
{
	BudgieDesktopManagerClass* _klass_;
#line 29 "../src/lib/manager.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/lib/manager.vala"
	_klass_ = BUDGIE_DESKTOP_MANAGER_GET_CLASS (self);
#line 29 "../src/lib/manager.vala"
	if (_klass_->set_spacing) {
#line 29 "../src/lib/manager.vala"
		_klass_->set_spacing (self, uuid, spacing);
#line 350 "manager.c"
	}
}

static void
budgie_desktop_manager_real_create_new_panel (BudgieDesktopManager* self)
{
#line 31 "../src/lib/manager.vala"
	g_critical ("Type `%s' does not implement abstract method `budgie_desktop_manager_create_new_panel'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 31 "../src/lib/manager.vala"
	return;
#line 361 "manager.c"
}

void
budgie_desktop_manager_create_new_panel (BudgieDesktopManager* self)
{
	BudgieDesktopManagerClass* _klass_;
#line 31 "../src/lib/manager.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/lib/manager.vala"
	_klass_ = BUDGIE_DESKTOP_MANAGER_GET_CLASS (self);
#line 31 "../src/lib/manager.vala"
	if (_klass_->create_new_panel) {
#line 31 "../src/lib/manager.vala"
		_klass_->create_new_panel (self);
#line 376 "manager.c"
	}
}

static void
budgie_desktop_manager_real_delete_panel (BudgieDesktopManager* self,
                                          const gchar* uuid)
{
#line 32 "../src/lib/manager.vala"
	g_critical ("Type `%s' does not implement abstract method `budgie_desktop_manager_delete_panel'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 32 "../src/lib/manager.vala"
	return;
#line 388 "manager.c"
}

void
budgie_desktop_manager_delete_panel (BudgieDesktopManager* self,
                                     const gchar* uuid)
{
	BudgieDesktopManagerClass* _klass_;
#line 32 "../src/lib/manager.vala"
	g_return_if_fail (self != NULL);
#line 32 "../src/lib/manager.vala"
	_klass_ = BUDGIE_DESKTOP_MANAGER_GET_CLASS (self);
#line 32 "../src/lib/manager.vala"
	if (_klass_->delete_panel) {
#line 32 "../src/lib/manager.vala"
		_klass_->delete_panel (self, uuid);
#line 404 "manager.c"
	}
}

static GList*
budgie_desktop_manager_real_get_panel_plugins (BudgieDesktopManager* self)
{
#line 34 "../src/lib/manager.vala"
	g_critical ("Type `%s' does not implement abstract method `budgie_desktop_manager_get_panel_plugins'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 34 "../src/lib/manager.vala"
	return NULL;
#line 415 "manager.c"
}

GList*
budgie_desktop_manager_get_panel_plugins (BudgieDesktopManager* self)
{
	BudgieDesktopManagerClass* _klass_;
#line 34 "../src/lib/manager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 34 "../src/lib/manager.vala"
	_klass_ = BUDGIE_DESKTOP_MANAGER_GET_CLASS (self);
#line 34 "../src/lib/manager.vala"
	if (_klass_->get_panel_plugins) {
#line 34 "../src/lib/manager.vala"
		return _klass_->get_panel_plugins (self);
#line 430 "manager.c"
	}
#line 34 "../src/lib/manager.vala"
	return NULL;
#line 434 "manager.c"
}

static GList*
budgie_desktop_manager_real_get_raven_plugins (BudgieDesktopManager* self)
{
#line 35 "../src/lib/manager.vala"
	g_critical ("Type `%s' does not implement abstract method `budgie_desktop_manager_get_raven_plugins'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 35 "../src/lib/manager.vala"
	return NULL;
#line 444 "manager.c"
}

GList*
budgie_desktop_manager_get_raven_plugins (BudgieDesktopManager* self)
{
	BudgieDesktopManagerClass* _klass_;
#line 35 "../src/lib/manager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 35 "../src/lib/manager.vala"
	_klass_ = BUDGIE_DESKTOP_MANAGER_GET_CLASS (self);
#line 35 "../src/lib/manager.vala"
	if (_klass_->get_raven_plugins) {
#line 35 "../src/lib/manager.vala"
		return _klass_->get_raven_plugins (self);
#line 459 "manager.c"
	}
#line 35 "../src/lib/manager.vala"
	return NULL;
#line 463 "manager.c"
}

static void
budgie_desktop_manager_real_rescan_panel_plugins (BudgieDesktopManager* self)
{
#line 37 "../src/lib/manager.vala"
	g_critical ("Type `%s' does not implement abstract method `budgie_desktop_manager_rescan_panel_plugins'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 37 "../src/lib/manager.vala"
	return;
#line 473 "manager.c"
}

void
budgie_desktop_manager_rescan_panel_plugins (BudgieDesktopManager* self)
{
	BudgieDesktopManagerClass* _klass_;
#line 37 "../src/lib/manager.vala"
	g_return_if_fail (self != NULL);
#line 37 "../src/lib/manager.vala"
	_klass_ = BUDGIE_DESKTOP_MANAGER_GET_CLASS (self);
#line 37 "../src/lib/manager.vala"
	if (_klass_->rescan_panel_plugins) {
#line 37 "../src/lib/manager.vala"
		_klass_->rescan_panel_plugins (self);
#line 488 "manager.c"
	}
}

static void
budgie_desktop_manager_real_rescan_raven_plugins (BudgieDesktopManager* self)
{
#line 38 "../src/lib/manager.vala"
	g_critical ("Type `%s' does not implement abstract method `budgie_desktop_manager_rescan_raven_plugins'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 38 "../src/lib/manager.vala"
	return;
#line 499 "manager.c"
}

void
budgie_desktop_manager_rescan_raven_plugins (BudgieDesktopManager* self)
{
	BudgieDesktopManagerClass* _klass_;
#line 38 "../src/lib/manager.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/lib/manager.vala"
	_klass_ = BUDGIE_DESKTOP_MANAGER_GET_CLASS (self);
#line 38 "../src/lib/manager.vala"
	if (_klass_->rescan_raven_plugins) {
#line 38 "../src/lib/manager.vala"
		_klass_->rescan_raven_plugins (self);
#line 514 "manager.c"
	}
}

BudgieDesktopManager*
budgie_desktop_manager_construct (GType object_type)
{
	BudgieDesktopManager * self = NULL;
#line 13 "../src/lib/manager.vala"
	self = (BudgieDesktopManager*) g_object_new (object_type, NULL);
#line 13 "../src/lib/manager.vala"
	return self;
#line 526 "manager.c"
}

static void
g_cclosure_user_marshal_VOID__STRING_OBJECT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_OBJECT) (gpointer data1, const char* arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 13 "../src/lib/manager.vala"
	g_return_if_fail (n_param_values == 3);
#line 13 "../src/lib/manager.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 13 "../src/lib/manager.vala"
		data1 = closure->data;
#line 13 "../src/lib/manager.vala"
		data2 = param_values->data[0].v_pointer;
#line 551 "manager.c"
	} else {
#line 13 "../src/lib/manager.vala"
		data1 = param_values->data[0].v_pointer;
#line 13 "../src/lib/manager.vala"
		data2 = closure->data;
#line 557 "manager.c"
	}
#line 13 "../src/lib/manager.vala"
	callback = (GMarshalFunc_VOID__STRING_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 13 "../src/lib/manager.vala"
	callback (data1, g_value_get_string (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 563 "manager.c"
}

static void
budgie_desktop_manager_class_init (BudgieDesktopManagerClass * klass,
                                   gpointer klass_data)
{
#line 13 "../src/lib/manager.vala"
	budgie_desktop_manager_parent_class = g_type_class_peek_parent (klass);
#line 13 "../src/lib/manager.vala"
	((BudgieDesktopManagerClass *) klass)->get_panels = (GList* (*) (BudgieDesktopManager*)) budgie_desktop_manager_real_get_panels;
#line 13 "../src/lib/manager.vala"
	((BudgieDesktopManagerClass *) klass)->slots_available = (guint (*) (BudgieDesktopManager*)) budgie_desktop_manager_real_slots_available;
#line 13 "../src/lib/manager.vala"
	((BudgieDesktopManagerClass *) klass)->slots_used = (guint (*) (BudgieDesktopManager*)) budgie_desktop_manager_real_slots_used;
#line 13 "../src/lib/manager.vala"
	((BudgieDesktopManagerClass *) klass)->set_placement = (void (*) (BudgieDesktopManager*, const gchar*, BudgiePanelPosition)) budgie_desktop_manager_real_set_placement;
#line 13 "../src/lib/manager.vala"
	((BudgieDesktopManagerClass *) klass)->set_transparency = (void (*) (BudgieDesktopManager*, const gchar*, BudgiePanelTransparency)) budgie_desktop_manager_real_set_transparency;
#line 13 "../src/lib/manager.vala"
	((BudgieDesktopManagerClass *) klass)->set_autohide = (void (*) (BudgieDesktopManager*, const gchar*, BudgieAutohidePolicy)) budgie_desktop_manager_real_set_autohide;
#line 13 "../src/lib/manager.vala"
	((BudgieDesktopManagerClass *) klass)->set_dock_mode = (void (*) (BudgieDesktopManager*, const gchar*, gboolean)) budgie_desktop_manager_real_set_dock_mode;
#line 13 "../src/lib/manager.vala"
	((BudgieDesktopManagerClass *) klass)->set_size = (void (*) (BudgieDesktopManager*, const gchar*, gint)) budgie_desktop_manager_real_set_size;
#line 13 "../src/lib/manager.vala"
	((BudgieDesktopManagerClass *) klass)->set_spacing = (void (*) (BudgieDesktopManager*, const gchar*, gint)) budgie_desktop_manager_real_set_spacing;
#line 13 "../src/lib/manager.vala"
	((BudgieDesktopManagerClass *) klass)->create_new_panel = (void (*) (BudgieDesktopManager*)) budgie_desktop_manager_real_create_new_panel;
#line 13 "../src/lib/manager.vala"
	((BudgieDesktopManagerClass *) klass)->delete_panel = (void (*) (BudgieDesktopManager*, const gchar*)) budgie_desktop_manager_real_delete_panel;
#line 13 "../src/lib/manager.vala"
	((BudgieDesktopManagerClass *) klass)->get_panel_plugins = (GList* (*) (BudgieDesktopManager*)) budgie_desktop_manager_real_get_panel_plugins;
#line 13 "../src/lib/manager.vala"
	((BudgieDesktopManagerClass *) klass)->get_raven_plugins = (GList* (*) (BudgieDesktopManager*)) budgie_desktop_manager_real_get_raven_plugins;
#line 13 "../src/lib/manager.vala"
	((BudgieDesktopManagerClass *) klass)->rescan_panel_plugins = (void (*) (BudgieDesktopManager*)) budgie_desktop_manager_real_rescan_panel_plugins;
#line 13 "../src/lib/manager.vala"
	((BudgieDesktopManagerClass *) klass)->rescan_raven_plugins = (void (*) (BudgieDesktopManager*)) budgie_desktop_manager_real_rescan_raven_plugins;
#line 13 "../src/lib/manager.vala"
	budgie_desktop_manager_signals[BUDGIE_DESKTOP_MANAGER_PANELS_CHANGED_SIGNAL] = g_signal_new ("panels-changed", BUDGIE_TYPE_DESKTOP_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 13 "../src/lib/manager.vala"
	budgie_desktop_manager_signals[BUDGIE_DESKTOP_MANAGER_PANEL_DELETED_SIGNAL] = g_signal_new ("panel-deleted", BUDGIE_TYPE_DESKTOP_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 13 "../src/lib/manager.vala"
	budgie_desktop_manager_signals[BUDGIE_DESKTOP_MANAGER_PANEL_ADDED_SIGNAL] = g_signal_new ("panel-added", BUDGIE_TYPE_DESKTOP_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_OBJECT, G_TYPE_NONE, 2, G_TYPE_STRING, BUDGIE_TYPE_TOPLEVEL);
#line 608 "manager.c"
}

static void
budgie_desktop_manager_instance_init (BudgieDesktopManager * self,
                                      gpointer klass)
{
}

static GType
budgie_desktop_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BudgieDesktopManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) budgie_desktop_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BudgieDesktopManager), 0, (GInstanceInitFunc) budgie_desktop_manager_instance_init, NULL };
	GType budgie_desktop_manager_type_id;
	budgie_desktop_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "BudgieDesktopManager", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	return budgie_desktop_manager_type_id;
}

GType
budgie_desktop_manager_get_type (void)
{
	static volatile gsize budgie_desktop_manager_type_id__once = 0;
	if (g_once_init_enter (&budgie_desktop_manager_type_id__once)) {
		GType budgie_desktop_manager_type_id;
		budgie_desktop_manager_type_id = budgie_desktop_manager_get_type_once ();
		g_once_init_leave (&budgie_desktop_manager_type_id__once, budgie_desktop_manager_type_id);
	}
	return budgie_desktop_manager_type_id__once;
}

