/* notification.c generated by valac 0.56.17, the Vala compiler
 * generated from notification.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright Budgie Desktop Developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#include "budgie-private.h"
#include <gio/gdesktopappinfo.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <gdk-pixbuf/gdk-pixbuf.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	BUDGIE_NOTIFICATION_0_PROPERTY,
	BUDGIE_NOTIFICATION_APP_INFO_PROPERTY,
	BUDGIE_NOTIFICATION_APP_ID_PROPERTY,
	BUDGIE_NOTIFICATION_URGENCY_PROPERTY,
	BUDGIE_NOTIFICATION_ID_PROPERTY,
	BUDGIE_NOTIFICATION_APP_NAME_PROPERTY,
	BUDGIE_NOTIFICATION_NOTIFICATION_ICON_PROPERTY,
	BUDGIE_NOTIFICATION_HINTS_PROPERTY,
	BUDGIE_NOTIFICATION_ACTIONS_PROPERTY,
	BUDGIE_NOTIFICATION_BODY_PROPERTY,
	BUDGIE_NOTIFICATION_SUMMARY_PROPERTY,
	BUDGIE_NOTIFICATION_EXPIRE_TIMEOUT_PROPERTY,
	BUDGIE_NOTIFICATION_CATEGORY_PROPERTY,
	BUDGIE_NOTIFICATION_TIMESTAMP_PROPERTY,
	BUDGIE_NOTIFICATION_APP_IMAGE_PROPERTY,
	BUDGIE_NOTIFICATION_IMAGE_PROPERTY,
	BUDGIE_NOTIFICATION_NUM_PROPERTIES
};
static GParamSpec* budgie_notification_properties[BUDGIE_NOTIFICATION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_time_zone_unref0(var) ((var == NULL) ? NULL : (var = (g_time_zone_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _BudgieNotificationPrivate {
	GDesktopAppInfo* _app_info;
	gchar* _app_id;
	GNotificationPriority _urgency;
	guint32 _id;
	gchar* _app_name;
	gchar* _notification_icon;
	GHashTable* _hints;
	gchar** _actions;
	gint _actions_length1;
	gint __actions_size_;
	gchar* _body;
	gchar* _summary;
	guint _expire_timeout;
	gchar* _category;
	gint64 _timestamp;
	GtkImage* _app_image;
	GtkImage* _image;
};

static gint BudgieNotification_private_offset;
static gpointer budgie_notification_parent_class = NULL;
static GRegex* budgie_notification_entity_regex;
static GRegex* budgie_notification_entity_regex = NULL;
static GRegex* budgie_notification_tag_regex;
static GRegex* budgie_notification_tag_regex = NULL;

static GdkPixbuf* budgie_notification_decode_image (BudgieNotification* self,
                                             GVariant* img);
static gchar* budgie_notification_fix_markup (BudgieNotification* self,
                                       const gchar* markup);
static GtkImage* budgie_notification_get_appinfo_image (BudgieNotification* self,
                                                 GtkIconSize size,
                                                 const gchar* fallback);
static void budgie_notification_set_app_info (BudgieNotification* self,
                                       GDesktopAppInfo* value);
static void budgie_notification_set_app_id (BudgieNotification* self,
                                     const gchar* value);
static void budgie_notification_set_urgency (BudgieNotification* self,
                                      GNotificationPriority value);
static gchar** _vala_array_dup1 (gchar** self,
                          gssize length);
static GObject * budgie_notification_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties);
static void budgie_notification_finalize (GObject * obj);
static GType budgie_notification_get_type_once (void);
static void _vala_budgie_notification_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_budgie_notification_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

/**
 * Enumeration of why a notification was closed.
 */
static GType
budgie_notification_close_reason_get_type_once (void)
{
	static const GEnumValue values[] = {{BUDGIE_NOTIFICATION_CLOSE_REASON_EXPIRED, "BUDGIE_NOTIFICATION_CLOSE_REASON_EXPIRED", "expired"}, {BUDGIE_NOTIFICATION_CLOSE_REASON_DISMISSED, "BUDGIE_NOTIFICATION_CLOSE_REASON_DISMISSED", "dismissed"}, {BUDGIE_NOTIFICATION_CLOSE_REASON_CLOSED, "BUDGIE_NOTIFICATION_CLOSE_REASON_CLOSED", "closed"}, {BUDGIE_NOTIFICATION_CLOSE_REASON_UNDEFINED, "BUDGIE_NOTIFICATION_CLOSE_REASON_UNDEFINED", "undefined"}, {0, NULL, NULL}};
	GType budgie_notification_close_reason_type_id;
	budgie_notification_close_reason_type_id = g_enum_register_static ("BudgieNotificationCloseReason", values);
	return budgie_notification_close_reason_type_id;
}

GType
budgie_notification_close_reason_get_type (void)
{
	static volatile gsize budgie_notification_close_reason_type_id__once = 0;
	if (g_once_init_enter (&budgie_notification_close_reason_type_id__once)) {
		GType budgie_notification_close_reason_type_id;
		budgie_notification_close_reason_type_id = budgie_notification_close_reason_get_type_once ();
		g_once_init_leave (&budgie_notification_close_reason_type_id__once, budgie_notification_close_reason_type_id);
	}
	return budgie_notification_close_reason_type_id__once;
}

/**
 * Enumeration of where notification popups will be shown.
 */
static GType
budgie_notification_position_get_type_once (void)
{
	static const GEnumValue values[] = {{BUDGIE_NOTIFICATION_POSITION_TOP_LEFT, "BUDGIE_NOTIFICATION_POSITION_TOP_LEFT", "top-left"}, {BUDGIE_NOTIFICATION_POSITION_TOP_RIGHT, "BUDGIE_NOTIFICATION_POSITION_TOP_RIGHT", "top-right"}, {BUDGIE_NOTIFICATION_POSITION_BOTTOM_LEFT, "BUDGIE_NOTIFICATION_POSITION_BOTTOM_LEFT", "bottom-left"}, {BUDGIE_NOTIFICATION_POSITION_BOTTOM_RIGHT, "BUDGIE_NOTIFICATION_POSITION_BOTTOM_RIGHT", "bottom-right"}, {0, NULL, NULL}};
	GType budgie_notification_position_type_id;
	budgie_notification_position_type_id = g_enum_register_static ("BudgieNotificationPosition", values);
	return budgie_notification_position_type_id;
}

GType
budgie_notification_position_get_type (void)
{
	static volatile gsize budgie_notification_position_type_id__once = 0;
	if (g_once_init_enter (&budgie_notification_position_type_id__once)) {
		GType budgie_notification_position_type_id;
		budgie_notification_position_type_id = budgie_notification_position_get_type_once ();
		g_once_init_leave (&budgie_notification_position_type_id__once, budgie_notification_position_type_id);
	}
	return budgie_notification_position_type_id__once;
}

static inline gpointer
budgie_notification_get_instance_private (BudgieNotification* self)
{
	return G_STRUCT_MEMBER_P (self, BudgieNotification_private_offset);
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 197 "notification.c"
}

BudgieNotification*
budgie_notification_construct (GType object_type,
                               guint32 id,
                               const gchar* app_name,
                               const gchar* notification_icon,
                               const gchar* summary,
                               const gchar* body,
                               gchar** actions,
                               gint actions_length1,
                               GHashTable* hints,
                               guint expire_timeout)
{
	BudgieNotification * self = NULL;
	gchar* name = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	const gchar* _tmp4_;
#line 67 "../src/lib/notification.vala"
	g_return_val_if_fail (app_name != NULL, NULL);
#line 67 "../src/lib/notification.vala"
	g_return_val_if_fail (notification_icon != NULL, NULL);
#line 67 "../src/lib/notification.vala"
	g_return_val_if_fail (summary != NULL, NULL);
#line 67 "../src/lib/notification.vala"
	g_return_val_if_fail (body != NULL, NULL);
#line 67 "../src/lib/notification.vala"
	g_return_val_if_fail (hints != NULL, NULL);
#line 77 "../src/lib/notification.vala"
	_tmp0_ = g_strdup (app_name);
#line 77 "../src/lib/notification.vala"
	name = _tmp0_;
#line 79 "../src/lib/notification.vala"
	_tmp2_ = name;
#line 79 "../src/lib/notification.vala"
	if (string_contains (_tmp2_, "budgie")) {
#line 79 "../src/lib/notification.vala"
		_tmp1_ = string_contains (notification_icon, "caffeine");
#line 238 "notification.c"
	} else {
#line 79 "../src/lib/notification.vala"
		_tmp1_ = FALSE;
#line 242 "notification.c"
	}
#line 79 "../src/lib/notification.vala"
	if (_tmp1_) {
#line 246 "notification.c"
		gchar* _tmp3_;
#line 80 "../src/lib/notification.vala"
		_tmp3_ = g_strdup (_ ("Caffeine Mode"));
#line 80 "../src/lib/notification.vala"
		_g_free0 (name);
#line 80 "../src/lib/notification.vala"
		name = _tmp3_;
#line 254 "notification.c"
	}
#line 83 "../src/lib/notification.vala"
	_tmp4_ = name;
#line 83 "../src/lib/notification.vala"
	self = (BudgieNotification*) g_object_new (object_type, "id", id, "app-name", _tmp4_, "notification-icon", notification_icon, "summary", summary, "body", body, "actions", actions, "hints", hints, "expire-timeout", expire_timeout, NULL);
#line 67 "../src/lib/notification.vala"
	_g_free0 (name);
#line 67 "../src/lib/notification.vala"
	return self;
#line 264 "notification.c"
}

BudgieNotification*
budgie_notification_new (guint32 id,
                         const gchar* app_name,
                         const gchar* notification_icon,
                         const gchar* summary,
                         const gchar* body,
                         gchar** actions,
                         gint actions_length1,
                         GHashTable* hints,
                         guint expire_timeout)
{
#line 67 "../src/lib/notification.vala"
	return budgie_notification_construct (BUDGIE_TYPE_NOTIFICATION, id, app_name, notification_icon, summary, body, actions, actions_length1, hints, expire_timeout);
#line 280 "notification.c"
}

static GdkPixbuf*
budgie_notification_decode_image (BudgieNotification* self,
                                  GVariant* img)
{
	gint width = 0;
	GVariant* _tmp0_;
	GVariant* _tmp1_;
	gint _tmp2_;
	gint height = 0;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
	gint _tmp5_;
	gint rowstride = 0;
	GVariant* _tmp6_;
	GVariant* _tmp7_;
	gint _tmp8_;
	gboolean has_alpha = FALSE;
	GVariant* _tmp9_;
	GVariant* _tmp10_;
	gboolean _tmp11_;
	gint bits_per_sample = 0;
	GVariant* _tmp12_;
	GVariant* _tmp13_;
	gint _tmp14_;
	guint8* raw = NULL;
	GVariant* _tmp15_;
	GVariant* _tmp16_;
	void* _tmp17_;
	guint8* _tmp18_;
	gint _tmp18__length1;
	gint raw_length1;
	gint _raw_size_;
	GdkPixbuf* pixbuf = NULL;
	guint8* _tmp19_;
	gint _tmp19__length1;
	GdkPixbuf* _tmp20_;
	GdkPixbuf* _tmp23_;
	GdkPixbuf* _tmp24_;
	GdkPixbuf* result;
#line 222 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 222 "../src/lib/notification.vala"
	g_return_val_if_fail (img != NULL, NULL);
#line 224 "../src/lib/notification.vala"
	_tmp0_ = g_variant_get_child_value (img, (gsize) 0);
#line 224 "../src/lib/notification.vala"
	_tmp1_ = _tmp0_;
#line 224 "../src/lib/notification.vala"
	_tmp2_ = (gint) g_variant_get_int32 (_tmp1_);
#line 224 "../src/lib/notification.vala"
	_g_variant_unref0 (_tmp1_);
#line 224 "../src/lib/notification.vala"
	width = _tmp2_;
#line 225 "../src/lib/notification.vala"
	_tmp3_ = g_variant_get_child_value (img, (gsize) 1);
#line 225 "../src/lib/notification.vala"
	_tmp4_ = _tmp3_;
#line 225 "../src/lib/notification.vala"
	_tmp5_ = (gint) g_variant_get_int32 (_tmp4_);
#line 225 "../src/lib/notification.vala"
	_g_variant_unref0 (_tmp4_);
#line 225 "../src/lib/notification.vala"
	height = _tmp5_;
#line 226 "../src/lib/notification.vala"
	_tmp6_ = g_variant_get_child_value (img, (gsize) 2);
#line 226 "../src/lib/notification.vala"
	_tmp7_ = _tmp6_;
#line 226 "../src/lib/notification.vala"
	_tmp8_ = (gint) g_variant_get_int32 (_tmp7_);
#line 226 "../src/lib/notification.vala"
	_g_variant_unref0 (_tmp7_);
#line 226 "../src/lib/notification.vala"
	rowstride = _tmp8_;
#line 227 "../src/lib/notification.vala"
	_tmp9_ = g_variant_get_child_value (img, (gsize) 3);
#line 227 "../src/lib/notification.vala"
	_tmp10_ = _tmp9_;
#line 227 "../src/lib/notification.vala"
	_tmp11_ = g_variant_get_boolean (_tmp10_);
#line 227 "../src/lib/notification.vala"
	_g_variant_unref0 (_tmp10_);
#line 227 "../src/lib/notification.vala"
	has_alpha = _tmp11_;
#line 228 "../src/lib/notification.vala"
	_tmp12_ = g_variant_get_child_value (img, (gsize) 4);
#line 228 "../src/lib/notification.vala"
	_tmp13_ = _tmp12_;
#line 228 "../src/lib/notification.vala"
	_tmp14_ = (gint) g_variant_get_int32 (_tmp13_);
#line 228 "../src/lib/notification.vala"
	_g_variant_unref0 (_tmp13_);
#line 228 "../src/lib/notification.vala"
	bits_per_sample = _tmp14_;
#line 230 "../src/lib/notification.vala"
	_tmp15_ = g_variant_get_child_value (img, (gsize) 6);
#line 230 "../src/lib/notification.vala"
	_tmp16_ = _tmp15_;
#line 230 "../src/lib/notification.vala"
	_tmp17_ = g_variant_get_data (_tmp16_);
#line 230 "../src/lib/notification.vala"
	_tmp18_ = (guint8*) _tmp17_;
#line 230 "../src/lib/notification.vala"
	_tmp18__length1 = -1;
#line 230 "../src/lib/notification.vala"
	_g_variant_unref0 (_tmp16_);
#line 230 "../src/lib/notification.vala"
	raw = _tmp18_;
#line 230 "../src/lib/notification.vala"
	raw_length1 = _tmp18__length1;
#line 230 "../src/lib/notification.vala"
	_raw_size_ = raw_length1;
#line 233 "../src/lib/notification.vala"
	_tmp19_ = raw;
#line 233 "../src/lib/notification.vala"
	_tmp19__length1 = raw_length1;
#line 233 "../src/lib/notification.vala"
	_tmp20_ = gdk_pixbuf_new_from_data (_tmp19_, GDK_COLORSPACE_RGB, has_alpha, bits_per_sample, width, height, rowstride, (GdkPixbufDestroyNotify) NULL, NULL);
#line 233 "../src/lib/notification.vala"
	pixbuf = _tmp20_;
#line 244 "../src/lib/notification.vala"
	if (height != 48) {
#line 404 "notification.c"
		GdkPixbuf* _tmp21_;
		GdkPixbuf* _tmp22_;
#line 245 "../src/lib/notification.vala"
		_tmp21_ = pixbuf;
#line 245 "../src/lib/notification.vala"
		_tmp22_ = gdk_pixbuf_scale_simple (_tmp21_, 48, 48, GDK_INTERP_BILINEAR);
#line 245 "../src/lib/notification.vala"
		_g_object_unref0 (pixbuf);
#line 245 "../src/lib/notification.vala"
		pixbuf = _tmp22_;
#line 415 "notification.c"
	}
#line 248 "../src/lib/notification.vala"
	_tmp23_ = pixbuf;
#line 248 "../src/lib/notification.vala"
	_tmp24_ = gdk_pixbuf_copy (_tmp23_);
#line 248 "../src/lib/notification.vala"
	result = _tmp24_;
#line 248 "../src/lib/notification.vala"
	_g_object_unref0 (pixbuf);
#line 248 "../src/lib/notification.vala"
	return result;
#line 427 "notification.c"
}

/**
 * Taken from gnome-shell. Notification markup is always a mess, and this is cleaner
 * than our previous solution.
 */
static gchar*
budgie_notification_fix_markup (BudgieNotification* self,
                                const gchar* markup)
{
	gchar* text = NULL;
	gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 255 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 255 "../src/lib/notification.vala"
	g_return_val_if_fail (markup != NULL, NULL);
#line 256 "../src/lib/notification.vala"
	_tmp0_ = g_strdup (markup);
#line 256 "../src/lib/notification.vala"
	text = _tmp0_;
#line 450 "notification.c"
	{
		gchar* _tmp1_ = NULL;
		GRegex* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 259 "../src/lib/notification.vala"
		_tmp2_ = budgie_notification_entity_regex;
#line 259 "../src/lib/notification.vala"
		_tmp3_ = strlen (markup);
#line 259 "../src/lib/notification.vala"
		_tmp4_ = _tmp3_;
#line 259 "../src/lib/notification.vala"
		_tmp5_ = g_regex_replace (_tmp2_, markup, (gssize) _tmp4_, 0, "&amp;", 0, &_inner_error0_);
#line 259 "../src/lib/notification.vala"
		_tmp1_ = _tmp5_;
#line 259 "../src/lib/notification.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 478 "notification.c"
			goto __catch0_g_error;
		}
#line 259 "../src/lib/notification.vala"
		_tmp6_ = _tmp1_;
#line 259 "../src/lib/notification.vala"
		_tmp1_ = NULL;
#line 259 "../src/lib/notification.vala"
		_g_free0 (text);
#line 259 "../src/lib/notification.vala"
		text = _tmp6_;
#line 260 "../src/lib/notification.vala"
		_tmp8_ = budgie_notification_tag_regex;
#line 260 "../src/lib/notification.vala"
		_tmp9_ = text;
#line 260 "../src/lib/notification.vala"
		_tmp10_ = text;
#line 260 "../src/lib/notification.vala"
		_tmp11_ = strlen (_tmp10_);
#line 260 "../src/lib/notification.vala"
		_tmp12_ = _tmp11_;
#line 260 "../src/lib/notification.vala"
		_tmp13_ = g_regex_replace (_tmp8_, _tmp9_, (gssize) _tmp12_, 0, "&lt;", 0, &_inner_error0_);
#line 260 "../src/lib/notification.vala"
		_tmp7_ = _tmp13_;
#line 260 "../src/lib/notification.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 260 "../src/lib/notification.vala"
			_g_free0 (_tmp1_);
#line 507 "notification.c"
			goto __catch0_g_error;
		}
#line 260 "../src/lib/notification.vala"
		_tmp14_ = _tmp7_;
#line 260 "../src/lib/notification.vala"
		_tmp7_ = NULL;
#line 260 "../src/lib/notification.vala"
		_g_free0 (text);
#line 260 "../src/lib/notification.vala"
		text = _tmp14_;
#line 258 "../src/lib/notification.vala"
		_g_free0 (_tmp7_);
#line 258 "../src/lib/notification.vala"
		_g_free0 (_tmp1_);
#line 522 "notification.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp15_;
		const gchar* _tmp16_;
#line 258 "../src/lib/notification.vala"
		e = _inner_error0_;
#line 258 "../src/lib/notification.vala"
		_inner_error0_ = NULL;
#line 262 "../src/lib/notification.vala"
		_tmp15_ = e;
#line 262 "../src/lib/notification.vala"
		_tmp16_ = _tmp15_->message;
#line 262 "../src/lib/notification.vala"
		g_warning ("notification.vala:262: Invalid regex: %s", _tmp16_);
#line 258 "../src/lib/notification.vala"
		_g_error_free0 (e);
#line 542 "notification.c"
	}
	__finally0:
#line 258 "../src/lib/notification.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 258 "../src/lib/notification.vala"
		_g_free0 (text);
#line 258 "../src/lib/notification.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 258 "../src/lib/notification.vala"
		g_clear_error (&_inner_error0_);
#line 258 "../src/lib/notification.vala"
		return NULL;
#line 555 "notification.c"
	}
#line 265 "../src/lib/notification.vala"
	result = text;
#line 265 "../src/lib/notification.vala"
	return result;
#line 561 "notification.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 270 "../src/lib/notification.vala"
	return self ? g_object_ref (self) : NULL;
#line 569 "notification.c"
}

static GtkImage*
budgie_notification_get_appinfo_image (BudgieNotification* self,
                                       GtkIconSize size,
                                       const gchar* fallback)
{
	GDesktopAppInfo* _tmp0_;
	gchar* app_icon_name = NULL;
	GDesktopAppInfo* _tmp5_;
	gchar* _tmp6_;
	GIcon* app_icon = NULL;
	GDesktopAppInfo* _tmp7_;
	GIcon* _tmp8_;
	GIcon* _tmp9_;
	const gchar* _tmp10_;
	GtkImage* result;
#line 268 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 269 "../src/lib/notification.vala"
	_tmp0_ = self->priv->_app_info;
#line 269 "../src/lib/notification.vala"
	if (_tmp0_ == NULL) {
#line 593 "notification.c"
		GtkIconTheme* theme = NULL;
		GtkIconTheme* _tmp1_;
		GtkIconTheme* _tmp2_;
		GtkIconTheme* _tmp3_;
		GtkImage* _tmp4_;
#line 270 "../src/lib/notification.vala"
		_tmp1_ = gtk_icon_theme_get_default ();
#line 270 "../src/lib/notification.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 270 "../src/lib/notification.vala"
		theme = _tmp2_;
#line 272 "../src/lib/notification.vala"
		_tmp3_ = theme;
#line 272 "../src/lib/notification.vala"
		if (!gtk_icon_theme_has_icon (_tmp3_, fallback)) {
#line 273 "../src/lib/notification.vala"
			result = NULL;
#line 273 "../src/lib/notification.vala"
			_g_object_unref0 (theme);
#line 273 "../src/lib/notification.vala"
			return result;
#line 615 "notification.c"
		}
#line 276 "../src/lib/notification.vala"
		_tmp4_ = (GtkImage*) gtk_image_new_from_icon_name (fallback, (GtkIconSize) size);
#line 276 "../src/lib/notification.vala"
		g_object_ref_sink (_tmp4_);
#line 276 "../src/lib/notification.vala"
		result = _tmp4_;
#line 276 "../src/lib/notification.vala"
		_g_object_unref0 (theme);
#line 276 "../src/lib/notification.vala"
		return result;
#line 627 "notification.c"
	}
#line 279 "../src/lib/notification.vala"
	_tmp5_ = self->priv->_app_info;
#line 279 "../src/lib/notification.vala"
	_tmp6_ = g_desktop_app_info_get_string (_tmp5_, "Icon");
#line 279 "../src/lib/notification.vala"
	app_icon_name = _tmp6_;
#line 280 "../src/lib/notification.vala"
	_tmp7_ = self->priv->_app_info;
#line 280 "../src/lib/notification.vala"
	_tmp8_ = g_app_info_get_icon ((GAppInfo*) _tmp7_);
#line 280 "../src/lib/notification.vala"
	_tmp9_ = _g_object_ref0 (_tmp8_);
#line 280 "../src/lib/notification.vala"
	app_icon = _tmp9_;
#line 282 "../src/lib/notification.vala"
	_tmp10_ = app_icon_name;
#line 282 "../src/lib/notification.vala"
	if (_tmp10_ != NULL) {
#line 647 "notification.c"
		const gchar* _tmp11_;
		GtkImage* _tmp12_;
#line 283 "../src/lib/notification.vala"
		_tmp11_ = app_icon_name;
#line 283 "../src/lib/notification.vala"
		_tmp12_ = (GtkImage*) gtk_image_new_from_icon_name (_tmp11_, (GtkIconSize) size);
#line 283 "../src/lib/notification.vala"
		g_object_ref_sink (_tmp12_);
#line 283 "../src/lib/notification.vala"
		result = _tmp12_;
#line 283 "../src/lib/notification.vala"
		_g_object_unref0 (app_icon);
#line 283 "../src/lib/notification.vala"
		_g_free0 (app_icon_name);
#line 283 "../src/lib/notification.vala"
		return result;
#line 664 "notification.c"
	} else {
		gboolean _tmp13_ = FALSE;
		const gchar* _tmp14_;
#line 284 "../src/lib/notification.vala"
		_tmp14_ = app_icon_name;
#line 284 "../src/lib/notification.vala"
		if (_tmp14_ == NULL) {
#line 672 "notification.c"
			GIcon* _tmp15_;
#line 284 "../src/lib/notification.vala"
			_tmp15_ = app_icon;
#line 284 "../src/lib/notification.vala"
			_tmp13_ = _tmp15_ != NULL;
#line 678 "notification.c"
		} else {
#line 284 "../src/lib/notification.vala"
			_tmp13_ = FALSE;
#line 682 "notification.c"
		}
#line 284 "../src/lib/notification.vala"
		if (_tmp13_) {
#line 686 "notification.c"
			GIcon* _tmp16_;
			GtkImage* _tmp17_;
#line 285 "../src/lib/notification.vala"
			_tmp16_ = app_icon;
#line 285 "../src/lib/notification.vala"
			_tmp17_ = (GtkImage*) gtk_image_new_from_gicon (_tmp16_, (GtkIconSize) size);
#line 285 "../src/lib/notification.vala"
			g_object_ref_sink (_tmp17_);
#line 285 "../src/lib/notification.vala"
			result = _tmp17_;
#line 285 "../src/lib/notification.vala"
			_g_object_unref0 (app_icon);
#line 285 "../src/lib/notification.vala"
			_g_free0 (app_icon_name);
#line 285 "../src/lib/notification.vala"
			return result;
#line 703 "notification.c"
		}
	}
#line 288 "../src/lib/notification.vala"
	result = NULL;
#line 288 "../src/lib/notification.vala"
	_g_object_unref0 (app_icon);
#line 288 "../src/lib/notification.vala"
	_g_free0 (app_icon_name);
#line 288 "../src/lib/notification.vala"
	return result;
#line 714 "notification.c"
}

GDesktopAppInfo*
budgie_notification_get_app_info (BudgieNotification* self)
{
	GDesktopAppInfo* result;
	GDesktopAppInfo* _tmp0_;
#line 42 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 42 "../src/lib/notification.vala"
	_tmp0_ = self->priv->_app_info;
#line 42 "../src/lib/notification.vala"
	result = _tmp0_;
#line 42 "../src/lib/notification.vala"
	return result;
#line 730 "notification.c"
}

static void
budgie_notification_set_app_info (BudgieNotification* self,
                                  GDesktopAppInfo* value)
{
	GDesktopAppInfo* old_value;
#line 42 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 42 "../src/lib/notification.vala"
	old_value = budgie_notification_get_app_info (self);
#line 42 "../src/lib/notification.vala"
	if (old_value != value) {
#line 744 "notification.c"
		GDesktopAppInfo* _tmp0_;
#line 42 "../src/lib/notification.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 42 "../src/lib/notification.vala"
		_g_object_unref0 (self->priv->_app_info);
#line 42 "../src/lib/notification.vala"
		self->priv->_app_info = _tmp0_;
#line 42 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_APP_INFO_PROPERTY]);
#line 754 "notification.c"
	}
}

const gchar*
budgie_notification_get_app_id (BudgieNotification* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 43 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 43 "../src/lib/notification.vala"
	_tmp0_ = self->priv->_app_id;
#line 43 "../src/lib/notification.vala"
	result = _tmp0_;
#line 43 "../src/lib/notification.vala"
	return result;
#line 771 "notification.c"
}

static void
budgie_notification_set_app_id (BudgieNotification* self,
                                const gchar* value)
{
	gchar* old_value;
#line 43 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 43 "../src/lib/notification.vala"
	old_value = budgie_notification_get_app_id (self);
#line 43 "../src/lib/notification.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 785 "notification.c"
		gchar* _tmp0_;
#line 43 "../src/lib/notification.vala"
		_tmp0_ = g_strdup (value);
#line 43 "../src/lib/notification.vala"
		_g_free0 (self->priv->_app_id);
#line 43 "../src/lib/notification.vala"
		self->priv->_app_id = _tmp0_;
#line 43 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_APP_ID_PROPERTY]);
#line 795 "notification.c"
	}
}

GNotificationPriority
budgie_notification_get_urgency (BudgieNotification* self)
{
	GNotificationPriority result;
#line 44 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 44 "../src/lib/notification.vala"
	result = self->priv->_urgency;
#line 44 "../src/lib/notification.vala"
	return result;
#line 809 "notification.c"
}

static void
budgie_notification_set_urgency (BudgieNotification* self,
                                 GNotificationPriority value)
{
	GNotificationPriority old_value;
#line 44 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 44 "../src/lib/notification.vala"
	old_value = budgie_notification_get_urgency (self);
#line 44 "../src/lib/notification.vala"
	if (old_value != value) {
#line 44 "../src/lib/notification.vala"
		self->priv->_urgency = value;
#line 44 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_URGENCY_PROPERTY]);
#line 827 "notification.c"
	}
}

guint32
budgie_notification_get_id (BudgieNotification* self)
{
	guint32 result;
#line 46 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 46 "../src/lib/notification.vala"
	result = self->priv->_id;
#line 46 "../src/lib/notification.vala"
	return result;
#line 841 "notification.c"
}

static void
budgie_notification_set_id (BudgieNotification* self,
                            guint32 value)
{
	guint32 old_value;
#line 46 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 46 "../src/lib/notification.vala"
	old_value = budgie_notification_get_id (self);
#line 46 "../src/lib/notification.vala"
	if (old_value != value) {
#line 46 "../src/lib/notification.vala"
		self->priv->_id = value;
#line 46 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_ID_PROPERTY]);
#line 859 "notification.c"
	}
}

const gchar*
budgie_notification_get_app_name (BudgieNotification* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 49 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 49 "../src/lib/notification.vala"
	_tmp0_ = self->priv->_app_name;
#line 49 "../src/lib/notification.vala"
	result = _tmp0_;
#line 49 "../src/lib/notification.vala"
	return result;
#line 876 "notification.c"
}

static void
budgie_notification_set_app_name (BudgieNotification* self,
                                  const gchar* value)
{
	gchar* old_value;
#line 49 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 49 "../src/lib/notification.vala"
	old_value = budgie_notification_get_app_name (self);
#line 49 "../src/lib/notification.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 890 "notification.c"
		gchar* _tmp0_;
#line 49 "../src/lib/notification.vala"
		_tmp0_ = g_strdup (value);
#line 49 "../src/lib/notification.vala"
		_g_free0 (self->priv->_app_name);
#line 49 "../src/lib/notification.vala"
		self->priv->_app_name = _tmp0_;
#line 49 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_APP_NAME_PROPERTY]);
#line 900 "notification.c"
	}
}

const gchar*
budgie_notification_get_notification_icon (BudgieNotification* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 50 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 50 "../src/lib/notification.vala"
	_tmp0_ = self->priv->_notification_icon;
#line 50 "../src/lib/notification.vala"
	result = _tmp0_;
#line 50 "../src/lib/notification.vala"
	return result;
#line 917 "notification.c"
}

static void
budgie_notification_set_notification_icon (BudgieNotification* self,
                                           const gchar* value)
{
	gchar* old_value;
#line 50 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 50 "../src/lib/notification.vala"
	old_value = budgie_notification_get_notification_icon (self);
#line 50 "../src/lib/notification.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 931 "notification.c"
		gchar* _tmp0_;
#line 50 "../src/lib/notification.vala"
		_tmp0_ = g_strdup (value);
#line 50 "../src/lib/notification.vala"
		_g_free0 (self->priv->_notification_icon);
#line 50 "../src/lib/notification.vala"
		self->priv->_notification_icon = _tmp0_;
#line 50 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_NOTIFICATION_ICON_PROPERTY]);
#line 941 "notification.c"
	}
}

GHashTable*
budgie_notification_get_hints (BudgieNotification* self)
{
	GHashTable* result;
	GHashTable* _tmp0_;
#line 51 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 51 "../src/lib/notification.vala"
	_tmp0_ = self->priv->_hints;
#line 51 "../src/lib/notification.vala"
	result = _tmp0_;
#line 51 "../src/lib/notification.vala"
	return result;
#line 958 "notification.c"
}

static gpointer
_g_hash_table_ref0 (gpointer self)
{
#line 51 "../src/lib/notification.vala"
	return self ? g_hash_table_ref (self) : NULL;
#line 966 "notification.c"
}

static void
budgie_notification_set_hints (BudgieNotification* self,
                               GHashTable* value)
{
	GHashTable* old_value;
#line 51 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 51 "../src/lib/notification.vala"
	old_value = budgie_notification_get_hints (self);
#line 51 "../src/lib/notification.vala"
	if (old_value != value) {
#line 980 "notification.c"
		GHashTable* _tmp0_;
#line 51 "../src/lib/notification.vala"
		_tmp0_ = _g_hash_table_ref0 (value);
#line 51 "../src/lib/notification.vala"
		_g_hash_table_unref0 (self->priv->_hints);
#line 51 "../src/lib/notification.vala"
		self->priv->_hints = _tmp0_;
#line 51 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_HINTS_PROPERTY]);
#line 990 "notification.c"
	}
}

gchar**
budgie_notification_get_actions (BudgieNotification* self,
                                 gint* result_length1)
{
	gchar** result;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
#line 52 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 52 "../src/lib/notification.vala"
	_tmp0_ = self->priv->_actions;
#line 52 "../src/lib/notification.vala"
	_tmp0__length1 = self->priv->_actions_length1;
#line 52 "../src/lib/notification.vala"
	_tmp1_ = _tmp0_;
#line 52 "../src/lib/notification.vala"
	_tmp1__length1 = _tmp0__length1;
#line 52 "../src/lib/notification.vala"
	if (result_length1) {
#line 52 "../src/lib/notification.vala"
		*result_length1 = _tmp1__length1;
#line 1017 "notification.c"
	}
#line 52 "../src/lib/notification.vala"
	result = _tmp1_;
#line 52 "../src/lib/notification.vala"
	return result;
#line 1023 "notification.c"
}

static gchar**
_vala_array_dup1 (gchar** self,
                  gssize length)
{
#line 52 "../src/lib/notification.vala"
	if (length >= 0) {
#line 1032 "notification.c"
		gchar** result;
		gssize i;
#line 52 "../src/lib/notification.vala"
		result = g_new0 (gchar*, length + 1);
#line 52 "../src/lib/notification.vala"
		for (i = 0; i < length; i++) {
#line 1039 "notification.c"
			gchar* _tmp0_;
#line 52 "../src/lib/notification.vala"
			_tmp0_ = g_strdup (self[i]);
#line 52 "../src/lib/notification.vala"
			result[i] = _tmp0_;
#line 1045 "notification.c"
		}
#line 52 "../src/lib/notification.vala"
		return result;
#line 1049 "notification.c"
	}
#line 52 "../src/lib/notification.vala"
	return NULL;
#line 1053 "notification.c"
}

static void
budgie_notification_set_actions (BudgieNotification* self,
                                 gchar** value,
                                 gint value_length1)
{
	gchar** old_value;
	gint old_value_length;
#line 52 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 52 "../src/lib/notification.vala"
	old_value = budgie_notification_get_actions (self, &old_value_length);
#line 52 "../src/lib/notification.vala"
	if (old_value != value) {
#line 1069 "notification.c"
		gchar** _tmp0_;
		gint _tmp0__length1;
#line 52 "../src/lib/notification.vala"
		_tmp0_ = (value != NULL) ? _vala_array_dup1 (value, value_length1) : value;
#line 52 "../src/lib/notification.vala"
		_tmp0__length1 = value_length1;
#line 52 "../src/lib/notification.vala"
		self->priv->_actions = (_vala_array_free (self->priv->_actions, self->priv->_actions_length1, (GDestroyNotify) g_free), NULL);
#line 52 "../src/lib/notification.vala"
		self->priv->_actions = _tmp0_;
#line 52 "../src/lib/notification.vala"
		self->priv->_actions_length1 = _tmp0__length1;
#line 52 "../src/lib/notification.vala"
		self->priv->__actions_size_ = self->priv->_actions_length1;
#line 52 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_ACTIONS_PROPERTY]);
#line 1086 "notification.c"
	}
}

const gchar*
budgie_notification_get_body (BudgieNotification* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 53 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 53 "../src/lib/notification.vala"
	_tmp0_ = self->priv->_body;
#line 53 "../src/lib/notification.vala"
	result = _tmp0_;
#line 53 "../src/lib/notification.vala"
	return result;
#line 1103 "notification.c"
}

void
budgie_notification_set_body (BudgieNotification* self,
                              const gchar* value)
{
	gchar* old_value;
#line 53 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 53 "../src/lib/notification.vala"
	old_value = budgie_notification_get_body (self);
#line 53 "../src/lib/notification.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1117 "notification.c"
		gchar* _tmp0_;
#line 53 "../src/lib/notification.vala"
		_tmp0_ = g_strdup (value);
#line 53 "../src/lib/notification.vala"
		_g_free0 (self->priv->_body);
#line 53 "../src/lib/notification.vala"
		self->priv->_body = _tmp0_;
#line 53 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_BODY_PROPERTY]);
#line 1127 "notification.c"
	}
}

const gchar*
budgie_notification_get_summary (BudgieNotification* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 54 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 54 "../src/lib/notification.vala"
	_tmp0_ = self->priv->_summary;
#line 54 "../src/lib/notification.vala"
	result = _tmp0_;
#line 54 "../src/lib/notification.vala"
	return result;
#line 1144 "notification.c"
}

void
budgie_notification_set_summary (BudgieNotification* self,
                                 const gchar* value)
{
	gchar* old_value;
#line 54 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 54 "../src/lib/notification.vala"
	old_value = budgie_notification_get_summary (self);
#line 54 "../src/lib/notification.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1158 "notification.c"
		gchar* _tmp0_;
#line 54 "../src/lib/notification.vala"
		_tmp0_ = g_strdup (value);
#line 54 "../src/lib/notification.vala"
		_g_free0 (self->priv->_summary);
#line 54 "../src/lib/notification.vala"
		self->priv->_summary = _tmp0_;
#line 54 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_SUMMARY_PROPERTY]);
#line 1168 "notification.c"
	}
}

guint
budgie_notification_get_expire_timeout (BudgieNotification* self)
{
	guint result;
#line 55 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 55 "../src/lib/notification.vala"
	result = self->priv->_expire_timeout;
#line 55 "../src/lib/notification.vala"
	return result;
#line 1182 "notification.c"
}

void
budgie_notification_set_expire_timeout (BudgieNotification* self,
                                        guint value)
{
	guint old_value;
#line 55 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 55 "../src/lib/notification.vala"
	old_value = budgie_notification_get_expire_timeout (self);
#line 55 "../src/lib/notification.vala"
	if (old_value != value) {
#line 55 "../src/lib/notification.vala"
		self->priv->_expire_timeout = value;
#line 55 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_EXPIRE_TIMEOUT_PROPERTY]);
#line 1200 "notification.c"
	}
}

const gchar*
budgie_notification_get_category (BudgieNotification* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 57 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 57 "../src/lib/notification.vala"
	_tmp0_ = self->priv->_category;
#line 57 "../src/lib/notification.vala"
	result = _tmp0_;
#line 57 "../src/lib/notification.vala"
	return result;
#line 1217 "notification.c"
}

void
budgie_notification_set_category (BudgieNotification* self,
                                  const gchar* value)
{
	gchar* old_value;
#line 57 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 57 "../src/lib/notification.vala"
	old_value = budgie_notification_get_category (self);
#line 57 "../src/lib/notification.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1231 "notification.c"
		gchar* _tmp0_;
#line 57 "../src/lib/notification.vala"
		_tmp0_ = g_strdup (value);
#line 57 "../src/lib/notification.vala"
		_g_free0 (self->priv->_category);
#line 57 "../src/lib/notification.vala"
		self->priv->_category = _tmp0_;
#line 57 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_CATEGORY_PROPERTY]);
#line 1241 "notification.c"
	}
}

gint64
budgie_notification_get_timestamp (BudgieNotification* self)
{
	gint64 result;
#line 58 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 58 "../src/lib/notification.vala"
	result = self->priv->_timestamp;
#line 58 "../src/lib/notification.vala"
	return result;
#line 1255 "notification.c"
}

void
budgie_notification_set_timestamp (BudgieNotification* self,
                                   gint64 value)
{
	gint64 old_value;
#line 58 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 58 "../src/lib/notification.vala"
	old_value = budgie_notification_get_timestamp (self);
#line 58 "../src/lib/notification.vala"
	if (old_value != value) {
#line 58 "../src/lib/notification.vala"
		self->priv->_timestamp = value;
#line 58 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_TIMESTAMP_PROPERTY]);
#line 1273 "notification.c"
	}
}

GtkImage*
budgie_notification_get_app_image (BudgieNotification* self)
{
	GtkImage* result;
	GtkImage* _tmp0_;
#line 61 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 61 "../src/lib/notification.vala"
	_tmp0_ = self->priv->_app_image;
#line 61 "../src/lib/notification.vala"
	result = _tmp0_;
#line 61 "../src/lib/notification.vala"
	return result;
#line 1290 "notification.c"
}

void
budgie_notification_set_app_image (BudgieNotification* self,
                                   GtkImage* value)
{
	GtkImage* old_value;
#line 61 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 61 "../src/lib/notification.vala"
	old_value = budgie_notification_get_app_image (self);
#line 61 "../src/lib/notification.vala"
	if (old_value != value) {
#line 1304 "notification.c"
		GtkImage* _tmp0_;
#line 61 "../src/lib/notification.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 61 "../src/lib/notification.vala"
		_g_object_unref0 (self->priv->_app_image);
#line 61 "../src/lib/notification.vala"
		self->priv->_app_image = _tmp0_;
#line 61 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_APP_IMAGE_PROPERTY]);
#line 1314 "notification.c"
	}
}

GtkImage*
budgie_notification_get_image (BudgieNotification* self)
{
	GtkImage* result;
	GtkImage* _tmp0_;
#line 62 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 62 "../src/lib/notification.vala"
	_tmp0_ = self->priv->_image;
#line 62 "../src/lib/notification.vala"
	result = _tmp0_;
#line 62 "../src/lib/notification.vala"
	return result;
#line 1331 "notification.c"
}

void
budgie_notification_set_image (BudgieNotification* self,
                               GtkImage* value)
{
	GtkImage* old_value;
#line 62 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 62 "../src/lib/notification.vala"
	old_value = budgie_notification_get_image (self);
#line 62 "../src/lib/notification.vala"
	if (old_value != value) {
#line 1345 "notification.c"
		GtkImage* _tmp0_;
#line 62 "../src/lib/notification.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 62 "../src/lib/notification.vala"
		_g_object_unref0 (self->priv->_image);
#line 62 "../src/lib/notification.vala"
		self->priv->_image = _tmp0_;
#line 62 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_IMAGE_PROPERTY]);
#line 1355 "notification.c"
	}
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 1378 "notification.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 1382 "notification.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 1388 "notification.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 1392 "notification.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1396 "notification.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 1404 "notification.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1432 "notification.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 1441 "notification.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1455 "notification.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 1464 "notification.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 1478 "notification.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1487 "notification.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 1496 "notification.c"
}

static GObject *
budgie_notification_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	BudgieNotification * self;
	GVariant* variant = NULL;
	GTimeZone* _tmp0_;
	GTimeZone* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	gboolean _tmp4_ = FALSE;
	GHashTable* _tmp5_;
	gconstpointer _tmp6_;
	GVariant* _tmp7_;
	gboolean _tmp11_ = FALSE;
	GHashTable* _tmp12_;
	gconstpointer _tmp13_;
	GVariant* _tmp14_;
	gboolean _tmp19_ = FALSE;
	GHashTable* _tmp20_;
	gconstpointer _tmp21_;
	GVariant* _tmp22_;
	GDesktopAppInfo* _tmp35_;
	GDesktopAppInfo* _tmp46_;
	const gchar* _tmp52_;
	gchar* _tmp53_;
	gchar* _tmp54_;
	GtkImage* _tmp55_;
	GtkImage* _tmp56_;
	gboolean image_found = FALSE;
	gboolean _tmp57_ = FALSE;
	GHashTable* _tmp58_;
	gconstpointer _tmp59_;
	GVariant* _tmp60_;
	gboolean _tmp70_ = FALSE;
	gboolean _tmp121_ = FALSE;
	const gchar* _tmp133_;
	GError* _inner_error0_ = NULL;
#line 104 "../src/lib/notification.vala"
	parent_class = G_OBJECT_CLASS (budgie_notification_parent_class);
#line 104 "../src/lib/notification.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 104 "../src/lib/notification.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BUDGIE_TYPE_NOTIFICATION, BudgieNotification);
#line 105 "../src/lib/notification.vala"
	variant = NULL;
#line 106 "../src/lib/notification.vala"
	_tmp0_ = g_time_zone_new_local ();
#line 106 "../src/lib/notification.vala"
	_tmp1_ = _tmp0_;
#line 106 "../src/lib/notification.vala"
	_tmp2_ = g_date_time_new_now (_tmp1_);
#line 106 "../src/lib/notification.vala"
	_tmp3_ = _tmp2_;
#line 106 "../src/lib/notification.vala"
	budgie_notification_set_timestamp (self, g_date_time_to_unix (_tmp3_));
#line 106 "../src/lib/notification.vala"
	_g_date_time_unref0 (_tmp3_);
#line 106 "../src/lib/notification.vala"
	_g_time_zone_unref0 (_tmp1_);
#line 109 "../src/lib/notification.vala"
	_tmp5_ = self->priv->_hints;
#line 109 "../src/lib/notification.vala"
	_tmp6_ = g_hash_table_lookup (_tmp5_, "urgency");
#line 109 "../src/lib/notification.vala"
	variant = (GVariant*) _tmp6_;
#line 109 "../src/lib/notification.vala"
	_tmp7_ = variant;
#line 109 "../src/lib/notification.vala"
	if (_tmp7_ != NULL) {
#line 1572 "notification.c"
		GVariant* _tmp8_;
		const GVariantType* _tmp9_;
#line 109 "../src/lib/notification.vala"
		_tmp8_ = variant;
#line 109 "../src/lib/notification.vala"
		_tmp9_ = G_VARIANT_TYPE_BYTE;
#line 109 "../src/lib/notification.vala"
		_tmp4_ = g_variant_is_of_type (_tmp8_, _tmp9_);
#line 1581 "notification.c"
	} else {
#line 109 "../src/lib/notification.vala"
		_tmp4_ = FALSE;
#line 1585 "notification.c"
	}
#line 109 "../src/lib/notification.vala"
	if (_tmp4_) {
#line 1589 "notification.c"
		GVariant* _tmp10_;
#line 110 "../src/lib/notification.vala"
		_tmp10_ = variant;
#line 110 "../src/lib/notification.vala"
		budgie_notification_set_urgency (self, (GNotificationPriority) g_variant_get_byte (_tmp10_));
#line 1595 "notification.c"
	}
#line 114 "../src/lib/notification.vala"
	_tmp12_ = self->priv->_hints;
#line 114 "../src/lib/notification.vala"
	_tmp13_ = g_hash_table_lookup (_tmp12_, "category");
#line 114 "../src/lib/notification.vala"
	variant = (GVariant*) _tmp13_;
#line 114 "../src/lib/notification.vala"
	_tmp14_ = variant;
#line 114 "../src/lib/notification.vala"
	if (_tmp14_ != NULL) {
#line 1607 "notification.c"
		GVariant* _tmp15_;
		const GVariantType* _tmp16_;
#line 114 "../src/lib/notification.vala"
		_tmp15_ = variant;
#line 114 "../src/lib/notification.vala"
		_tmp16_ = G_VARIANT_TYPE_STRING;
#line 114 "../src/lib/notification.vala"
		_tmp11_ = g_variant_is_of_type (_tmp15_, _tmp16_);
#line 1616 "notification.c"
	} else {
#line 114 "../src/lib/notification.vala"
		_tmp11_ = FALSE;
#line 1620 "notification.c"
	}
#line 114 "../src/lib/notification.vala"
	if (_tmp11_) {
#line 1624 "notification.c"
		GVariant* _tmp17_;
		const gchar* _tmp18_;
#line 115 "../src/lib/notification.vala"
		_tmp17_ = variant;
#line 115 "../src/lib/notification.vala"
		_tmp18_ = g_variant_get_string (_tmp17_, NULL);
#line 115 "../src/lib/notification.vala"
		budgie_notification_set_category (self, _tmp18_);
#line 1633 "notification.c"
	}
#line 119 "../src/lib/notification.vala"
	_tmp20_ = self->priv->_hints;
#line 119 "../src/lib/notification.vala"
	_tmp21_ = g_hash_table_lookup (_tmp20_, "desktop-entry");
#line 119 "../src/lib/notification.vala"
	variant = (GVariant*) _tmp21_;
#line 119 "../src/lib/notification.vala"
	_tmp22_ = variant;
#line 119 "../src/lib/notification.vala"
	if (_tmp22_ != NULL) {
#line 1645 "notification.c"
		GVariant* _tmp23_;
		const GVariantType* _tmp24_;
#line 119 "../src/lib/notification.vala"
		_tmp23_ = variant;
#line 119 "../src/lib/notification.vala"
		_tmp24_ = G_VARIANT_TYPE_STRING;
#line 119 "../src/lib/notification.vala"
		_tmp19_ = g_variant_is_of_type (_tmp23_, _tmp24_);
#line 1654 "notification.c"
	} else {
#line 119 "../src/lib/notification.vala"
		_tmp19_ = FALSE;
#line 1658 "notification.c"
	}
#line 119 "../src/lib/notification.vala"
	if (_tmp19_) {
#line 1662 "notification.c"
		GVariant* _tmp25_;
		const gchar* _tmp26_;
		const gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		const gchar* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
		GDesktopAppInfo* _tmp33_;
		GDesktopAppInfo* _tmp34_;
#line 120 "../src/lib/notification.vala"
		_tmp25_ = variant;
#line 120 "../src/lib/notification.vala"
		_tmp26_ = g_variant_get_string (_tmp25_, NULL);
#line 120 "../src/lib/notification.vala"
		budgie_notification_set_app_id (self, _tmp26_);
#line 121 "../src/lib/notification.vala"
		_tmp27_ = self->priv->_app_id;
#line 121 "../src/lib/notification.vala"
		_tmp28_ = string_replace (_tmp27_, ".desktop", "");
#line 121 "../src/lib/notification.vala"
		_tmp29_ = _tmp28_;
#line 121 "../src/lib/notification.vala"
		_g_free0 (_tmp29_);
#line 122 "../src/lib/notification.vala"
		_tmp30_ = self->priv->_app_id;
#line 122 "../src/lib/notification.vala"
		_tmp31_ = g_strdup_printf ("%s.desktop", _tmp30_);
#line 122 "../src/lib/notification.vala"
		_tmp32_ = _tmp31_;
#line 122 "../src/lib/notification.vala"
		_tmp33_ = g_desktop_app_info_new (_tmp32_);
#line 122 "../src/lib/notification.vala"
		_tmp34_ = _tmp33_;
#line 122 "../src/lib/notification.vala"
		budgie_notification_set_app_info (self, _tmp34_);
#line 122 "../src/lib/notification.vala"
		_g_object_unref0 (_tmp34_);
#line 122 "../src/lib/notification.vala"
		_g_free0 (_tmp32_);
#line 1703 "notification.c"
	}
#line 128 "../src/lib/notification.vala"
	_tmp35_ = self->priv->_app_info;
#line 128 "../src/lib/notification.vala"
	if (_tmp35_ == NULL) {
#line 1709 "notification.c"
		const gchar* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		gchar* _tmp40_;
		const gchar* _tmp41_;
		gchar* _tmp42_;
		gchar* _tmp43_;
		GDesktopAppInfo* _tmp44_;
		GDesktopAppInfo* _tmp45_;
#line 129 "../src/lib/notification.vala"
		_tmp36_ = self->priv->_app_name;
#line 129 "../src/lib/notification.vala"
		_tmp37_ = string_replace (_tmp36_, " ", "-");
#line 129 "../src/lib/notification.vala"
		_tmp38_ = _tmp37_;
#line 129 "../src/lib/notification.vala"
		_tmp39_ = g_utf8_strdown (_tmp38_, (gssize) -1);
#line 129 "../src/lib/notification.vala"
		_tmp40_ = _tmp39_;
#line 129 "../src/lib/notification.vala"
		budgie_notification_set_app_id (self, _tmp40_);
#line 129 "../src/lib/notification.vala"
		_g_free0 (_tmp40_);
#line 129 "../src/lib/notification.vala"
		_g_free0 (_tmp38_);
#line 130 "../src/lib/notification.vala"
		_tmp41_ = self->priv->_app_id;
#line 130 "../src/lib/notification.vala"
		_tmp42_ = g_strdup_printf ("%s.desktop", _tmp41_);
#line 130 "../src/lib/notification.vala"
		_tmp43_ = _tmp42_;
#line 130 "../src/lib/notification.vala"
		_tmp44_ = g_desktop_app_info_new (_tmp43_);
#line 130 "../src/lib/notification.vala"
		_tmp45_ = _tmp44_;
#line 130 "../src/lib/notification.vala"
		budgie_notification_set_app_info (self, _tmp45_);
#line 130 "../src/lib/notification.vala"
		_g_object_unref0 (_tmp45_);
#line 130 "../src/lib/notification.vala"
		_g_free0 (_tmp43_);
#line 1752 "notification.c"
	}
#line 134 "../src/lib/notification.vala"
	_tmp46_ = self->priv->_app_info;
#line 134 "../src/lib/notification.vala"
	if (_tmp46_ != NULL) {
#line 1758 "notification.c"
		gchar* _tmp47_ = NULL;
		GDesktopAppInfo* _tmp48_;
		gchar* _tmp49_;
#line 135 "../src/lib/notification.vala"
		_tmp48_ = self->priv->_app_info;
#line 135 "../src/lib/notification.vala"
		_tmp49_ = g_desktop_app_info_get_string (_tmp48_, "Name");
#line 135 "../src/lib/notification.vala"
		_tmp47_ = _tmp49_;
#line 135 "../src/lib/notification.vala"
		if (_tmp47_ == NULL) {
#line 1770 "notification.c"
			const gchar* _tmp50_;
			gchar* _tmp51_;
#line 135 "../src/lib/notification.vala"
			_tmp50_ = self->priv->_app_name;
#line 135 "../src/lib/notification.vala"
			_tmp51_ = g_strdup (_tmp50_);
#line 135 "../src/lib/notification.vala"
			_g_free0 (_tmp47_);
#line 135 "../src/lib/notification.vala"
			_tmp47_ = _tmp51_;
#line 1781 "notification.c"
		}
#line 135 "../src/lib/notification.vala"
		budgie_notification_set_app_name (self, _tmp47_);
#line 134 "../src/lib/notification.vala"
		_g_free0 (_tmp47_);
#line 1787 "notification.c"
	}
#line 139 "../src/lib/notification.vala"
	_tmp52_ = self->priv->_app_id;
#line 139 "../src/lib/notification.vala"
	_tmp53_ = g_utf8_strdown (_tmp52_, (gssize) -1);
#line 139 "../src/lib/notification.vala"
	_tmp54_ = _tmp53_;
#line 139 "../src/lib/notification.vala"
	_tmp55_ = budgie_notification_get_appinfo_image (self, GTK_ICON_SIZE_DND, _tmp54_);
#line 139 "../src/lib/notification.vala"
	_tmp56_ = _tmp55_;
#line 139 "../src/lib/notification.vala"
	budgie_notification_set_app_image (self, _tmp56_);
#line 139 "../src/lib/notification.vala"
	_g_object_unref0 (_tmp56_);
#line 139 "../src/lib/notification.vala"
	_g_free0 (_tmp54_);
#line 141 "../src/lib/notification.vala"
	image_found = FALSE;
#line 145 "../src/lib/notification.vala"
	_tmp58_ = self->priv->_hints;
#line 145 "../src/lib/notification.vala"
	_tmp59_ = g_hash_table_lookup (_tmp58_, "image-data");
#line 145 "../src/lib/notification.vala"
	variant = (GVariant*) _tmp59_;
#line 145 "../src/lib/notification.vala"
	_tmp60_ = variant;
#line 145 "../src/lib/notification.vala"
	if (_tmp60_ != NULL) {
#line 145 "../src/lib/notification.vala"
		_tmp57_ = TRUE;
#line 1819 "notification.c"
	} else {
		GHashTable* _tmp61_;
		gconstpointer _tmp62_;
		GVariant* _tmp63_;
#line 146 "../src/lib/notification.vala"
		_tmp61_ = self->priv->_hints;
#line 146 "../src/lib/notification.vala"
		_tmp62_ = g_hash_table_lookup (_tmp61_, "image_data");
#line 146 "../src/lib/notification.vala"
		variant = (GVariant*) _tmp62_;
#line 146 "../src/lib/notification.vala"
		_tmp63_ = variant;
#line 146 "../src/lib/notification.vala"
		_tmp57_ = _tmp63_ != NULL;
#line 1834 "notification.c"
	}
#line 144 "../src/lib/notification.vala"
	if (_tmp57_) {
#line 1838 "notification.c"
		GdkPixbuf* pixbuf = NULL;
		GVariant* _tmp64_;
		GdkPixbuf* _tmp65_;
		GdkPixbuf* _tmp66_;
#line 148 "../src/lib/notification.vala"
		_tmp64_ = variant;
#line 148 "../src/lib/notification.vala"
		_tmp65_ = budgie_notification_decode_image (self, _tmp64_);
#line 148 "../src/lib/notification.vala"
		pixbuf = _tmp65_;
#line 149 "../src/lib/notification.vala"
		_tmp66_ = pixbuf;
#line 149 "../src/lib/notification.vala"
		if (_tmp66_ != NULL) {
#line 1853 "notification.c"
			GdkPixbuf* _tmp67_;
			GtkImage* _tmp68_;
			GtkImage* _tmp69_;
#line 150 "../src/lib/notification.vala"
			_tmp67_ = pixbuf;
#line 150 "../src/lib/notification.vala"
			_tmp68_ = (GtkImage*) gtk_image_new_from_pixbuf (_tmp67_);
#line 150 "../src/lib/notification.vala"
			g_object_ref_sink (_tmp68_);
#line 150 "../src/lib/notification.vala"
			_tmp69_ = _tmp68_;
#line 150 "../src/lib/notification.vala"
			budgie_notification_set_image (self, _tmp69_);
#line 150 "../src/lib/notification.vala"
			_g_object_unref0 (_tmp69_);
#line 151 "../src/lib/notification.vala"
			image_found = TRUE;
#line 1871 "notification.c"
		}
#line 144 "../src/lib/notification.vala"
		_g_object_unref0 (pixbuf);
#line 1875 "notification.c"
	}
#line 156 "../src/lib/notification.vala"
	if (!image_found) {
#line 1879 "notification.c"
		gboolean _tmp71_ = FALSE;
		GHashTable* _tmp72_;
		gconstpointer _tmp73_;
		GVariant* _tmp74_;
#line 157 "../src/lib/notification.vala"
		_tmp72_ = self->priv->_hints;
#line 157 "../src/lib/notification.vala"
		_tmp73_ = g_hash_table_lookup (_tmp72_, "image-path");
#line 157 "../src/lib/notification.vala"
		variant = (GVariant*) _tmp73_;
#line 157 "../src/lib/notification.vala"
		_tmp74_ = variant;
#line 157 "../src/lib/notification.vala"
		if (_tmp74_ != NULL) {
#line 158 "../src/lib/notification.vala"
			_tmp71_ = TRUE;
#line 1896 "notification.c"
		} else {
			GHashTable* _tmp75_;
			gconstpointer _tmp76_;
			GVariant* _tmp77_;
#line 159 "../src/lib/notification.vala"
			_tmp75_ = self->priv->_hints;
#line 159 "../src/lib/notification.vala"
			_tmp76_ = g_hash_table_lookup (_tmp75_, "image_path");
#line 159 "../src/lib/notification.vala"
			variant = (GVariant*) _tmp76_;
#line 159 "../src/lib/notification.vala"
			_tmp77_ = variant;
#line 159 "../src/lib/notification.vala"
			_tmp71_ = _tmp77_ != NULL;
#line 1911 "notification.c"
		}
#line 157 "../src/lib/notification.vala"
		_tmp70_ = _tmp71_;
#line 1915 "notification.c"
	} else {
#line 156 "../src/lib/notification.vala"
		_tmp70_ = FALSE;
#line 1919 "notification.c"
	}
#line 156 "../src/lib/notification.vala"
	if (_tmp70_) {
#line 1923 "notification.c"
		gchar* path = NULL;
		GVariant* _tmp78_;
		const gchar* _tmp79_;
		gchar* _tmp80_;
		gboolean _tmp81_ = FALSE;
		GtkIconTheme* _tmp82_;
		const gchar* _tmp83_;
#line 162 "../src/lib/notification.vala"
		_tmp78_ = variant;
#line 162 "../src/lib/notification.vala"
		_tmp79_ = g_variant_get_string (_tmp78_, NULL);
#line 162 "../src/lib/notification.vala"
		_tmp80_ = g_strdup (_tmp79_);
#line 162 "../src/lib/notification.vala"
		path = _tmp80_;
#line 164 "../src/lib/notification.vala"
		_tmp82_ = gtk_icon_theme_get_default ();
#line 164 "../src/lib/notification.vala"
		_tmp83_ = path;
#line 164 "../src/lib/notification.vala"
		if (gtk_icon_theme_has_icon (_tmp82_, _tmp83_)) {
#line 1945 "notification.c"
			const gchar* _tmp84_;
			const gchar* _tmp85_;
#line 164 "../src/lib/notification.vala"
			_tmp84_ = path;
#line 164 "../src/lib/notification.vala"
			_tmp85_ = self->priv->_notification_icon;
#line 164 "../src/lib/notification.vala"
			_tmp81_ = g_strcmp0 (_tmp84_, _tmp85_) != 0;
#line 1954 "notification.c"
		} else {
#line 164 "../src/lib/notification.vala"
			_tmp81_ = FALSE;
#line 1958 "notification.c"
		}
#line 164 "../src/lib/notification.vala"
		if (_tmp81_) {
#line 1962 "notification.c"
			GThemedIcon* icon = NULL;
			const gchar* _tmp86_;
			GThemedIcon* _tmp87_;
			GThemedIcon* _tmp88_;
			GtkImage* _tmp89_;
			GtkImage* _tmp90_;
#line 165 "../src/lib/notification.vala"
			_tmp86_ = path;
#line 165 "../src/lib/notification.vala"
			_tmp87_ = (GThemedIcon*) g_themed_icon_new (_tmp86_);
#line 165 "../src/lib/notification.vala"
			icon = _tmp87_;
#line 166 "../src/lib/notification.vala"
			_tmp88_ = icon;
#line 166 "../src/lib/notification.vala"
			_tmp89_ = (GtkImage*) gtk_image_new_from_gicon ((GIcon*) _tmp88_, (GtkIconSize) GTK_ICON_SIZE_DIALOG);
#line 166 "../src/lib/notification.vala"
			g_object_ref_sink (_tmp89_);
#line 166 "../src/lib/notification.vala"
			_tmp90_ = _tmp89_;
#line 166 "../src/lib/notification.vala"
			budgie_notification_set_image (self, _tmp90_);
#line 166 "../src/lib/notification.vala"
			_g_object_unref0 (_tmp90_);
#line 167 "../src/lib/notification.vala"
			image_found = TRUE;
#line 164 "../src/lib/notification.vala"
			_g_object_unref0 (icon);
#line 1991 "notification.c"
		} else {
			gboolean _tmp91_ = FALSE;
			const gchar* _tmp92_;
#line 168 "../src/lib/notification.vala"
			_tmp92_ = path;
#line 168 "../src/lib/notification.vala"
			if (g_str_has_prefix (_tmp92_, "/")) {
#line 168 "../src/lib/notification.vala"
				_tmp91_ = TRUE;
#line 2001 "notification.c"
			} else {
				const gchar* _tmp93_;
#line 168 "../src/lib/notification.vala"
				_tmp93_ = path;
#line 168 "../src/lib/notification.vala"
				_tmp91_ = g_str_has_prefix (_tmp93_, "file://");
#line 2008 "notification.c"
			}
#line 168 "../src/lib/notification.vala"
			if (_tmp91_) {
#line 2012 "notification.c"
				{
					GdkPixbuf* pixbuf = NULL;
					const gchar* _tmp94_;
					GdkPixbuf* _tmp95_;
					GdkPixbuf* _tmp96_;
					GtkImage* _tmp97_;
					GtkImage* _tmp98_;
#line 170 "../src/lib/notification.vala"
					_tmp94_ = path;
#line 170 "../src/lib/notification.vala"
					_tmp95_ = gdk_pixbuf_new_from_file_at_size (_tmp94_, 48, 48, &_inner_error0_);
#line 170 "../src/lib/notification.vala"
					pixbuf = _tmp95_;
#line 170 "../src/lib/notification.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2028 "notification.c"
						goto __catch0_g_error;
					}
#line 171 "../src/lib/notification.vala"
					_tmp96_ = pixbuf;
#line 171 "../src/lib/notification.vala"
					_tmp97_ = (GtkImage*) gtk_image_new_from_pixbuf (_tmp96_);
#line 171 "../src/lib/notification.vala"
					g_object_ref_sink (_tmp97_);
#line 171 "../src/lib/notification.vala"
					_tmp98_ = _tmp97_;
#line 171 "../src/lib/notification.vala"
					budgie_notification_set_image (self, _tmp98_);
#line 171 "../src/lib/notification.vala"
					_g_object_unref0 (_tmp98_);
#line 172 "../src/lib/notification.vala"
					image_found = TRUE;
#line 169 "../src/lib/notification.vala"
					_g_object_unref0 (pixbuf);
#line 2047 "notification.c"
				}
				goto __finally0;
				__catch0_g_error:
				{
					GError* e = NULL;
					GError* _tmp99_;
					const gchar* _tmp100_;
#line 169 "../src/lib/notification.vala"
					e = _inner_error0_;
#line 169 "../src/lib/notification.vala"
					_inner_error0_ = NULL;
#line 174 "../src/lib/notification.vala"
					_tmp99_ = e;
#line 174 "../src/lib/notification.vala"
					_tmp100_ = _tmp99_->message;
#line 174 "../src/lib/notification.vala"
					g_critical ("notification.vala:174: Unable to get pixbuf from path: %s", _tmp100_);
#line 169 "../src/lib/notification.vala"
					_g_error_free0 (e);
#line 2067 "notification.c"
				}
				__finally0:
#line 169 "../src/lib/notification.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 169 "../src/lib/notification.vala"
					_g_free0 (path);
#line 169 "../src/lib/notification.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 169 "../src/lib/notification.vala"
					g_clear_error (&_inner_error0_);
#line 2078 "notification.c"
				}
			}
		}
#line 156 "../src/lib/notification.vala"
		_g_free0 (path);
#line 2084 "notification.c"
	}
#line 180 "../src/lib/notification.vala"
	if (!image_found) {
#line 2088 "notification.c"
		gboolean _tmp101_ = FALSE;
		const gchar* _tmp102_;
#line 181 "../src/lib/notification.vala"
		_tmp102_ = self->priv->_notification_icon;
#line 181 "../src/lib/notification.vala"
		if (g_strcmp0 (_tmp102_, "") != 0) {
#line 2095 "notification.c"
			const gchar* _tmp103_;
#line 181 "../src/lib/notification.vala"
			_tmp103_ = self->priv->_notification_icon;
#line 181 "../src/lib/notification.vala"
			_tmp101_ = !string_contains (_tmp103_, "/");
#line 2101 "notification.c"
		} else {
#line 181 "../src/lib/notification.vala"
			_tmp101_ = FALSE;
#line 2105 "notification.c"
		}
#line 181 "../src/lib/notification.vala"
		if (_tmp101_) {
#line 2109 "notification.c"
			const gchar* _tmp104_;
			GtkImage* _tmp105_;
			GtkImage* _tmp106_;
#line 182 "../src/lib/notification.vala"
			_tmp104_ = self->priv->_notification_icon;
#line 182 "../src/lib/notification.vala"
			_tmp105_ = (GtkImage*) gtk_image_new_from_icon_name (_tmp104_, (GtkIconSize) GTK_ICON_SIZE_DIALOG);
#line 182 "../src/lib/notification.vala"
			g_object_ref_sink (_tmp105_);
#line 182 "../src/lib/notification.vala"
			_tmp106_ = _tmp105_;
#line 182 "../src/lib/notification.vala"
			budgie_notification_set_image (self, _tmp106_);
#line 182 "../src/lib/notification.vala"
			_g_object_unref0 (_tmp106_);
#line 183 "../src/lib/notification.vala"
			image_found = TRUE;
#line 2127 "notification.c"
		} else {
			gboolean _tmp107_ = FALSE;
			const gchar* _tmp108_;
#line 184 "../src/lib/notification.vala"
			_tmp108_ = self->priv->_notification_icon;
#line 184 "../src/lib/notification.vala"
			if (g_strcmp0 (_tmp108_, "") == 0) {
#line 2135 "notification.c"
				GDesktopAppInfo* _tmp109_;
#line 184 "../src/lib/notification.vala"
				_tmp109_ = self->priv->_app_info;
#line 184 "../src/lib/notification.vala"
				_tmp107_ = _tmp109_ != NULL;
#line 2141 "notification.c"
			} else {
#line 184 "../src/lib/notification.vala"
				_tmp107_ = FALSE;
#line 2145 "notification.c"
			}
#line 184 "../src/lib/notification.vala"
			if (_tmp107_) {
#line 2149 "notification.c"
				GtkImage* _tmp110_;
				GtkImage* _tmp111_;
#line 185 "../src/lib/notification.vala"
				_tmp110_ = budgie_notification_get_appinfo_image (self, GTK_ICON_SIZE_DIALOG, "mail-unread-symbolic");
#line 185 "../src/lib/notification.vala"
				_tmp111_ = _tmp110_;
#line 185 "../src/lib/notification.vala"
				budgie_notification_set_image (self, _tmp111_);
#line 185 "../src/lib/notification.vala"
				_g_object_unref0 (_tmp111_);
#line 186 "../src/lib/notification.vala"
				image_found = TRUE;
#line 2162 "notification.c"
			} else {
				const gchar* _tmp112_;
#line 187 "../src/lib/notification.vala"
				_tmp112_ = self->priv->_notification_icon;
#line 187 "../src/lib/notification.vala"
				if (string_contains (_tmp112_, "/")) {
#line 2169 "notification.c"
					GFile* file = NULL;
					const gchar* _tmp113_;
					GFile* _tmp114_;
					GFile* _tmp115_;
#line 188 "../src/lib/notification.vala"
					_tmp113_ = self->priv->_notification_icon;
#line 188 "../src/lib/notification.vala"
					_tmp114_ = g_file_new_for_uri (_tmp113_);
#line 188 "../src/lib/notification.vala"
					file = _tmp114_;
#line 189 "../src/lib/notification.vala"
					_tmp115_ = file;
#line 189 "../src/lib/notification.vala"
					if (g_file_query_exists (_tmp115_, NULL)) {
#line 2184 "notification.c"
						GFileIcon* icon = NULL;
						GFile* _tmp116_;
						GFileIcon* _tmp117_;
						GFileIcon* _tmp118_;
						GtkImage* _tmp119_;
						GtkImage* _tmp120_;
#line 190 "../src/lib/notification.vala"
						_tmp116_ = file;
#line 190 "../src/lib/notification.vala"
						_tmp117_ = (GFileIcon*) g_file_icon_new (_tmp116_);
#line 190 "../src/lib/notification.vala"
						icon = _tmp117_;
#line 191 "../src/lib/notification.vala"
						_tmp118_ = icon;
#line 191 "../src/lib/notification.vala"
						_tmp119_ = (GtkImage*) gtk_image_new_from_gicon ((GIcon*) _tmp118_, (GtkIconSize) GTK_ICON_SIZE_DIALOG);
#line 191 "../src/lib/notification.vala"
						g_object_ref_sink (_tmp119_);
#line 191 "../src/lib/notification.vala"
						_tmp120_ = _tmp119_;
#line 191 "../src/lib/notification.vala"
						budgie_notification_set_image (self, _tmp120_);
#line 191 "../src/lib/notification.vala"
						_g_object_unref0 (_tmp120_);
#line 192 "../src/lib/notification.vala"
						image_found = TRUE;
#line 189 "../src/lib/notification.vala"
						_g_object_unref0 (icon);
#line 2213 "notification.c"
					}
#line 187 "../src/lib/notification.vala"
					_g_object_unref0 (file);
#line 2217 "notification.c"
				}
			}
		}
	}
#line 198 "../src/lib/notification.vala"
	if (!image_found) {
#line 2224 "notification.c"
		GHashTable* _tmp122_;
		gconstpointer _tmp123_;
		GVariant* _tmp124_;
#line 198 "../src/lib/notification.vala"
		_tmp122_ = self->priv->_hints;
#line 198 "../src/lib/notification.vala"
		_tmp123_ = g_hash_table_lookup (_tmp122_, "icon_data");
#line 198 "../src/lib/notification.vala"
		variant = (GVariant*) _tmp123_;
#line 198 "../src/lib/notification.vala"
		_tmp124_ = variant;
#line 198 "../src/lib/notification.vala"
		_tmp121_ = _tmp124_ != NULL;
#line 2238 "notification.c"
	} else {
#line 198 "../src/lib/notification.vala"
		_tmp121_ = FALSE;
#line 2242 "notification.c"
	}
#line 198 "../src/lib/notification.vala"
	if (_tmp121_) {
#line 2246 "notification.c"
		GdkPixbuf* pixbuf = NULL;
		GVariant* _tmp125_;
		GdkPixbuf* _tmp126_;
		GdkPixbuf* _tmp127_;
#line 199 "../src/lib/notification.vala"
		_tmp125_ = variant;
#line 199 "../src/lib/notification.vala"
		_tmp126_ = budgie_notification_decode_image (self, _tmp125_);
#line 199 "../src/lib/notification.vala"
		pixbuf = _tmp126_;
#line 200 "../src/lib/notification.vala"
		_tmp127_ = pixbuf;
#line 200 "../src/lib/notification.vala"
		if (_tmp127_ != NULL) {
#line 2261 "notification.c"
			GdkPixbuf* _tmp128_;
			GtkImage* _tmp129_;
			GtkImage* _tmp130_;
#line 201 "../src/lib/notification.vala"
			_tmp128_ = pixbuf;
#line 201 "../src/lib/notification.vala"
			_tmp129_ = (GtkImage*) gtk_image_new_from_pixbuf (_tmp128_);
#line 201 "../src/lib/notification.vala"
			g_object_ref_sink (_tmp129_);
#line 201 "../src/lib/notification.vala"
			_tmp130_ = _tmp129_;
#line 201 "../src/lib/notification.vala"
			budgie_notification_set_image (self, _tmp130_);
#line 201 "../src/lib/notification.vala"
			_g_object_unref0 (_tmp130_);
#line 202 "../src/lib/notification.vala"
			image_found = TRUE;
#line 2279 "notification.c"
		}
#line 198 "../src/lib/notification.vala"
		_g_object_unref0 (pixbuf);
#line 2283 "notification.c"
	}
#line 207 "../src/lib/notification.vala"
	if (!image_found) {
#line 2287 "notification.c"
		GtkImage* _tmp131_;
		GtkImage* _tmp132_;
#line 208 "../src/lib/notification.vala"
		_tmp131_ = (GtkImage*) gtk_image_new_from_icon_name ("mail-unread-symbolic", (GtkIconSize) GTK_ICON_SIZE_DIALOG);
#line 208 "../src/lib/notification.vala"
		g_object_ref_sink (_tmp131_);
#line 208 "../src/lib/notification.vala"
		_tmp132_ = _tmp131_;
#line 208 "../src/lib/notification.vala"
		budgie_notification_set_image (self, _tmp132_);
#line 208 "../src/lib/notification.vala"
		_g_object_unref0 (_tmp132_);
#line 2300 "notification.c"
	}
#line 213 "../src/lib/notification.vala"
	_tmp133_ = self->priv->_body;
#line 213 "../src/lib/notification.vala"
	if (g_strcmp0 (_tmp133_, "") == 0) {
#line 2306 "notification.c"
		const gchar* _tmp134_;
		gchar* _tmp135_;
		gchar* _tmp136_;
		const gchar* _tmp137_;
#line 214 "../src/lib/notification.vala"
		_tmp134_ = self->priv->_summary;
#line 214 "../src/lib/notification.vala"
		_tmp135_ = budgie_notification_fix_markup (self, _tmp134_);
#line 214 "../src/lib/notification.vala"
		_tmp136_ = _tmp135_;
#line 214 "../src/lib/notification.vala"
		budgie_notification_set_body (self, _tmp136_);
#line 214 "../src/lib/notification.vala"
		_g_free0 (_tmp136_);
#line 215 "../src/lib/notification.vala"
		_tmp137_ = self->priv->_app_name;
#line 215 "../src/lib/notification.vala"
		budgie_notification_set_summary (self, _tmp137_);
#line 2325 "notification.c"
	} else {
		const gchar* _tmp138_;
		gchar* _tmp139_;
		gchar* _tmp140_;
		const gchar* _tmp141_;
		gchar* _tmp142_;
		gchar* _tmp143_;
#line 217 "../src/lib/notification.vala"
		_tmp138_ = self->priv->_body;
#line 217 "../src/lib/notification.vala"
		_tmp139_ = budgie_notification_fix_markup (self, _tmp138_);
#line 217 "../src/lib/notification.vala"
		_tmp140_ = _tmp139_;
#line 217 "../src/lib/notification.vala"
		budgie_notification_set_body (self, _tmp140_);
#line 217 "../src/lib/notification.vala"
		_g_free0 (_tmp140_);
#line 218 "../src/lib/notification.vala"
		_tmp141_ = self->priv->_summary;
#line 218 "../src/lib/notification.vala"
		_tmp142_ = budgie_notification_fix_markup (self, _tmp141_);
#line 218 "../src/lib/notification.vala"
		_tmp143_ = _tmp142_;
#line 218 "../src/lib/notification.vala"
		budgie_notification_set_summary (self, _tmp143_);
#line 218 "../src/lib/notification.vala"
		_g_free0 (_tmp143_);
#line 2353 "notification.c"
	}
#line 104 "../src/lib/notification.vala"
	return obj;
#line 2357 "notification.c"
}

static void
budgie_notification_class_init (BudgieNotificationClass * klass,
                                gpointer klass_data)
{
	GError* _inner_error0_ = NULL;
#line 41 "../src/lib/notification.vala"
	budgie_notification_parent_class = g_type_class_peek_parent (klass);
#line 41 "../src/lib/notification.vala"
	g_type_class_adjust_private_offset (klass, &BudgieNotification_private_offset);
#line 41 "../src/lib/notification.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_budgie_notification_get_property;
#line 41 "../src/lib/notification.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_budgie_notification_set_property;
#line 41 "../src/lib/notification.vala"
	G_OBJECT_CLASS (klass)->constructor = budgie_notification_constructor;
#line 41 "../src/lib/notification.vala"
	G_OBJECT_CLASS (klass)->finalize = budgie_notification_finalize;
#line 41 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_APP_INFO_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_APP_INFO_PROPERTY] = g_param_spec_object ("app-info", "app-info", "app-info", G_TYPE_DESKTOP_APP_INFO, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 41 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_APP_ID_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_APP_ID_PROPERTY] = g_param_spec_string ("app-id", "app-id", "app-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 41 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_URGENCY_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_URGENCY_PROPERTY] = g_param_spec_enum ("urgency", "urgency", "urgency", g_notification_priority_get_type (), G_NOTIFICATION_PRIORITY_NORMAL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 41 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_ID_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_ID_PROPERTY] = g_param_spec_uint ("id", "id", "id", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 41 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_APP_NAME_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_APP_NAME_PROPERTY] = g_param_spec_string ("app-name", "app-name", "app-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 41 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_NOTIFICATION_ICON_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_NOTIFICATION_ICON_PROPERTY] = g_param_spec_string ("notification-icon", "notification-icon", "notification-icon", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 41 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_HINTS_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_HINTS_PROPERTY] = g_param_spec_boxed ("hints", "hints", "hints", G_TYPE_HASH_TABLE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 41 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_ACTIONS_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_ACTIONS_PROPERTY] = g_param_spec_boxed ("actions", "actions", "actions", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 41 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_BODY_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_BODY_PROPERTY] = g_param_spec_string ("body", "body", "body", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 41 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_SUMMARY_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_SUMMARY_PROPERTY] = g_param_spec_string ("summary", "summary", "summary", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 41 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_EXPIRE_TIMEOUT_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_EXPIRE_TIMEOUT_PROPERTY] = g_param_spec_uint ("expire-timeout", "expire-timeout", "expire-timeout", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 41 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_CATEGORY_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_CATEGORY_PROPERTY] = g_param_spec_string ("category", "category", "category", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 41 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_TIMESTAMP_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_TIMESTAMP_PROPERTY] = g_param_spec_int64 ("timestamp", "timestamp", "timestamp", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 41 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_APP_IMAGE_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_APP_IMAGE_PROPERTY] = g_param_spec_object ("app-image", "app-image", "app-image", gtk_image_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 41 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_IMAGE_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_IMAGE_PROPERTY] = g_param_spec_object ("image", "image", "image", gtk_image_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2407 "notification.c"
	{
		GRegex* _tmp0_ = NULL;
		GRegex* _tmp1_;
		GRegex* _tmp2_;
		GRegex* _tmp3_ = NULL;
		GRegex* _tmp4_;
		GRegex* _tmp5_;
#line 97 "../src/lib/notification.vala"
		_tmp1_ = g_regex_new ("&(?!amp;|quot;|apos;|lt;|gt;|#39;|nbsp;)", 0, 0, &_inner_error0_);
#line 97 "../src/lib/notification.vala"
		_tmp0_ = _tmp1_;
#line 97 "../src/lib/notification.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2421 "notification.c"
			goto __catch0_g_error;
		}
#line 97 "../src/lib/notification.vala"
		_tmp2_ = _tmp0_;
#line 97 "../src/lib/notification.vala"
		_tmp0_ = NULL;
#line 97 "../src/lib/notification.vala"
		_g_regex_unref0 (budgie_notification_entity_regex);
#line 97 "../src/lib/notification.vala"
		budgie_notification_entity_regex = _tmp2_;
#line 98 "../src/lib/notification.vala"
		_tmp4_ = g_regex_new ("<(?!\\/?[biu]>)", 0, 0, &_inner_error0_);
#line 98 "../src/lib/notification.vala"
		_tmp3_ = _tmp4_;
#line 98 "../src/lib/notification.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 98 "../src/lib/notification.vala"
			_g_regex_unref0 (_tmp0_);
#line 2440 "notification.c"
			goto __catch0_g_error;
		}
#line 98 "../src/lib/notification.vala"
		_tmp5_ = _tmp3_;
#line 98 "../src/lib/notification.vala"
		_tmp3_ = NULL;
#line 98 "../src/lib/notification.vala"
		_g_regex_unref0 (budgie_notification_tag_regex);
#line 98 "../src/lib/notification.vala"
		budgie_notification_tag_regex = _tmp5_;
#line 96 "../src/lib/notification.vala"
		_g_regex_unref0 (_tmp3_);
#line 96 "../src/lib/notification.vala"
		_g_regex_unref0 (_tmp0_);
#line 2455 "notification.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 96 "../src/lib/notification.vala"
		e = _inner_error0_;
#line 96 "../src/lib/notification.vala"
		_inner_error0_ = NULL;
#line 100 "../src/lib/notification.vala"
		_tmp6_ = e;
#line 100 "../src/lib/notification.vala"
		_tmp7_ = _tmp6_->message;
#line 100 "../src/lib/notification.vala"
		g_warning ("notification.vala:100: Invalid notification regex: %s", _tmp7_);
#line 96 "../src/lib/notification.vala"
		_g_error_free0 (e);
#line 2475 "notification.c"
	}
	__finally0:
#line 96 "../src/lib/notification.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 96 "../src/lib/notification.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 96 "../src/lib/notification.vala"
		g_clear_error (&_inner_error0_);
#line 2484 "notification.c"
	}
}

static void
budgie_notification_instance_init (BudgieNotification * self,
                                   gpointer klass)
{
#line 41 "../src/lib/notification.vala"
	self->priv = budgie_notification_get_instance_private (self);
#line 42 "../src/lib/notification.vala"
	self->priv->_app_info = NULL;
#line 44 "../src/lib/notification.vala"
	self->priv->_urgency = G_NOTIFICATION_PRIORITY_NORMAL;
#line 61 "../src/lib/notification.vala"
	self->priv->_app_image = NULL;
#line 62 "../src/lib/notification.vala"
	self->priv->_image = NULL;
#line 2502 "notification.c"
}

static void
budgie_notification_finalize (GObject * obj)
{
	BudgieNotification * self;
#line 41 "../src/lib/notification.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BUDGIE_TYPE_NOTIFICATION, BudgieNotification);
#line 42 "../src/lib/notification.vala"
	_g_object_unref0 (self->priv->_app_info);
#line 43 "../src/lib/notification.vala"
	_g_free0 (self->priv->_app_id);
#line 49 "../src/lib/notification.vala"
	_g_free0 (self->priv->_app_name);
#line 50 "../src/lib/notification.vala"
	_g_free0 (self->priv->_notification_icon);
#line 51 "../src/lib/notification.vala"
	_g_hash_table_unref0 (self->priv->_hints);
#line 52 "../src/lib/notification.vala"
	self->priv->_actions = (_vala_array_free (self->priv->_actions, self->priv->_actions_length1, (GDestroyNotify) g_free), NULL);
#line 53 "../src/lib/notification.vala"
	_g_free0 (self->priv->_body);
#line 54 "../src/lib/notification.vala"
	_g_free0 (self->priv->_summary);
#line 57 "../src/lib/notification.vala"
	_g_free0 (self->priv->_category);
#line 61 "../src/lib/notification.vala"
	_g_object_unref0 (self->priv->_app_image);
#line 62 "../src/lib/notification.vala"
	_g_object_unref0 (self->priv->_image);
#line 41 "../src/lib/notification.vala"
	G_OBJECT_CLASS (budgie_notification_parent_class)->finalize (obj);
#line 2535 "notification.c"
}

/**
 * This is our wrapper class for a FreeDesktop notification.
 */
static GType
budgie_notification_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BudgieNotificationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) budgie_notification_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BudgieNotification), 0, (GInstanceInitFunc) budgie_notification_instance_init, NULL };
	GType budgie_notification_type_id;
	budgie_notification_type_id = g_type_register_static (G_TYPE_OBJECT, "BudgieNotification", &g_define_type_info, 0);
	BudgieNotification_private_offset = g_type_add_instance_private (budgie_notification_type_id, sizeof (BudgieNotificationPrivate));
	return budgie_notification_type_id;
}

GType
budgie_notification_get_type (void)
{
	static volatile gsize budgie_notification_type_id__once = 0;
	if (g_once_init_enter (&budgie_notification_type_id__once)) {
		GType budgie_notification_type_id;
		budgie_notification_type_id = budgie_notification_get_type_once ();
		g_once_init_leave (&budgie_notification_type_id__once, budgie_notification_type_id);
	}
	return budgie_notification_type_id__once;
}

static void
_vala_budgie_notification_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	BudgieNotification * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BUDGIE_TYPE_NOTIFICATION, BudgieNotification);
#line 41 "../src/lib/notification.vala"
	switch (property_id) {
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_APP_INFO_PROPERTY:
#line 41 "../src/lib/notification.vala"
		g_value_set_object (value, budgie_notification_get_app_info (self));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_APP_ID_PROPERTY:
#line 41 "../src/lib/notification.vala"
		g_value_set_string (value, budgie_notification_get_app_id (self));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_URGENCY_PROPERTY:
#line 41 "../src/lib/notification.vala"
		g_value_set_enum (value, budgie_notification_get_urgency (self));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_ID_PROPERTY:
#line 41 "../src/lib/notification.vala"
		g_value_set_uint (value, budgie_notification_get_id (self));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_APP_NAME_PROPERTY:
#line 41 "../src/lib/notification.vala"
		g_value_set_string (value, budgie_notification_get_app_name (self));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_NOTIFICATION_ICON_PROPERTY:
#line 41 "../src/lib/notification.vala"
		g_value_set_string (value, budgie_notification_get_notification_icon (self));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_HINTS_PROPERTY:
#line 41 "../src/lib/notification.vala"
		g_value_set_boxed (value, budgie_notification_get_hints (self));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_ACTIONS_PROPERTY:
#line 2617 "notification.c"
		{
			int length;
#line 41 "../src/lib/notification.vala"
			g_value_set_boxed (value, budgie_notification_get_actions (self, &length));
#line 2622 "notification.c"
		}
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_BODY_PROPERTY:
#line 41 "../src/lib/notification.vala"
		g_value_set_string (value, budgie_notification_get_body (self));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_SUMMARY_PROPERTY:
#line 41 "../src/lib/notification.vala"
		g_value_set_string (value, budgie_notification_get_summary (self));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_EXPIRE_TIMEOUT_PROPERTY:
#line 41 "../src/lib/notification.vala"
		g_value_set_uint (value, budgie_notification_get_expire_timeout (self));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_CATEGORY_PROPERTY:
#line 41 "../src/lib/notification.vala"
		g_value_set_string (value, budgie_notification_get_category (self));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_TIMESTAMP_PROPERTY:
#line 41 "../src/lib/notification.vala"
		g_value_set_int64 (value, budgie_notification_get_timestamp (self));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_APP_IMAGE_PROPERTY:
#line 41 "../src/lib/notification.vala"
		g_value_set_object (value, budgie_notification_get_app_image (self));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_IMAGE_PROPERTY:
#line 41 "../src/lib/notification.vala"
		g_value_set_object (value, budgie_notification_get_image (self));
#line 41 "../src/lib/notification.vala"
		break;
#line 2668 "notification.c"
		default:
#line 41 "../src/lib/notification.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 41 "../src/lib/notification.vala"
		break;
#line 2674 "notification.c"
	}
}

static void
_vala_budgie_notification_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	BudgieNotification * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BUDGIE_TYPE_NOTIFICATION, BudgieNotification);
#line 41 "../src/lib/notification.vala"
	switch (property_id) {
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_APP_INFO_PROPERTY:
#line 41 "../src/lib/notification.vala"
		budgie_notification_set_app_info (self, g_value_get_object (value));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_APP_ID_PROPERTY:
#line 41 "../src/lib/notification.vala"
		budgie_notification_set_app_id (self, g_value_get_string (value));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_URGENCY_PROPERTY:
#line 41 "../src/lib/notification.vala"
		budgie_notification_set_urgency (self, g_value_get_enum (value));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_ID_PROPERTY:
#line 41 "../src/lib/notification.vala"
		budgie_notification_set_id (self, g_value_get_uint (value));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_APP_NAME_PROPERTY:
#line 41 "../src/lib/notification.vala"
		budgie_notification_set_app_name (self, g_value_get_string (value));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_NOTIFICATION_ICON_PROPERTY:
#line 41 "../src/lib/notification.vala"
		budgie_notification_set_notification_icon (self, g_value_get_string (value));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_HINTS_PROPERTY:
#line 41 "../src/lib/notification.vala"
		budgie_notification_set_hints (self, g_value_get_boxed (value));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_ACTIONS_PROPERTY:
#line 2732 "notification.c"
		{
			gpointer boxed;
#line 41 "../src/lib/notification.vala"
			boxed = g_value_get_boxed (value);
#line 41 "../src/lib/notification.vala"
			budgie_notification_set_actions (self, boxed, (boxed == NULL) ? 0 : g_strv_length (boxed));
#line 2739 "notification.c"
		}
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_BODY_PROPERTY:
#line 41 "../src/lib/notification.vala"
		budgie_notification_set_body (self, g_value_get_string (value));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_SUMMARY_PROPERTY:
#line 41 "../src/lib/notification.vala"
		budgie_notification_set_summary (self, g_value_get_string (value));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_EXPIRE_TIMEOUT_PROPERTY:
#line 41 "../src/lib/notification.vala"
		budgie_notification_set_expire_timeout (self, g_value_get_uint (value));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_CATEGORY_PROPERTY:
#line 41 "../src/lib/notification.vala"
		budgie_notification_set_category (self, g_value_get_string (value));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_TIMESTAMP_PROPERTY:
#line 41 "../src/lib/notification.vala"
		budgie_notification_set_timestamp (self, g_value_get_int64 (value));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_APP_IMAGE_PROPERTY:
#line 41 "../src/lib/notification.vala"
		budgie_notification_set_app_image (self, g_value_get_object (value));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_IMAGE_PROPERTY:
#line 41 "../src/lib/notification.vala"
		budgie_notification_set_image (self, g_value_get_object (value));
#line 41 "../src/lib/notification.vala"
		break;
#line 2785 "notification.c"
		default:
#line 41 "../src/lib/notification.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 41 "../src/lib/notification.vala"
		break;
#line 2791 "notification.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

