/* themes.c generated by valac 0.56.17, the Vala compiler
 * generated from themes.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright Budgie Desktop Developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <glib/gstdio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	THEME_TYPE_ICON_THEME,
	THEME_TYPE_GTK_THEME,
	THEME_TYPE_CURSOR_THEME
} ThemeType;

#define TYPE_THEME_TYPE (theme_type_get_type ())

#define TYPE_THEME_INFO (theme_info_get_type ())
#define THEME_INFO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THEME_INFO, ThemeInfo))
#define THEME_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THEME_INFO, ThemeInfoClass))
#define IS_THEME_INFO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THEME_INFO))
#define IS_THEME_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THEME_INFO))
#define THEME_INFO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THEME_INFO, ThemeInfoClass))

typedef struct _ThemeInfo ThemeInfo;
typedef struct _ThemeInfoClass ThemeInfoClass;
typedef struct _ThemeInfoPrivate ThemeInfoPrivate;
enum  {
	THEME_INFO_0_PROPERTY,
	THEME_INFO_NUM_PROPERTIES
};
static GParamSpec* theme_info_properties[THEME_INFO_NUM_PROPERTIES];

#define TYPE_THEME_SCANNER (theme_scanner_get_type ())
#define THEME_SCANNER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THEME_SCANNER, ThemeScanner))
#define THEME_SCANNER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THEME_SCANNER, ThemeScannerClass))
#define IS_THEME_SCANNER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THEME_SCANNER))
#define IS_THEME_SCANNER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THEME_SCANNER))
#define THEME_SCANNER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THEME_SCANNER, ThemeScannerClass))

typedef struct _ThemeScanner ThemeScanner;
typedef struct _ThemeScannerClass ThemeScannerClass;
typedef struct _ThemeScannerPrivate ThemeScannerPrivate;
enum  {
	THEME_SCANNER_0_PROPERTY,
	THEME_SCANNER_NUM_PROPERTIES
};
static GParamSpec* theme_scanner_properties[THEME_SCANNER_NUM_PROPERTIES];
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _ThemeScannerScanThemesData ThemeScannerScanThemesData;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ThemeScannerScanThemesDirData ThemeScannerScanThemesDirData;
typedef struct _ThemeScannerScanOneData ThemeScannerScanOneData;
typedef struct _ThemeScannerMaybeAddGtkThemeData ThemeScannerMaybeAddGtkThemeData;
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
typedef struct _ThemeScannerMaybeAddIconThemeData ThemeScannerMaybeAddIconThemeData;
typedef struct _ThemeScannerMaybeAddCursorsData ThemeScannerMaybeAddCursorsData;
typedef struct _ThemeScannerMaybeAddIconsData ThemeScannerMaybeAddIconsData;

struct _ThemeInfo {
	GObject parent_instance;
	ThemeInfoPrivate * priv;
};

struct _ThemeInfoClass {
	GObjectClass parent_class;
};

struct _ThemeInfoPrivate {
	ThemeType theme_type;
	GList* paths;
};

struct _ThemeScanner {
	GObject parent_instance;
	ThemeScannerPrivate * priv;
};

struct _ThemeScannerClass {
	GObjectClass parent_class;
};

struct _ThemeScannerPrivate {
	gchar** xdg_paths;
	gint xdg_paths_length1;
	gint _xdg_paths_size_;
	gchar** gtk_theme_blacklist;
	gint gtk_theme_blacklist_length1;
	gint _gtk_theme_blacklist_size_;
	gchar** icon_theme_blacklist;
	gint icon_theme_blacklist_length1;
	gint _icon_theme_blacklist_size_;
	gchar** normal_suffixes;
	gint normal_suffixes_length1;
	gint _normal_suffixes_size_;
	gchar** legacy_suffixes;
	gint legacy_suffixes_length1;
	gint _legacy_suffixes_size_;
	gchar** gtk_theme_paths;
	gint gtk_theme_paths_length1;
	gint _gtk_theme_paths_size_;
	GHashTable* gtk_themes;
	GHashTable* cursor_themes;
	GHashTable* icon_themes;
};

struct _ThemeScannerScanThemesData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ThemeScanner* self;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** xdg_path_collection;
	gint xdg_path_collection_length1;
	gint _xdg_path_collection_size_;
	gint xdg_path_it;
	gchar* _tmp1_;
	gchar* xdg_path;
	const gchar* _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar* home_dir;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gboolean _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	const gchar* _tmp11_;
	gchar** _tmp12_;
	gint _tmp12__length1;
};

struct _ThemeScannerScanThemesDirData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ThemeScanner* self;
	gchar* base_dir;
	gchar** suffixes;
	gint suffixes_length1;
	gchar** suffix_collection;
	gint suffix_collection_length1;
	gint _suffix_collection_size_;
	gint suffix_it;
	gchar* _tmp0_;
	gchar* suffix;
	gchar* full_path;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	GFile* f;
	const gchar* _tmp4_;
	GFile* _tmp5_;
	GFileEnumerator* en;
	GFile* _tmp6_;
	GFileEnumerator* _tmp7_;
	GList* files;
	GFileEnumerator* _tmp8_;
	GList* _tmp9_;
	GList* _tmp10_;
	GList* _tmp11_;
	GList* file_collection;
	GList* file_it;
	GFileInfo* _tmp12_;
	GFileInfo* file;
	gchar* display_path;
	GFileInfo* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* sep;
	gchar* _tmp16_;
	gchar* path;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	const gchar* _tmp23_;
	GError* e;
	GError* _tmp24_;
	const gchar* _tmp25_;
	GError* _inner_error0_;
};

struct _ThemeScannerScanOneData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ThemeScanner* self;
	gchar* path_type;
	gchar* full_path;
	gchar* display_name;
	gboolean gtk_theme;
	gboolean _tmp0_;
	gchar** _tmp1_;
	gint _tmp1__length1;
	gchar** suffix_collection;
	gint suffix_collection_length1;
	gint _suffix_collection_size_;
	gint suffix_it;
	gchar* _tmp2_;
	gchar* suffix;
	gchar* path;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean added;
	const gchar* _tmp5_;
};

struct _ThemeScannerMaybeAddGtkThemeData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ThemeScanner* self;
	gchar* path;
	gchar* theme_name;
	gboolean result;
	gint index;
	gboolean _tmp0_;
	gint _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gchar* blacklisted_item;
	gchar** _tmp3_;
	gint _tmp3__length1;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gboolean _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	ThemeInfo* info;
	GHashTable* _tmp9_;
	gconstpointer _tmp10_;
	ThemeInfo* _tmp11_;
	ThemeInfo* ninfo;
	ThemeInfo* _tmp12_;
	GHashTable* _tmp13_;
	gchar* _tmp14_;
	ThemeInfo* _tmp15_;
	ThemeInfo* _tmp16_;
	GHashTable* _tmp17_;
	gconstpointer _tmp18_;
	ThemeInfo* _tmp19_;
};

struct _ThemeScannerMaybeAddIconThemeData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ThemeScanner* self;
	gchar* path;
	gchar* theme_name;
	gchar* test_path;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gboolean icon_theme;
	GKeyFile* f;
	GKeyFile* _tmp2_;
	GKeyFile* _tmp3_;
	const gchar* _tmp4_;
	gboolean _tmp5_;
	GKeyFile* _tmp6_;
	gchar* cursor_path;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	GError* _inner_error0_;
};

struct _ThemeScannerMaybeAddCursorsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ThemeScanner* self;
	gchar* path;
	gchar* theme_name;
	gboolean result;
	ThemeInfo* info;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	ThemeInfo* _tmp2_;
	ThemeInfo* ninfo;
	ThemeInfo* _tmp3_;
	GHashTable* _tmp4_;
	gchar* _tmp5_;
	ThemeInfo* _tmp6_;
	ThemeInfo* _tmp7_;
	GHashTable* _tmp8_;
	gconstpointer _tmp9_;
	ThemeInfo* _tmp10_;
};

struct _ThemeScannerMaybeAddIconsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ThemeScanner* self;
	gchar* path;
	gchar* theme_name;
	gboolean result;
	gint index;
	gboolean _tmp0_;
	gint _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gchar* blacklisted_item;
	gchar** _tmp3_;
	gint _tmp3__length1;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gboolean _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	ThemeInfo* info;
	GHashTable* _tmp9_;
	gconstpointer _tmp10_;
	ThemeInfo* _tmp11_;
	ThemeInfo* ninfo;
	ThemeInfo* _tmp12_;
	GHashTable* _tmp13_;
	gchar* _tmp14_;
	ThemeInfo* _tmp15_;
	ThemeInfo* _tmp16_;
	GHashTable* _tmp17_;
	gconstpointer _tmp18_;
	ThemeInfo* _tmp19_;
};

static gint ThemeInfo_private_offset;
static gpointer theme_info_parent_class = NULL;
static gint ThemeScanner_private_offset;
static gpointer theme_scanner_parent_class = NULL;

VALA_EXTERN GType theme_type_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType theme_info_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ThemeInfo, g_object_unref)
static void _g_free0_ (gpointer var);
static inline void _g_list_free__g_free0_ (GList* self);
VALA_EXTERN ThemeInfo* theme_info_new (ThemeType type);
VALA_EXTERN ThemeInfo* theme_info_construct (GType object_type,
                                 ThemeType type);
VALA_EXTERN gboolean theme_info_add_path (ThemeInfo* self,
                              const gchar* path);
VALA_EXTERN gboolean theme_info_contains_path (ThemeInfo* self,
                                   const gchar* path);
static void theme_info_finalize (GObject * obj);
static GType theme_info_get_type_once (void);
VALA_EXTERN GType theme_scanner_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ThemeScanner, g_object_unref)
VALA_EXTERN ThemeScanner* theme_scanner_new (void);
VALA_EXTERN ThemeScanner* theme_scanner_construct (GType object_type);
static gboolean _vala_string_array_contains (gchar* * stack,
                                      gssize stack_length,
                                      const gchar* needle);
static void _vala_array_add5 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _g_object_unref0_ (gpointer var);
static void theme_scanner_scan_themes_data_free (gpointer _data);
VALA_EXTERN void theme_scanner_scan_themes (ThemeScanner* self,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_);
VALA_EXTERN void theme_scanner_scan_themes_finish (ThemeScanner* self,
                                       GAsyncResult* _res_);
static gboolean theme_scanner_scan_themes_co (ThemeScannerScanThemesData* _data_);
static void theme_scanner_scan_themes_dir (ThemeScanner* self,
                                    const gchar* base_dir,
                                    gchar** suffixes,
                                    gint suffixes_length1,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_);
static void theme_scanner_scan_themes_dir_finish (ThemeScanner* self,
                                           GAsyncResult* _res_);
static void theme_scanner_scan_themes_ready (GObject* source_object,
                                      GAsyncResult* _res_,
                                      gpointer _user_data_);
static void theme_scanner_scan_themes_dir_data_free (gpointer _data);
static gboolean theme_scanner_scan_themes_dir_co (ThemeScannerScanThemesDirData* _data_);
static void theme_scanner_scan_themes_dir_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void theme_scanner_scan_one (ThemeScanner* self,
                             const gchar* path_type,
                             const gchar* full_path,
                             const gchar* display_name,
                             GAsyncReadyCallback _callback_,
                             gpointer _user_data_);
static void theme_scanner_scan_one_finish (ThemeScanner* self,
                                    GAsyncResult* _res_);
static void theme_scanner_scan_one_data_free (gpointer _data);
static gboolean theme_scanner_scan_one_co (ThemeScannerScanOneData* _data_);
static void theme_scanner_maybe_add_gtk_theme (ThemeScanner* self,
                                        const gchar* path,
                                        const gchar* theme_name,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_);
static gboolean theme_scanner_maybe_add_gtk_theme_finish (ThemeScanner* self,
                                                   GAsyncResult* _res_);
static void theme_scanner_scan_one_ready (GObject* source_object,
                                   GAsyncResult* _res_,
                                   gpointer _user_data_);
static void theme_scanner_maybe_add_icon_theme (ThemeScanner* self,
                                         const gchar* path,
                                         const gchar* theme_name,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_);
static void theme_scanner_maybe_add_icon_theme_finish (ThemeScanner* self,
                                                GAsyncResult* _res_);
static void theme_scanner_maybe_add_gtk_theme_data_free (gpointer _data);
static gboolean theme_scanner_maybe_add_gtk_theme_co (ThemeScannerMaybeAddGtkThemeData* _data_);
VALA_EXTERN gchar** theme_scanner_get_gtk_themes (ThemeScanner* self,
                                      gint* result_length1);
static void _vala_array_add6 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
VALA_EXTERN gchar** theme_scanner_get_cursor_themes (ThemeScanner* self,
                                         gint* result_length1);
static void _vala_array_add7 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
VALA_EXTERN gchar** theme_scanner_get_icon_themes (ThemeScanner* self,
                                       gint* result_length1);
static void _vala_array_add8 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void theme_scanner_maybe_add_icon_theme_data_free (gpointer _data);
static gboolean theme_scanner_maybe_add_icon_theme_co (ThemeScannerMaybeAddIconThemeData* _data_);
static void theme_scanner_maybe_add_icons (ThemeScanner* self,
                                    const gchar* path,
                                    const gchar* theme_name,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_);
static gboolean theme_scanner_maybe_add_icons_finish (ThemeScanner* self,
                                               GAsyncResult* _res_);
static void theme_scanner_maybe_add_icon_theme_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_);
static void theme_scanner_maybe_add_cursors (ThemeScanner* self,
                                      const gchar* path,
                                      const gchar* theme_name,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
static gboolean theme_scanner_maybe_add_cursors_finish (ThemeScanner* self,
                                                 GAsyncResult* _res_);
static void theme_scanner_maybe_add_cursors_data_free (gpointer _data);
static gboolean theme_scanner_maybe_add_cursors_co (ThemeScannerMaybeAddCursorsData* _data_);
static void theme_scanner_maybe_add_icons_data_free (gpointer _data);
static gboolean theme_scanner_maybe_add_icons_co (ThemeScannerMaybeAddIconsData* _data_);
static void theme_scanner_finalize (GObject * obj);
static GType theme_scanner_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static GType
theme_type_get_type_once (void)
{
	static const GEnumValue values[] = {{THEME_TYPE_ICON_THEME, "THEME_TYPE_ICON_THEME", "icon-theme"}, {THEME_TYPE_GTK_THEME, "THEME_TYPE_GTK_THEME", "gtk-theme"}, {THEME_TYPE_CURSOR_THEME, "THEME_TYPE_CURSOR_THEME", "cursor-theme"}, {0, NULL, NULL}};
	GType theme_type_type_id;
	theme_type_type_id = g_enum_register_static ("ThemeType", values);
	return theme_type_type_id;
}

GType
theme_type_get_type (void)
{
	static volatile gsize theme_type_type_id__once = 0;
	if (g_once_init_enter (&theme_type_type_id__once)) {
		GType theme_type_type_id;
		theme_type_type_id = theme_type_get_type_once ();
		g_once_init_leave (&theme_type_type_id__once, theme_type_type_id);
	}
	return theme_type_type_id__once;
}

static inline gpointer
theme_info_get_instance_private (ThemeInfo* self)
{
	return G_STRUCT_MEMBER_P (self, ThemeInfo_private_offset);
}

static void
_g_free0_ (gpointer var)
{
#line 21 "../src/panel/settings/themes.vala"
	var = (g_free (var), NULL);
#line 540 "themes.c"
}

static inline void
_g_list_free__g_free0_ (GList* self)
{
#line 21 "../src/panel/settings/themes.vala"
	g_list_free_full (self, (GDestroyNotify) _g_free0_);
#line 548 "themes.c"
}

ThemeInfo*
theme_info_construct (GType object_type,
                      ThemeType type)
{
	ThemeInfo * self = NULL;
#line 23 "../src/panel/settings/themes.vala"
	self = (ThemeInfo*) g_object_new (object_type, NULL);
#line 24 "../src/panel/settings/themes.vala"
	self->priv->theme_type = type;
#line 25 "../src/panel/settings/themes.vala"
	(self->priv->paths == NULL) ? NULL : (self->priv->paths = (_g_list_free__g_free0_ (self->priv->paths), NULL));
#line 25 "../src/panel/settings/themes.vala"
	self->priv->paths = NULL;
#line 23 "../src/panel/settings/themes.vala"
	return self;
#line 566 "themes.c"
}

ThemeInfo*
theme_info_new (ThemeType type)
{
#line 23 "../src/panel/settings/themes.vala"
	return theme_info_construct (TYPE_THEME_INFO, type);
#line 574 "themes.c"
}

/**
 * Try to add a path
 */
gboolean
theme_info_add_path (ThemeInfo* self,
                     const gchar* path)
{
	gchar* _tmp0_;
	gboolean result;
#line 31 "../src/panel/settings/themes.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 31 "../src/panel/settings/themes.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 32 "../src/panel/settings/themes.vala"
	if (theme_info_contains_path (self, path)) {
#line 33 "../src/panel/settings/themes.vala"
		result = FALSE;
#line 33 "../src/panel/settings/themes.vala"
		return result;
#line 596 "themes.c"
	}
#line 35 "../src/panel/settings/themes.vala"
	_tmp0_ = g_strdup (path);
#line 35 "../src/panel/settings/themes.vala"
	self->priv->paths = g_list_append (self->priv->paths, _tmp0_);
#line 36 "../src/panel/settings/themes.vala"
	result = TRUE;
#line 36 "../src/panel/settings/themes.vala"
	return result;
#line 606 "themes.c"
}

gboolean
theme_info_contains_path (ThemeInfo* self,
                          const gchar* path)
{
	GList* g = NULL;
	GList* _tmp0_;
	GCompareFunc _tmp1_;
	GList* _tmp2_;
	gboolean result;
#line 39 "../src/panel/settings/themes.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 39 "../src/panel/settings/themes.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 40 "../src/panel/settings/themes.vala"
	_tmp0_ = self->priv->paths;
#line 40 "../src/panel/settings/themes.vala"
	_tmp1_ = ((GCompareFunc) g_strcmp0);
#line 40 "../src/panel/settings/themes.vala"
	_tmp2_ = g_list_find_custom (_tmp0_, path, _tmp1_);
#line 40 "../src/panel/settings/themes.vala"
	g = _tmp2_;
#line 41 "../src/panel/settings/themes.vala"
	result = g != NULL;
#line 41 "../src/panel/settings/themes.vala"
	return result;
#line 634 "themes.c"
}

static void
theme_info_class_init (ThemeInfoClass * klass,
                       gpointer klass_data)
{
#line 19 "../src/panel/settings/themes.vala"
	theme_info_parent_class = g_type_class_peek_parent (klass);
#line 19 "../src/panel/settings/themes.vala"
	g_type_class_adjust_private_offset (klass, &ThemeInfo_private_offset);
#line 19 "../src/panel/settings/themes.vala"
	G_OBJECT_CLASS (klass)->finalize = theme_info_finalize;
#line 647 "themes.c"
}

static void
theme_info_instance_init (ThemeInfo * self,
                          gpointer klass)
{
#line 19 "../src/panel/settings/themes.vala"
	self->priv = theme_info_get_instance_private (self);
#line 656 "themes.c"
}

static void
theme_info_finalize (GObject * obj)
{
	ThemeInfo * self;
#line 19 "../src/panel/settings/themes.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_THEME_INFO, ThemeInfo);
#line 21 "../src/panel/settings/themes.vala"
	(self->priv->paths == NULL) ? NULL : (self->priv->paths = (_g_list_free__g_free0_ (self->priv->paths), NULL));
#line 19 "../src/panel/settings/themes.vala"
	G_OBJECT_CLASS (theme_info_parent_class)->finalize (obj);
#line 669 "themes.c"
}

static GType
theme_info_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ThemeInfoClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) theme_info_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ThemeInfo), 0, (GInstanceInitFunc) theme_info_instance_init, NULL };
	GType theme_info_type_id;
	theme_info_type_id = g_type_register_static (G_TYPE_OBJECT, "ThemeInfo", &g_define_type_info, 0);
	ThemeInfo_private_offset = g_type_add_instance_private (theme_info_type_id, sizeof (ThemeInfoPrivate));
	return theme_info_type_id;
}

GType
theme_info_get_type (void)
{
	static volatile gsize theme_info_type_id__once = 0;
	if (g_once_init_enter (&theme_info_type_id__once)) {
		GType theme_info_type_id;
		theme_info_type_id = theme_info_get_type_once ();
		g_once_init_leave (&theme_info_type_id__once, theme_info_type_id);
	}
	return theme_info_type_id__once;
}

static inline gpointer
theme_scanner_get_instance_private (ThemeScanner* self)
{
	return G_STRUCT_MEMBER_P (self, ThemeScanner_private_offset);
}

static gboolean
_vala_string_array_contains (gchar* * stack,
                             gssize stack_length,
                             const gchar* needle)
{
	gssize i;
#line 95 "../src/panel/settings/themes.vala"
	for (i = 0; i < stack_length; i++) {
#line 95 "../src/panel/settings/themes.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 95 "../src/panel/settings/themes.vala"
			return TRUE;
#line 712 "themes.c"
		}
	}
#line 95 "../src/panel/settings/themes.vala"
	return FALSE;
#line 717 "themes.c"
}

static void
_vala_array_add5 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 98 "../src/panel/settings/themes.vala"
	if ((*length) == (*size)) {
#line 98 "../src/panel/settings/themes.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 98 "../src/panel/settings/themes.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 732 "themes.c"
	}
#line 98 "../src/panel/settings/themes.vala"
	(*array)[(*length)++] = value;
#line 98 "../src/panel/settings/themes.vala"
	(*array)[*length] = NULL;
#line 738 "themes.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 107 "../src/panel/settings/themes.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 746 "themes.c"
}

ThemeScanner*
theme_scanner_construct (GType object_type)
{
	ThemeScanner * self = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar** _tmp12_;
	GHashFunc _tmp13_;
	GEqualFunc _tmp14_;
	GHashTable* _tmp15_;
	GHashFunc _tmp16_;
	GEqualFunc _tmp17_;
	GHashTable* _tmp18_;
	GHashFunc _tmp19_;
	GEqualFunc _tmp20_;
	GHashTable* _tmp21_;
#line 89 "../src/panel/settings/themes.vala"
	self = (ThemeScanner*) g_object_new (object_type, NULL);
#line 91 "../src/panel/settings/themes.vala"
	_tmp0_ = g_get_user_data_dir ();
#line 91 "../src/panel/settings/themes.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 91 "../src/panel/settings/themes.vala"
	_tmp2_ = g_new0 (gchar*, 1 + 1);
#line 91 "../src/panel/settings/themes.vala"
	_tmp2_[0] = _tmp1_;
#line 91 "../src/panel/settings/themes.vala"
	self->priv->xdg_paths = (_vala_array_free (self->priv->xdg_paths, self->priv->xdg_paths_length1, (GDestroyNotify) g_free), NULL);
#line 91 "../src/panel/settings/themes.vala"
	self->priv->xdg_paths = _tmp2_;
#line 91 "../src/panel/settings/themes.vala"
	self->priv->xdg_paths_length1 = 1;
#line 91 "../src/panel/settings/themes.vala"
	self->priv->_xdg_paths_size_ = self->priv->xdg_paths_length1;
#line 94 "../src/panel/settings/themes.vala"
	_tmp4_ = _tmp3_ = g_get_system_data_dirs ();
#line 790 "themes.c"
	{
		gchar** item_collection = NULL;
		gint item_collection_length1 = 0;
		gint _item_collection_size_ = 0;
		gint item_it = 0;
#line 94 "../src/panel/settings/themes.vala"
		item_collection = _tmp4_;
#line 94 "../src/panel/settings/themes.vala"
		item_collection_length1 = _vala_array_length (_tmp3_);
#line 94 "../src/panel/settings/themes.vala"
		for (item_it = 0; item_it < item_collection_length1; item_it = item_it + 1) {
#line 802 "themes.c"
			gchar* _tmp5_;
			gchar* item = NULL;
#line 94 "../src/panel/settings/themes.vala"
			_tmp5_ = g_strdup (item_collection[item_it]);
#line 94 "../src/panel/settings/themes.vala"
			item = _tmp5_;
#line 809 "themes.c"
			{
				const gchar* _tmp6_;
				gchar** _tmp7_;
				gint _tmp7__length1;
				const gchar* _tmp8_;
				gchar* _tmp9_;
#line 95 "../src/panel/settings/themes.vala"
				_tmp6_ = item;
#line 95 "../src/panel/settings/themes.vala"
				_tmp7_ = self->priv->xdg_paths;
#line 95 "../src/panel/settings/themes.vala"
				_tmp7__length1 = self->priv->xdg_paths_length1;
#line 95 "../src/panel/settings/themes.vala"
				if (_vala_string_array_contains (_tmp7_, _tmp7__length1, _tmp6_)) {
#line 96 "../src/panel/settings/themes.vala"
					_g_free0 (item);
#line 96 "../src/panel/settings/themes.vala"
					continue;
#line 828 "themes.c"
				}
#line 98 "../src/panel/settings/themes.vala"
				_tmp8_ = item;
#line 98 "../src/panel/settings/themes.vala"
				_tmp9_ = g_strdup (_tmp8_);
#line 98 "../src/panel/settings/themes.vala"
				_vala_array_add5 (&self->priv->xdg_paths, &self->priv->xdg_paths_length1, &self->priv->_xdg_paths_size_, _tmp9_);
#line 94 "../src/panel/settings/themes.vala"
				_g_free0 (item);
#line 838 "themes.c"
			}
		}
	}
#line 101 "../src/panel/settings/themes.vala"
	_tmp10_ = g_strdup_printf ("gtk-%d.0", GTK_MAJOR_VERSION);
#line 101 "../src/panel/settings/themes.vala"
	_tmp11_ = g_strdup_printf ("gtk-%d-%d", GTK_MAJOR_VERSION, GTK_MINOR_VERSION);
#line 101 "../src/panel/settings/themes.vala"
	_tmp12_ = g_new0 (gchar*, 2 + 1);
#line 101 "../src/panel/settings/themes.vala"
	_tmp12_[0] = _tmp10_;
#line 101 "../src/panel/settings/themes.vala"
	_tmp12_[1] = _tmp11_;
#line 101 "../src/panel/settings/themes.vala"
	self->priv->gtk_theme_paths = (_vala_array_free (self->priv->gtk_theme_paths, self->priv->gtk_theme_paths_length1, (GDestroyNotify) g_free), NULL);
#line 101 "../src/panel/settings/themes.vala"
	self->priv->gtk_theme_paths = _tmp12_;
#line 101 "../src/panel/settings/themes.vala"
	self->priv->gtk_theme_paths_length1 = 2;
#line 101 "../src/panel/settings/themes.vala"
	self->priv->_gtk_theme_paths_size_ = self->priv->gtk_theme_paths_length1;
#line 107 "../src/panel/settings/themes.vala"
	_tmp13_ = g_str_hash;
#line 107 "../src/panel/settings/themes.vala"
	_tmp14_ = g_str_equal;
#line 107 "../src/panel/settings/themes.vala"
	_tmp15_ = g_hash_table_new_full (_tmp13_, _tmp14_, _g_free0_, _g_object_unref0_);
#line 107 "../src/panel/settings/themes.vala"
	_g_hash_table_unref0 (self->priv->gtk_themes);
#line 107 "../src/panel/settings/themes.vala"
	self->priv->gtk_themes = _tmp15_;
#line 108 "../src/panel/settings/themes.vala"
	_tmp16_ = g_str_hash;
#line 108 "../src/panel/settings/themes.vala"
	_tmp17_ = g_str_equal;
#line 108 "../src/panel/settings/themes.vala"
	_tmp18_ = g_hash_table_new_full (_tmp16_, _tmp17_, _g_free0_, _g_object_unref0_);
#line 108 "../src/panel/settings/themes.vala"
	_g_hash_table_unref0 (self->priv->cursor_themes);
#line 108 "../src/panel/settings/themes.vala"
	self->priv->cursor_themes = _tmp18_;
#line 109 "../src/panel/settings/themes.vala"
	_tmp19_ = g_str_hash;
#line 109 "../src/panel/settings/themes.vala"
	_tmp20_ = g_str_equal;
#line 109 "../src/panel/settings/themes.vala"
	_tmp21_ = g_hash_table_new_full (_tmp19_, _tmp20_, _g_free0_, _g_object_unref0_);
#line 109 "../src/panel/settings/themes.vala"
	_g_hash_table_unref0 (self->priv->icon_themes);
#line 109 "../src/panel/settings/themes.vala"
	self->priv->icon_themes = _tmp21_;
#line 89 "../src/panel/settings/themes.vala"
	return self;
#line 892 "themes.c"
}

ThemeScanner*
theme_scanner_new (void)
{
#line 89 "../src/panel/settings/themes.vala"
	return theme_scanner_construct (TYPE_THEME_SCANNER);
#line 900 "themes.c"
}

static void
theme_scanner_scan_themes_data_free (gpointer _data)
{
	ThemeScannerScanThemesData* _data_;
	_data_ = _data;
#line 45 "../src/panel/settings/themes.vala"
	_g_object_unref0 (_data_->self);
#line 45 "../src/panel/settings/themes.vala"
	g_slice_free (ThemeScannerScanThemesData, _data_);
#line 912 "themes.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 45 "../src/panel/settings/themes.vala"
	return self ? g_object_ref (self) : NULL;
#line 920 "themes.c"
}

void
theme_scanner_scan_themes (ThemeScanner* self,
                           GAsyncReadyCallback _callback_,
                           gpointer _user_data_)
{
	ThemeScannerScanThemesData* _data_;
	ThemeScanner* _tmp0_;
#line 45 "../src/panel/settings/themes.vala"
	g_return_if_fail (self != NULL);
#line 45 "../src/panel/settings/themes.vala"
	_data_ = g_slice_new0 (ThemeScannerScanThemesData);
#line 45 "../src/panel/settings/themes.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 45 "../src/panel/settings/themes.vala"
	g_task_set_task_data (_data_->_async_result, _data_, theme_scanner_scan_themes_data_free);
#line 45 "../src/panel/settings/themes.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 45 "../src/panel/settings/themes.vala"
	_data_->self = _tmp0_;
#line 45 "../src/panel/settings/themes.vala"
	theme_scanner_scan_themes_co (_data_);
#line 944 "themes.c"
}

void
theme_scanner_scan_themes_finish (ThemeScanner* self,
                                  GAsyncResult* _res_)
{
	ThemeScannerScanThemesData* _data_;
#line 45 "../src/panel/settings/themes.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 954 "themes.c"
}

/**
 * Scan all theme types
 */
static void
theme_scanner_scan_themes_ready (GObject* source_object,
                                 GAsyncResult* _res_,
                                 gpointer _user_data_)
{
	ThemeScannerScanThemesData* _data_;
#line 117 "../src/panel/settings/themes.vala"
	_data_ = _user_data_;
#line 117 "../src/panel/settings/themes.vala"
	_data_->_source_object_ = source_object;
#line 117 "../src/panel/settings/themes.vala"
	_data_->_res_ = _res_;
#line 117 "../src/panel/settings/themes.vala"
	theme_scanner_scan_themes_co (_data_);
#line 974 "themes.c"
}

static gboolean
theme_scanner_scan_themes_co (ThemeScannerScanThemesData* _data_)
{
#line 115 "../src/panel/settings/themes.vala"
	switch (_data_->_state_) {
#line 115 "../src/panel/settings/themes.vala"
		case 0:
#line 984 "themes.c"
		goto _state_0;
#line 115 "../src/panel/settings/themes.vala"
		case 1:
#line 988 "themes.c"
		goto _state_1;
#line 115 "../src/panel/settings/themes.vala"
		case 2:
#line 992 "themes.c"
		goto _state_2;
		default:
#line 115 "../src/panel/settings/themes.vala"
		g_assert_not_reached ();
#line 997 "themes.c"
	}
	_state_0:
#line 116 "../src/panel/settings/themes.vala"
	_data_->_tmp0_ = _data_->self->priv->xdg_paths;
#line 116 "../src/panel/settings/themes.vala"
	_data_->_tmp0__length1 = _data_->self->priv->xdg_paths_length1;
#line 1004 "themes.c"
	{
#line 116 "../src/panel/settings/themes.vala"
		_data_->xdg_path_collection_length1 = 0;
#line 116 "../src/panel/settings/themes.vala"
		_data_->_xdg_path_collection_size_ = 0;
#line 116 "../src/panel/settings/themes.vala"
		_data_->xdg_path_collection = _data_->_tmp0_;
#line 116 "../src/panel/settings/themes.vala"
		_data_->xdg_path_collection_length1 = _data_->_tmp0__length1;
#line 116 "../src/panel/settings/themes.vala"
		for (_data_->xdg_path_it = 0; _data_->xdg_path_it < _data_->xdg_path_collection_length1; _data_->xdg_path_it = _data_->xdg_path_it + 1) {
#line 116 "../src/panel/settings/themes.vala"
			_data_->_tmp1_ = g_strdup (_data_->xdg_path_collection[_data_->xdg_path_it]);
#line 116 "../src/panel/settings/themes.vala"
			_data_->xdg_path = _data_->_tmp1_;
#line 1020 "themes.c"
			{
#line 117 "../src/panel/settings/themes.vala"
				_data_->_tmp2_ = _data_->xdg_path;
#line 117 "../src/panel/settings/themes.vala"
				_data_->_tmp3_ = _data_->self->priv->normal_suffixes;
#line 117 "../src/panel/settings/themes.vala"
				_data_->_tmp3__length1 = _data_->self->priv->normal_suffixes_length1;
#line 117 "../src/panel/settings/themes.vala"
				_data_->_state_ = 1;
#line 117 "../src/panel/settings/themes.vala"
				theme_scanner_scan_themes_dir (_data_->self, _data_->_tmp2_, _data_->_tmp3_, (gint) _data_->_tmp3__length1, theme_scanner_scan_themes_ready, _data_);
#line 117 "../src/panel/settings/themes.vala"
				return FALSE;
#line 1034 "themes.c"
				_state_1:
#line 117 "../src/panel/settings/themes.vala"
				theme_scanner_scan_themes_dir_finish (_data_->self, _data_->_res_);
#line 116 "../src/panel/settings/themes.vala"
				_g_free0 (_data_->xdg_path);
#line 1040 "themes.c"
			}
		}
	}
#line 119 "../src/panel/settings/themes.vala"
	_data_->_tmp4_ = g_get_home_dir ();
#line 119 "../src/panel/settings/themes.vala"
	_data_->_tmp5_ = g_strdup (_data_->_tmp4_);
#line 119 "../src/panel/settings/themes.vala"
	_data_->home_dir = _data_->_tmp5_;
#line 120 "../src/panel/settings/themes.vala"
	_data_->_tmp7_ = _data_->home_dir;
#line 120 "../src/panel/settings/themes.vala"
	if (_data_->_tmp7_ == NULL) {
#line 120 "../src/panel/settings/themes.vala"
		_data_->_tmp6_ = TRUE;
#line 1056 "themes.c"
	} else {
#line 120 "../src/panel/settings/themes.vala"
		_data_->_tmp8_ = _data_->home_dir;
#line 120 "../src/panel/settings/themes.vala"
		_data_->_tmp9_ = strlen (_data_->_tmp8_);
#line 120 "../src/panel/settings/themes.vala"
		_data_->_tmp10_ = _data_->_tmp9_;
#line 120 "../src/panel/settings/themes.vala"
		_data_->_tmp6_ = _data_->_tmp10_ < 1;
#line 1066 "themes.c"
	}
#line 120 "../src/panel/settings/themes.vala"
	if (_data_->_tmp6_) {
#line 121 "../src/panel/settings/themes.vala"
		_g_free0 (_data_->home_dir);
#line 121 "../src/panel/settings/themes.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 121 "../src/panel/settings/themes.vala"
		if (_data_->_state_ != 0) {
#line 121 "../src/panel/settings/themes.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 121 "../src/panel/settings/themes.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1080 "themes.c"
			}
		}
#line 121 "../src/panel/settings/themes.vala"
		g_object_unref (_data_->_async_result);
#line 121 "../src/panel/settings/themes.vala"
		return FALSE;
#line 1087 "themes.c"
	}
#line 123 "../src/panel/settings/themes.vala"
	_data_->_tmp11_ = _data_->home_dir;
#line 123 "../src/panel/settings/themes.vala"
	_data_->_tmp12_ = _data_->self->priv->legacy_suffixes;
#line 123 "../src/panel/settings/themes.vala"
	_data_->_tmp12__length1 = _data_->self->priv->legacy_suffixes_length1;
#line 123 "../src/panel/settings/themes.vala"
	_data_->_state_ = 2;
#line 123 "../src/panel/settings/themes.vala"
	theme_scanner_scan_themes_dir (_data_->self, _data_->_tmp11_, _data_->_tmp12_, (gint) _data_->_tmp12__length1, theme_scanner_scan_themes_ready, _data_);
#line 123 "../src/panel/settings/themes.vala"
	return FALSE;
#line 1101 "themes.c"
	_state_2:
#line 123 "../src/panel/settings/themes.vala"
	theme_scanner_scan_themes_dir_finish (_data_->self, _data_->_res_);
#line 115 "../src/panel/settings/themes.vala"
	_g_free0 (_data_->home_dir);
#line 115 "../src/panel/settings/themes.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 115 "../src/panel/settings/themes.vala"
	if (_data_->_state_ != 0) {
#line 115 "../src/panel/settings/themes.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 115 "../src/panel/settings/themes.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1115 "themes.c"
		}
	}
#line 115 "../src/panel/settings/themes.vala"
	g_object_unref (_data_->_async_result);
#line 115 "../src/panel/settings/themes.vala"
	return FALSE;
#line 1122 "themes.c"
}

static void
theme_scanner_scan_themes_dir_data_free (gpointer _data)
{
	ThemeScannerScanThemesDirData* _data_;
	_data_ = _data;
#line 45 "../src/panel/settings/themes.vala"
	_g_free0 (_data_->base_dir);
#line 45 "../src/panel/settings/themes.vala"
	_g_object_unref0 (_data_->self);
#line 45 "../src/panel/settings/themes.vala"
	g_slice_free (ThemeScannerScanThemesDirData, _data_);
#line 1136 "themes.c"
}

static void
theme_scanner_scan_themes_dir (ThemeScanner* self,
                               const gchar* base_dir,
                               gchar** suffixes,
                               gint suffixes_length1,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_)
{
	ThemeScannerScanThemesDirData* _data_;
	ThemeScanner* _tmp0_;
	gchar* _tmp1_;
#line 45 "../src/panel/settings/themes.vala"
	g_return_if_fail (self != NULL);
#line 45 "../src/panel/settings/themes.vala"
	g_return_if_fail (base_dir != NULL);
#line 45 "../src/panel/settings/themes.vala"
	_data_ = g_slice_new0 (ThemeScannerScanThemesDirData);
#line 45 "../src/panel/settings/themes.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 45 "../src/panel/settings/themes.vala"
	g_task_set_task_data (_data_->_async_result, _data_, theme_scanner_scan_themes_dir_data_free);
#line 45 "../src/panel/settings/themes.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 45 "../src/panel/settings/themes.vala"
	_data_->self = _tmp0_;
#line 45 "../src/panel/settings/themes.vala"
	_tmp1_ = g_strdup (base_dir);
#line 45 "../src/panel/settings/themes.vala"
	_g_free0 (_data_->base_dir);
#line 45 "../src/panel/settings/themes.vala"
	_data_->base_dir = _tmp1_;
#line 45 "../src/panel/settings/themes.vala"
	_data_->suffixes = suffixes;
#line 45 "../src/panel/settings/themes.vala"
	_data_->suffixes_length1 = suffixes_length1;
#line 45 "../src/panel/settings/themes.vala"
	theme_scanner_scan_themes_dir_co (_data_);
#line 1176 "themes.c"
}

static void
theme_scanner_scan_themes_dir_finish (ThemeScanner* self,
                                      GAsyncResult* _res_)
{
	ThemeScannerScanThemesDirData* _data_;
#line 45 "../src/panel/settings/themes.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1186 "themes.c"
}

/**
 * Scan a directory for all theme types
 */
static void
theme_scanner_scan_themes_dir_ready (GObject* source_object,
                                     GAsyncResult* _res_,
                                     gpointer _user_data_)
{
	ThemeScannerScanThemesDirData* _data_;
#line 143 "../src/panel/settings/themes.vala"
	_data_ = _user_data_;
#line 143 "../src/panel/settings/themes.vala"
	_data_->_source_object_ = source_object;
#line 143 "../src/panel/settings/themes.vala"
	_data_->_res_ = _res_;
#line 143 "../src/panel/settings/themes.vala"
	theme_scanner_scan_themes_dir_co (_data_);
#line 1206 "themes.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 147 "../src/panel/settings/themes.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 1214 "themes.c"
}

static gboolean
theme_scanner_scan_themes_dir_co (ThemeScannerScanThemesDirData* _data_)
{
#line 129 "../src/panel/settings/themes.vala"
	switch (_data_->_state_) {
#line 129 "../src/panel/settings/themes.vala"
		case 0:
#line 1224 "themes.c"
		goto _state_0;
#line 129 "../src/panel/settings/themes.vala"
		case 1:
#line 1228 "themes.c"
		goto _state_1;
#line 129 "../src/panel/settings/themes.vala"
		case 2:
#line 1232 "themes.c"
		goto _state_2;
#line 129 "../src/panel/settings/themes.vala"
		case 3:
#line 1236 "themes.c"
		goto _state_3;
		default:
#line 129 "../src/panel/settings/themes.vala"
		g_assert_not_reached ();
#line 1241 "themes.c"
	}
	_state_0:
#line 130 "../src/panel/settings/themes.vala"
	if (!g_file_test (_data_->base_dir, G_FILE_TEST_IS_DIR)) {
#line 131 "../src/panel/settings/themes.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 131 "../src/panel/settings/themes.vala"
		if (_data_->_state_ != 0) {
#line 131 "../src/panel/settings/themes.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 131 "../src/panel/settings/themes.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1254 "themes.c"
			}
		}
#line 131 "../src/panel/settings/themes.vala"
		g_object_unref (_data_->_async_result);
#line 131 "../src/panel/settings/themes.vala"
		return FALSE;
#line 1261 "themes.c"
	}
	{
		{
#line 135 "../src/panel/settings/themes.vala"
			_data_->suffix_collection_length1 = 0;
#line 135 "../src/panel/settings/themes.vala"
			_data_->_suffix_collection_size_ = 0;
#line 135 "../src/panel/settings/themes.vala"
			_data_->suffix_collection = _data_->suffixes;
#line 135 "../src/panel/settings/themes.vala"
			_data_->suffix_collection_length1 = _data_->suffixes_length1;
#line 135 "../src/panel/settings/themes.vala"
			for (_data_->suffix_it = 0; _data_->suffix_it < _data_->suffix_collection_length1; _data_->suffix_it = _data_->suffix_it + 1) {
#line 135 "../src/panel/settings/themes.vala"
				_data_->_tmp0_ = g_strdup (_data_->suffix_collection[_data_->suffix_it]);
#line 135 "../src/panel/settings/themes.vala"
				_data_->suffix = _data_->_tmp0_;
#line 1279 "themes.c"
				{
#line 136 "../src/panel/settings/themes.vala"
					_data_->_tmp1_ = _data_->suffix;
#line 136 "../src/panel/settings/themes.vala"
					_data_->_tmp2_ = g_strdup_printf ("%s%s%s", _data_->base_dir, G_DIR_SEPARATOR_S, _data_->_tmp1_);
#line 136 "../src/panel/settings/themes.vala"
					_data_->full_path = _data_->_tmp2_;
#line 137 "../src/panel/settings/themes.vala"
					_data_->_tmp3_ = _data_->full_path;
#line 137 "../src/panel/settings/themes.vala"
					if (!g_file_test (_data_->_tmp3_, G_FILE_TEST_IS_DIR)) {
#line 138 "../src/panel/settings/themes.vala"
						_g_free0 (_data_->full_path);
#line 138 "../src/panel/settings/themes.vala"
						_g_free0 (_data_->suffix);
#line 138 "../src/panel/settings/themes.vala"
						continue;
#line 1297 "themes.c"
					}
#line 142 "../src/panel/settings/themes.vala"
					_data_->_tmp4_ = _data_->full_path;
#line 142 "../src/panel/settings/themes.vala"
					_data_->_tmp5_ = g_file_new_for_path (_data_->_tmp4_);
#line 142 "../src/panel/settings/themes.vala"
					_data_->f = _data_->_tmp5_;
#line 143 "../src/panel/settings/themes.vala"
					_data_->_tmp6_ = _data_->f;
#line 143 "../src/panel/settings/themes.vala"
					_data_->_state_ = 1;
#line 143 "../src/panel/settings/themes.vala"
					g_file_enumerate_children_async (_data_->_tmp6_, "standard::*", G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, G_PRIORITY_DEFAULT, NULL, theme_scanner_scan_themes_dir_ready, _data_);
#line 143 "../src/panel/settings/themes.vala"
					return FALSE;
#line 1313 "themes.c"
					_state_1:
#line 143 "../src/panel/settings/themes.vala"
					_data_->_tmp7_ = g_file_enumerate_children_finish (_data_->_tmp6_, _data_->_res_, &_data_->_inner_error0_);
#line 143 "../src/panel/settings/themes.vala"
					_data_->en = _data_->_tmp7_;
#line 143 "../src/panel/settings/themes.vala"
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 143 "../src/panel/settings/themes.vala"
						_g_object_unref0 (_data_->f);
#line 143 "../src/panel/settings/themes.vala"
						_g_free0 (_data_->full_path);
#line 143 "../src/panel/settings/themes.vala"
						_g_free0 (_data_->suffix);
#line 1327 "themes.c"
						goto __catch0_g_error;
					}
#line 144 "../src/panel/settings/themes.vala"
					while (TRUE) {
#line 145 "../src/panel/settings/themes.vala"
						_data_->_tmp8_ = _data_->en;
#line 145 "../src/panel/settings/themes.vala"
						_data_->_state_ = 2;
#line 145 "../src/panel/settings/themes.vala"
						g_file_enumerator_next_files_async (_data_->_tmp8_, 10, G_PRIORITY_DEFAULT, NULL, theme_scanner_scan_themes_dir_ready, _data_);
#line 145 "../src/panel/settings/themes.vala"
						return FALSE;
#line 1340 "themes.c"
						_state_2:
#line 145 "../src/panel/settings/themes.vala"
						_data_->_tmp9_ = g_file_enumerator_next_files_finish (_data_->_tmp8_, _data_->_res_, &_data_->_inner_error0_);
#line 145 "../src/panel/settings/themes.vala"
						_data_->files = _data_->_tmp9_;
#line 145 "../src/panel/settings/themes.vala"
						if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 145 "../src/panel/settings/themes.vala"
							_g_object_unref0 (_data_->en);
#line 145 "../src/panel/settings/themes.vala"
							_g_object_unref0 (_data_->f);
#line 145 "../src/panel/settings/themes.vala"
							_g_free0 (_data_->full_path);
#line 145 "../src/panel/settings/themes.vala"
							_g_free0 (_data_->suffix);
#line 1356 "themes.c"
							goto __catch0_g_error;
						}
#line 146 "../src/panel/settings/themes.vala"
						_data_->_tmp10_ = _data_->files;
#line 146 "../src/panel/settings/themes.vala"
						if (_data_->_tmp10_ == NULL) {
#line 147 "../src/panel/settings/themes.vala"
							(_data_->files == NULL) ? NULL : (_data_->files = (_g_list_free__g_object_unref0_ (_data_->files), NULL));
#line 147 "../src/panel/settings/themes.vala"
							break;
#line 1367 "themes.c"
						}
#line 150 "../src/panel/settings/themes.vala"
						_data_->_tmp11_ = _data_->files;
#line 1371 "themes.c"
						{
#line 150 "../src/panel/settings/themes.vala"
							_data_->file_collection = _data_->_tmp11_;
#line 150 "../src/panel/settings/themes.vala"
							for (_data_->file_it = _data_->file_collection; _data_->file_it != NULL; _data_->file_it = _data_->file_it->next) {
#line 150 "../src/panel/settings/themes.vala"
								_data_->_tmp12_ = _g_object_ref0 ((GFileInfo*) _data_->file_it->data);
#line 150 "../src/panel/settings/themes.vala"
								_data_->file = _data_->_tmp12_;
#line 1381 "themes.c"
								{
#line 151 "../src/panel/settings/themes.vala"
									_data_->_tmp13_ = _data_->file;
#line 151 "../src/panel/settings/themes.vala"
									_data_->_tmp14_ = g_file_info_get_display_name (_data_->_tmp13_);
#line 151 "../src/panel/settings/themes.vala"
									_data_->_tmp15_ = g_strdup (_data_->_tmp14_);
#line 151 "../src/panel/settings/themes.vala"
									_data_->display_path = _data_->_tmp15_;
#line 152 "../src/panel/settings/themes.vala"
									_data_->_tmp16_ = g_strdup (G_DIR_SEPARATOR_S);
#line 152 "../src/panel/settings/themes.vala"
									_data_->sep = _data_->_tmp16_;
#line 153 "../src/panel/settings/themes.vala"
									_data_->_tmp17_ = _data_->full_path;
#line 153 "../src/panel/settings/themes.vala"
									_data_->_tmp18_ = _data_->sep;
#line 153 "../src/panel/settings/themes.vala"
									_data_->_tmp19_ = _data_->display_path;
#line 153 "../src/panel/settings/themes.vala"
									_data_->_tmp20_ = g_strdup_printf ("%s%s%s", _data_->_tmp17_, _data_->_tmp18_, _data_->_tmp19_);
#line 153 "../src/panel/settings/themes.vala"
									_data_->path = _data_->_tmp20_;
#line 154 "../src/panel/settings/themes.vala"
									_data_->_tmp21_ = _data_->suffix;
#line 154 "../src/panel/settings/themes.vala"
									_data_->_tmp22_ = _data_->path;
#line 154 "../src/panel/settings/themes.vala"
									_data_->_tmp23_ = _data_->display_path;
#line 154 "../src/panel/settings/themes.vala"
									_data_->_state_ = 3;
#line 154 "../src/panel/settings/themes.vala"
									theme_scanner_scan_one (_data_->self, _data_->_tmp21_, _data_->_tmp22_, _data_->_tmp23_, theme_scanner_scan_themes_dir_ready, _data_);
#line 154 "../src/panel/settings/themes.vala"
									return FALSE;
#line 1417 "themes.c"
									_state_3:
#line 154 "../src/panel/settings/themes.vala"
									theme_scanner_scan_one_finish (_data_->self, _data_->_res_);
#line 150 "../src/panel/settings/themes.vala"
									_g_free0 (_data_->path);
#line 150 "../src/panel/settings/themes.vala"
									_g_free0 (_data_->sep);
#line 150 "../src/panel/settings/themes.vala"
									_g_free0 (_data_->display_path);
#line 150 "../src/panel/settings/themes.vala"
									_g_object_unref0 (_data_->file);
#line 1429 "themes.c"
								}
							}
						}
#line 144 "../src/panel/settings/themes.vala"
						(_data_->files == NULL) ? NULL : (_data_->files = (_g_list_free__g_object_unref0_ (_data_->files), NULL));
#line 1435 "themes.c"
					}
#line 135 "../src/panel/settings/themes.vala"
					_g_object_unref0 (_data_->en);
#line 135 "../src/panel/settings/themes.vala"
					_g_object_unref0 (_data_->f);
#line 135 "../src/panel/settings/themes.vala"
					_g_free0 (_data_->full_path);
#line 135 "../src/panel/settings/themes.vala"
					_g_free0 (_data_->suffix);
#line 1445 "themes.c"
				}
			}
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 134 "../src/panel/settings/themes.vala"
		_data_->e = _data_->_inner_error0_;
#line 134 "../src/panel/settings/themes.vala"
		_data_->_inner_error0_ = NULL;
#line 159 "../src/panel/settings/themes.vala"
		_data_->_tmp24_ = _data_->e;
#line 159 "../src/panel/settings/themes.vala"
		_data_->_tmp25_ = _data_->_tmp24_->message;
#line 159 "../src/panel/settings/themes.vala"
		g_message ("themes.vala:159: Error in scan_themes_dir: %s\n", _data_->_tmp25_);
#line 134 "../src/panel/settings/themes.vala"
		_g_error_free0 (_data_->e);
#line 1465 "themes.c"
	}
	__finally0:
#line 134 "../src/panel/settings/themes.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 134 "../src/panel/settings/themes.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 134 "../src/panel/settings/themes.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 134 "../src/panel/settings/themes.vala"
		g_object_unref (_data_->_async_result);
#line 134 "../src/panel/settings/themes.vala"
		return FALSE;
#line 1478 "themes.c"
	}
#line 129 "../src/panel/settings/themes.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 129 "../src/panel/settings/themes.vala"
	if (_data_->_state_ != 0) {
#line 129 "../src/panel/settings/themes.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 129 "../src/panel/settings/themes.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1488 "themes.c"
		}
	}
#line 129 "../src/panel/settings/themes.vala"
	g_object_unref (_data_->_async_result);
#line 129 "../src/panel/settings/themes.vala"
	return FALSE;
#line 1495 "themes.c"
}

static void
theme_scanner_scan_one_data_free (gpointer _data)
{
	ThemeScannerScanOneData* _data_;
	_data_ = _data;
#line 45 "../src/panel/settings/themes.vala"
	_g_free0 (_data_->path_type);
#line 45 "../src/panel/settings/themes.vala"
	_g_free0 (_data_->full_path);
#line 45 "../src/panel/settings/themes.vala"
	_g_free0 (_data_->display_name);
#line 45 "../src/panel/settings/themes.vala"
	_g_object_unref0 (_data_->self);
#line 45 "../src/panel/settings/themes.vala"
	g_slice_free (ThemeScannerScanOneData, _data_);
#line 1513 "themes.c"
}

static void
theme_scanner_scan_one (ThemeScanner* self,
                        const gchar* path_type,
                        const gchar* full_path,
                        const gchar* display_name,
                        GAsyncReadyCallback _callback_,
                        gpointer _user_data_)
{
	ThemeScannerScanOneData* _data_;
	ThemeScanner* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 45 "../src/panel/settings/themes.vala"
	g_return_if_fail (self != NULL);
#line 45 "../src/panel/settings/themes.vala"
	g_return_if_fail (path_type != NULL);
#line 45 "../src/panel/settings/themes.vala"
	g_return_if_fail (full_path != NULL);
#line 45 "../src/panel/settings/themes.vala"
	g_return_if_fail (display_name != NULL);
#line 45 "../src/panel/settings/themes.vala"
	_data_ = g_slice_new0 (ThemeScannerScanOneData);
#line 45 "../src/panel/settings/themes.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 45 "../src/panel/settings/themes.vala"
	g_task_set_task_data (_data_->_async_result, _data_, theme_scanner_scan_one_data_free);
#line 45 "../src/panel/settings/themes.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 45 "../src/panel/settings/themes.vala"
	_data_->self = _tmp0_;
#line 45 "../src/panel/settings/themes.vala"
	_tmp1_ = g_strdup (path_type);
#line 45 "../src/panel/settings/themes.vala"
	_g_free0 (_data_->path_type);
#line 45 "../src/panel/settings/themes.vala"
	_data_->path_type = _tmp1_;
#line 45 "../src/panel/settings/themes.vala"
	_tmp2_ = g_strdup (full_path);
#line 45 "../src/panel/settings/themes.vala"
	_g_free0 (_data_->full_path);
#line 45 "../src/panel/settings/themes.vala"
	_data_->full_path = _tmp2_;
#line 45 "../src/panel/settings/themes.vala"
	_tmp3_ = g_strdup (display_name);
#line 45 "../src/panel/settings/themes.vala"
	_g_free0 (_data_->display_name);
#line 45 "../src/panel/settings/themes.vala"
	_data_->display_name = _tmp3_;
#line 45 "../src/panel/settings/themes.vala"
	theme_scanner_scan_one_co (_data_);
#line 1567 "themes.c"
}

static void
theme_scanner_scan_one_finish (ThemeScanner* self,
                               GAsyncResult* _res_)
{
	ThemeScannerScanOneData* _data_;
#line 45 "../src/panel/settings/themes.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1577 "themes.c"
}

/**
 * Scan one directory with the given type, i.e. "icons", or "themes"
 */
static void
theme_scanner_scan_one_ready (GObject* source_object,
                              GAsyncResult* _res_,
                              gpointer _user_data_)
{
	ThemeScannerScanOneData* _data_;
#line 175 "../src/panel/settings/themes.vala"
	_data_ = _user_data_;
#line 175 "../src/panel/settings/themes.vala"
	_data_->_source_object_ = source_object;
#line 175 "../src/panel/settings/themes.vala"
	_data_->_res_ = _res_;
#line 175 "../src/panel/settings/themes.vala"
	theme_scanner_scan_one_co (_data_);
#line 1597 "themes.c"
}

static gboolean
theme_scanner_scan_one_co (ThemeScannerScanOneData* _data_)
{
#line 166 "../src/panel/settings/themes.vala"
	switch (_data_->_state_) {
#line 166 "../src/panel/settings/themes.vala"
		case 0:
#line 1607 "themes.c"
		goto _state_0;
#line 166 "../src/panel/settings/themes.vala"
		case 1:
#line 1611 "themes.c"
		goto _state_1;
#line 166 "../src/panel/settings/themes.vala"
		case 2:
#line 1615 "themes.c"
		goto _state_2;
		default:
#line 166 "../src/panel/settings/themes.vala"
		g_assert_not_reached ();
#line 1620 "themes.c"
	}
	_state_0:
#line 167 "../src/panel/settings/themes.vala"
	_data_->gtk_theme = FALSE;
#line 168 "../src/panel/settings/themes.vala"
	if (g_strcmp0 (_data_->path_type, "themes") == 0) {
#line 168 "../src/panel/settings/themes.vala"
		_data_->_tmp0_ = TRUE;
#line 1629 "themes.c"
	} else {
#line 168 "../src/panel/settings/themes.vala"
		_data_->_tmp0_ = g_strcmp0 (_data_->path_type, ".themes") == 0;
#line 1633 "themes.c"
	}
#line 168 "../src/panel/settings/themes.vala"
	if (_data_->_tmp0_) {
#line 169 "../src/panel/settings/themes.vala"
		_data_->gtk_theme = TRUE;
#line 1639 "themes.c"
	}
#line 172 "../src/panel/settings/themes.vala"
	if (_data_->gtk_theme) {
#line 173 "../src/panel/settings/themes.vala"
		_data_->_tmp1_ = _data_->self->priv->gtk_theme_paths;
#line 173 "../src/panel/settings/themes.vala"
		_data_->_tmp1__length1 = _data_->self->priv->gtk_theme_paths_length1;
#line 1647 "themes.c"
		{
#line 173 "../src/panel/settings/themes.vala"
			_data_->suffix_collection_length1 = 0;
#line 173 "../src/panel/settings/themes.vala"
			_data_->_suffix_collection_size_ = 0;
#line 173 "../src/panel/settings/themes.vala"
			_data_->suffix_collection = _data_->_tmp1_;
#line 173 "../src/panel/settings/themes.vala"
			_data_->suffix_collection_length1 = _data_->_tmp1__length1;
#line 173 "../src/panel/settings/themes.vala"
			for (_data_->suffix_it = 0; _data_->suffix_it < _data_->suffix_collection_length1; _data_->suffix_it = _data_->suffix_it + 1) {
#line 173 "../src/panel/settings/themes.vala"
				_data_->_tmp2_ = g_strdup (_data_->suffix_collection[_data_->suffix_it]);
#line 173 "../src/panel/settings/themes.vala"
				_data_->suffix = _data_->_tmp2_;
#line 1663 "themes.c"
				{
#line 174 "../src/panel/settings/themes.vala"
					_data_->_tmp3_ = _data_->suffix;
#line 174 "../src/panel/settings/themes.vala"
					_data_->_tmp4_ = g_strdup_printf ("%s%s%s", _data_->full_path, G_DIR_SEPARATOR_S, _data_->_tmp3_);
#line 174 "../src/panel/settings/themes.vala"
					_data_->path = _data_->_tmp4_;
#line 175 "../src/panel/settings/themes.vala"
					_data_->_tmp5_ = _data_->path;
#line 175 "../src/panel/settings/themes.vala"
					_data_->_state_ = 1;
#line 175 "../src/panel/settings/themes.vala"
					theme_scanner_maybe_add_gtk_theme (_data_->self, _data_->_tmp5_, _data_->display_name, theme_scanner_scan_one_ready, _data_);
#line 175 "../src/panel/settings/themes.vala"
					return FALSE;
#line 1679 "themes.c"
					_state_1:
#line 175 "../src/panel/settings/themes.vala"
					_data_->added = theme_scanner_maybe_add_gtk_theme_finish (_data_->self, _data_->_res_);
#line 176 "../src/panel/settings/themes.vala"
					if (_data_->added) {
#line 177 "../src/panel/settings/themes.vala"
						_g_free0 (_data_->path);
#line 177 "../src/panel/settings/themes.vala"
						_g_free0 (_data_->suffix);
#line 177 "../src/panel/settings/themes.vala"
						g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 177 "../src/panel/settings/themes.vala"
						if (_data_->_state_ != 0) {
#line 177 "../src/panel/settings/themes.vala"
							while (!g_task_get_completed (_data_->_async_result)) {
#line 177 "../src/panel/settings/themes.vala"
								g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1697 "themes.c"
							}
						}
#line 177 "../src/panel/settings/themes.vala"
						g_object_unref (_data_->_async_result);
#line 177 "../src/panel/settings/themes.vala"
						return FALSE;
#line 1704 "themes.c"
					}
#line 173 "../src/panel/settings/themes.vala"
					_g_free0 (_data_->path);
#line 173 "../src/panel/settings/themes.vala"
					_g_free0 (_data_->suffix);
#line 1710 "themes.c"
				}
			}
		}
	} else {
#line 182 "../src/panel/settings/themes.vala"
		_data_->_state_ = 2;
#line 182 "../src/panel/settings/themes.vala"
		theme_scanner_maybe_add_icon_theme (_data_->self, _data_->full_path, _data_->display_name, theme_scanner_scan_one_ready, _data_);
#line 182 "../src/panel/settings/themes.vala"
		return FALSE;
#line 1721 "themes.c"
		_state_2:
#line 182 "../src/panel/settings/themes.vala"
		theme_scanner_maybe_add_icon_theme_finish (_data_->self, _data_->_res_);
#line 1725 "themes.c"
	}
#line 166 "../src/panel/settings/themes.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 166 "../src/panel/settings/themes.vala"
	if (_data_->_state_ != 0) {
#line 166 "../src/panel/settings/themes.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 166 "../src/panel/settings/themes.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1735 "themes.c"
		}
	}
#line 166 "../src/panel/settings/themes.vala"
	g_object_unref (_data_->_async_result);
#line 166 "../src/panel/settings/themes.vala"
	return FALSE;
#line 1742 "themes.c"
}

static void
theme_scanner_maybe_add_gtk_theme_data_free (gpointer _data)
{
	ThemeScannerMaybeAddGtkThemeData* _data_;
	_data_ = _data;
#line 45 "../src/panel/settings/themes.vala"
	_g_free0 (_data_->path);
#line 45 "../src/panel/settings/themes.vala"
	_g_free0 (_data_->theme_name);
#line 45 "../src/panel/settings/themes.vala"
	_g_object_unref0 (_data_->self);
#line 45 "../src/panel/settings/themes.vala"
	g_slice_free (ThemeScannerMaybeAddGtkThemeData, _data_);
#line 1758 "themes.c"
}

static void
theme_scanner_maybe_add_gtk_theme (ThemeScanner* self,
                                   const gchar* path,
                                   const gchar* theme_name,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_)
{
	ThemeScannerMaybeAddGtkThemeData* _data_;
	ThemeScanner* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 45 "../src/panel/settings/themes.vala"
	g_return_if_fail (self != NULL);
#line 45 "../src/panel/settings/themes.vala"
	g_return_if_fail (path != NULL);
#line 45 "../src/panel/settings/themes.vala"
	g_return_if_fail (theme_name != NULL);
#line 45 "../src/panel/settings/themes.vala"
	_data_ = g_slice_new0 (ThemeScannerMaybeAddGtkThemeData);
#line 45 "../src/panel/settings/themes.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 45 "../src/panel/settings/themes.vala"
	g_task_set_task_data (_data_->_async_result, _data_, theme_scanner_maybe_add_gtk_theme_data_free);
#line 45 "../src/panel/settings/themes.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 45 "../src/panel/settings/themes.vala"
	_data_->self = _tmp0_;
#line 45 "../src/panel/settings/themes.vala"
	_tmp1_ = g_strdup (path);
#line 45 "../src/panel/settings/themes.vala"
	_g_free0 (_data_->path);
#line 45 "../src/panel/settings/themes.vala"
	_data_->path = _tmp1_;
#line 45 "../src/panel/settings/themes.vala"
	_tmp2_ = g_strdup (theme_name);
#line 45 "../src/panel/settings/themes.vala"
	_g_free0 (_data_->theme_name);
#line 45 "../src/panel/settings/themes.vala"
	_data_->theme_name = _tmp2_;
#line 45 "../src/panel/settings/themes.vala"
	theme_scanner_maybe_add_gtk_theme_co (_data_);
#line 1802 "themes.c"
}

static gboolean
theme_scanner_maybe_add_gtk_theme_finish (ThemeScanner* self,
                                          GAsyncResult* _res_)
{
	gboolean result;
	ThemeScannerMaybeAddGtkThemeData* _data_;
#line 45 "../src/panel/settings/themes.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 45 "../src/panel/settings/themes.vala"
	result = _data_->result;
#line 45 "../src/panel/settings/themes.vala"
	return result;
#line 1817 "themes.c"
}

/**
 * Attempt to add a unique theme into the set
 */
static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1184 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1184 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1185 "glib-2.0.vapi"
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1185 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1187 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1187 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 1844 "themes.c"
		gchar* _tmp2_;
#line 1188 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1188 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1188 "glib-2.0.vapi"
		return result;
#line 1852 "themes.c"
	} else {
#line 1190 "glib-2.0.vapi"
		result = -1;
#line 1190 "glib-2.0.vapi"
		return result;
#line 1858 "themes.c"
	}
}

static gboolean
theme_scanner_maybe_add_gtk_theme_co (ThemeScannerMaybeAddGtkThemeData* _data_)
{
#line 189 "../src/panel/settings/themes.vala"
	switch (_data_->_state_) {
#line 189 "../src/panel/settings/themes.vala"
		case 0:
#line 1869 "themes.c"
		goto _state_0;
		default:
#line 189 "../src/panel/settings/themes.vala"
		g_assert_not_reached ();
#line 1874 "themes.c"
	}
	_state_0:
	{
#line 190 "../src/panel/settings/themes.vala"
		_data_->index = 0;
#line 1880 "themes.c"
		{
#line 190 "../src/panel/settings/themes.vala"
			_data_->_tmp0_ = TRUE;
#line 190 "../src/panel/settings/themes.vala"
			while (TRUE) {
#line 190 "../src/panel/settings/themes.vala"
				if (!_data_->_tmp0_) {
#line 190 "../src/panel/settings/themes.vala"
					_data_->_tmp1_ = _data_->index;
#line 190 "../src/panel/settings/themes.vala"
					_data_->index = _data_->_tmp1_ + 1;
#line 1892 "themes.c"
				}
#line 190 "../src/panel/settings/themes.vala"
				_data_->_tmp0_ = FALSE;
#line 190 "../src/panel/settings/themes.vala"
				_data_->_tmp2_ = _data_->self->priv->gtk_theme_blacklist;
#line 190 "../src/panel/settings/themes.vala"
				_data_->_tmp2__length1 = _data_->self->priv->gtk_theme_blacklist_length1;
#line 190 "../src/panel/settings/themes.vala"
				if (!(_data_->index < _data_->_tmp2__length1)) {
#line 190 "../src/panel/settings/themes.vala"
					break;
#line 1904 "themes.c"
				}
#line 191 "../src/panel/settings/themes.vala"
				_data_->_tmp3_ = _data_->self->priv->gtk_theme_blacklist;
#line 191 "../src/panel/settings/themes.vala"
				_data_->_tmp3__length1 = _data_->self->priv->gtk_theme_blacklist_length1;
#line 191 "../src/panel/settings/themes.vala"
				_data_->_tmp4_ = _data_->_tmp3_[_data_->index];
#line 191 "../src/panel/settings/themes.vala"
				_data_->_tmp5_ = g_strdup (_data_->_tmp4_);
#line 191 "../src/panel/settings/themes.vala"
				_data_->blacklisted_item = _data_->_tmp5_;
#line 193 "../src/panel/settings/themes.vala"
				_data_->_tmp7_ = _data_->blacklisted_item;
#line 193 "../src/panel/settings/themes.vala"
				if (g_strcmp0 (_data_->_tmp7_, _data_->theme_name) == 0) {
#line 193 "../src/panel/settings/themes.vala"
					_data_->_tmp6_ = TRUE;
#line 1922 "themes.c"
				} else {
#line 193 "../src/panel/settings/themes.vala"
					_data_->_tmp8_ = _data_->blacklisted_item;
#line 193 "../src/panel/settings/themes.vala"
					_data_->_tmp6_ = string_index_of (_data_->theme_name, _data_->_tmp8_, 0) != -1;
#line 1928 "themes.c"
				}
#line 193 "../src/panel/settings/themes.vala"
				if (_data_->_tmp6_) {
#line 194 "../src/panel/settings/themes.vala"
					_data_->result = FALSE;
#line 194 "../src/panel/settings/themes.vala"
					_g_free0 (_data_->blacklisted_item);
#line 194 "../src/panel/settings/themes.vala"
					g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 194 "../src/panel/settings/themes.vala"
					if (_data_->_state_ != 0) {
#line 194 "../src/panel/settings/themes.vala"
						while (!g_task_get_completed (_data_->_async_result)) {
#line 194 "../src/panel/settings/themes.vala"
							g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1944 "themes.c"
						}
					}
#line 194 "../src/panel/settings/themes.vala"
					g_object_unref (_data_->_async_result);
#line 194 "../src/panel/settings/themes.vala"
					return FALSE;
#line 1951 "themes.c"
				}
#line 190 "../src/panel/settings/themes.vala"
				_g_free0 (_data_->blacklisted_item);
#line 1955 "themes.c"
			}
		}
	}
#line 198 "../src/panel/settings/themes.vala"
	_data_->_tmp9_ = _data_->self->priv->gtk_themes;
#line 198 "../src/panel/settings/themes.vala"
	_data_->_tmp10_ = g_hash_table_lookup (_data_->_tmp9_, _data_->theme_name);
#line 198 "../src/panel/settings/themes.vala"
	_data_->info = (ThemeInfo*) _data_->_tmp10_;
#line 199 "../src/panel/settings/themes.vala"
	_data_->_tmp11_ = _data_->info;
#line 199 "../src/panel/settings/themes.vala"
	if (_data_->_tmp11_ == NULL) {
#line 200 "../src/panel/settings/themes.vala"
		_data_->_tmp12_ = theme_info_new (THEME_TYPE_GTK_THEME);
#line 200 "../src/panel/settings/themes.vala"
		_data_->ninfo = _data_->_tmp12_;
#line 201 "../src/panel/settings/themes.vala"
		_data_->_tmp13_ = _data_->self->priv->gtk_themes;
#line 201 "../src/panel/settings/themes.vala"
		_data_->_tmp14_ = g_strdup (_data_->theme_name);
#line 201 "../src/panel/settings/themes.vala"
		_data_->_tmp15_ = _data_->ninfo;
#line 201 "../src/panel/settings/themes.vala"
		_data_->_tmp16_ = _g_object_ref0 (_data_->_tmp15_);
#line 201 "../src/panel/settings/themes.vala"
		g_hash_table_insert (_data_->_tmp13_, _data_->_tmp14_, _data_->_tmp16_);
#line 202 "../src/panel/settings/themes.vala"
		_data_->_tmp17_ = _data_->self->priv->gtk_themes;
#line 202 "../src/panel/settings/themes.vala"
		_data_->_tmp18_ = g_hash_table_lookup (_data_->_tmp17_, _data_->theme_name);
#line 202 "../src/panel/settings/themes.vala"
		_data_->info = (ThemeInfo*) _data_->_tmp18_;
#line 199 "../src/panel/settings/themes.vala"
		_g_object_unref0 (_data_->ninfo);
#line 1991 "themes.c"
	}
#line 204 "../src/panel/settings/themes.vala"
	_data_->_tmp19_ = _data_->info;
#line 204 "../src/panel/settings/themes.vala"
	if (theme_info_add_path (_data_->_tmp19_, _data_->path)) {
#line 205 "../src/panel/settings/themes.vala"
		_data_->result = TRUE;
#line 205 "../src/panel/settings/themes.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 205 "../src/panel/settings/themes.vala"
		if (_data_->_state_ != 0) {
#line 205 "../src/panel/settings/themes.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 205 "../src/panel/settings/themes.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2007 "themes.c"
			}
		}
#line 205 "../src/panel/settings/themes.vala"
		g_object_unref (_data_->_async_result);
#line 205 "../src/panel/settings/themes.vala"
		return FALSE;
#line 2014 "themes.c"
	}
#line 207 "../src/panel/settings/themes.vala"
	_data_->result = FALSE;
#line 207 "../src/panel/settings/themes.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 207 "../src/panel/settings/themes.vala"
	if (_data_->_state_ != 0) {
#line 207 "../src/panel/settings/themes.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 207 "../src/panel/settings/themes.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2026 "themes.c"
		}
	}
#line 207 "../src/panel/settings/themes.vala"
	g_object_unref (_data_->_async_result);
#line 207 "../src/panel/settings/themes.vala"
	return FALSE;
#line 2033 "themes.c"
}

/**
 * Return a unique list of currently known gtk themes
 */
static void
_vala_array_add6 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 220 "../src/panel/settings/themes.vala"
	if ((*length) == (*size)) {
#line 220 "../src/panel/settings/themes.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 220 "../src/panel/settings/themes.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2051 "themes.c"
	}
#line 220 "../src/panel/settings/themes.vala"
	(*array)[(*length)++] = value;
#line 220 "../src/panel/settings/themes.vala"
	(*array)[*length] = NULL;
#line 2057 "themes.c"
}

gchar**
theme_scanner_get_gtk_themes (ThemeScanner* self,
                              gint* result_length1)
{
	gchar** t = NULL;
	gchar** _tmp0_;
	gint t_length1;
	gint _t_size_;
	const gchar* name = NULL;
	ThemeInfo* info = NULL;
	GHashTableIter iter = {0};
	GHashTable* _tmp1_;
	gchar** _tmp7_;
	gint _tmp7__length1;
	gchar** result;
#line 213 "../src/panel/settings/themes.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 214 "../src/panel/settings/themes.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 214 "../src/panel/settings/themes.vala"
	t = _tmp0_;
#line 214 "../src/panel/settings/themes.vala"
	t_length1 = 0;
#line 214 "../src/panel/settings/themes.vala"
	_t_size_ = t_length1;
#line 215 "../src/panel/settings/themes.vala"
	name = NULL;
#line 216 "../src/panel/settings/themes.vala"
	info = NULL;
#line 218 "../src/panel/settings/themes.vala"
	_tmp1_ = self->priv->gtk_themes;
#line 218 "../src/panel/settings/themes.vala"
	g_hash_table_iter_init (&iter, _tmp1_);
#line 219 "../src/panel/settings/themes.vala"
	while (TRUE) {
#line 2095 "themes.c"
		gconstpointer _tmp2_ = NULL;
		gconstpointer _tmp3_ = NULL;
		gboolean _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 219 "../src/panel/settings/themes.vala"
		_tmp4_ = g_hash_table_iter_next (&iter, (gpointer*) (&_tmp2_), (gpointer*) (&_tmp3_));
#line 219 "../src/panel/settings/themes.vala"
		name = (const gchar*) _tmp2_;
#line 219 "../src/panel/settings/themes.vala"
		info = (ThemeInfo*) _tmp3_;
#line 219 "../src/panel/settings/themes.vala"
		if (!_tmp4_) {
#line 219 "../src/panel/settings/themes.vala"
			break;
#line 2111 "themes.c"
		}
#line 220 "../src/panel/settings/themes.vala"
		_tmp5_ = name;
#line 220 "../src/panel/settings/themes.vala"
		_tmp6_ = g_strconcat ("", _tmp5_, NULL);
#line 220 "../src/panel/settings/themes.vala"
		_vala_array_add6 (&t, &t_length1, &_t_size_, _tmp6_);
#line 2119 "themes.c"
	}
#line 222 "../src/panel/settings/themes.vala"
	_tmp7_ = t;
#line 222 "../src/panel/settings/themes.vala"
	_tmp7__length1 = t_length1;
#line 222 "../src/panel/settings/themes.vala"
	if (result_length1) {
#line 222 "../src/panel/settings/themes.vala"
		*result_length1 = _tmp7__length1;
#line 2129 "themes.c"
	}
#line 222 "../src/panel/settings/themes.vala"
	result = _tmp7_;
#line 222 "../src/panel/settings/themes.vala"
	return result;
#line 2135 "themes.c"
}

/**
 * Return a unique list of currently known cursor themes
 */
static void
_vala_array_add7 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 235 "../src/panel/settings/themes.vala"
	if ((*length) == (*size)) {
#line 235 "../src/panel/settings/themes.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 235 "../src/panel/settings/themes.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2153 "themes.c"
	}
#line 235 "../src/panel/settings/themes.vala"
	(*array)[(*length)++] = value;
#line 235 "../src/panel/settings/themes.vala"
	(*array)[*length] = NULL;
#line 2159 "themes.c"
}

gchar**
theme_scanner_get_cursor_themes (ThemeScanner* self,
                                 gint* result_length1)
{
	gchar** t = NULL;
	gchar** _tmp0_;
	gint t_length1;
	gint _t_size_;
	const gchar* name = NULL;
	ThemeInfo* info = NULL;
	GHashTableIter iter = {0};
	GHashTable* _tmp1_;
	gchar** _tmp7_;
	gint _tmp7__length1;
	gchar** result;
#line 228 "../src/panel/settings/themes.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 229 "../src/panel/settings/themes.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 229 "../src/panel/settings/themes.vala"
	t = _tmp0_;
#line 229 "../src/panel/settings/themes.vala"
	t_length1 = 0;
#line 229 "../src/panel/settings/themes.vala"
	_t_size_ = t_length1;
#line 230 "../src/panel/settings/themes.vala"
	name = NULL;
#line 231 "../src/panel/settings/themes.vala"
	info = NULL;
#line 233 "../src/panel/settings/themes.vala"
	_tmp1_ = self->priv->cursor_themes;
#line 233 "../src/panel/settings/themes.vala"
	g_hash_table_iter_init (&iter, _tmp1_);
#line 234 "../src/panel/settings/themes.vala"
	while (TRUE) {
#line 2197 "themes.c"
		gconstpointer _tmp2_ = NULL;
		gconstpointer _tmp3_ = NULL;
		gboolean _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 234 "../src/panel/settings/themes.vala"
		_tmp4_ = g_hash_table_iter_next (&iter, (gpointer*) (&_tmp2_), (gpointer*) (&_tmp3_));
#line 234 "../src/panel/settings/themes.vala"
		name = (const gchar*) _tmp2_;
#line 234 "../src/panel/settings/themes.vala"
		info = (ThemeInfo*) _tmp3_;
#line 234 "../src/panel/settings/themes.vala"
		if (!_tmp4_) {
#line 234 "../src/panel/settings/themes.vala"
			break;
#line 2213 "themes.c"
		}
#line 235 "../src/panel/settings/themes.vala"
		_tmp5_ = name;
#line 235 "../src/panel/settings/themes.vala"
		_tmp6_ = g_strconcat ("", _tmp5_, NULL);
#line 235 "../src/panel/settings/themes.vala"
		_vala_array_add7 (&t, &t_length1, &_t_size_, _tmp6_);
#line 2221 "themes.c"
	}
#line 237 "../src/panel/settings/themes.vala"
	_tmp7_ = t;
#line 237 "../src/panel/settings/themes.vala"
	_tmp7__length1 = t_length1;
#line 237 "../src/panel/settings/themes.vala"
	if (result_length1) {
#line 237 "../src/panel/settings/themes.vala"
		*result_length1 = _tmp7__length1;
#line 2231 "themes.c"
	}
#line 237 "../src/panel/settings/themes.vala"
	result = _tmp7_;
#line 237 "../src/panel/settings/themes.vala"
	return result;
#line 2237 "themes.c"
}

/**
 * Return a unique list of currently known icon themes
 */
static void
_vala_array_add8 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 250 "../src/panel/settings/themes.vala"
	if ((*length) == (*size)) {
#line 250 "../src/panel/settings/themes.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 250 "../src/panel/settings/themes.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2255 "themes.c"
	}
#line 250 "../src/panel/settings/themes.vala"
	(*array)[(*length)++] = value;
#line 250 "../src/panel/settings/themes.vala"
	(*array)[*length] = NULL;
#line 2261 "themes.c"
}

gchar**
theme_scanner_get_icon_themes (ThemeScanner* self,
                               gint* result_length1)
{
	gchar** t = NULL;
	gchar** _tmp0_;
	gint t_length1;
	gint _t_size_;
	const gchar* name = NULL;
	ThemeInfo* info = NULL;
	GHashTableIter iter = {0};
	GHashTable* _tmp1_;
	gchar** _tmp7_;
	gint _tmp7__length1;
	gchar** result;
#line 243 "../src/panel/settings/themes.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 244 "../src/panel/settings/themes.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 244 "../src/panel/settings/themes.vala"
	t = _tmp0_;
#line 244 "../src/panel/settings/themes.vala"
	t_length1 = 0;
#line 244 "../src/panel/settings/themes.vala"
	_t_size_ = t_length1;
#line 245 "../src/panel/settings/themes.vala"
	name = NULL;
#line 246 "../src/panel/settings/themes.vala"
	info = NULL;
#line 248 "../src/panel/settings/themes.vala"
	_tmp1_ = self->priv->icon_themes;
#line 248 "../src/panel/settings/themes.vala"
	g_hash_table_iter_init (&iter, _tmp1_);
#line 249 "../src/panel/settings/themes.vala"
	while (TRUE) {
#line 2299 "themes.c"
		gconstpointer _tmp2_ = NULL;
		gconstpointer _tmp3_ = NULL;
		gboolean _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 249 "../src/panel/settings/themes.vala"
		_tmp4_ = g_hash_table_iter_next (&iter, (gpointer*) (&_tmp2_), (gpointer*) (&_tmp3_));
#line 249 "../src/panel/settings/themes.vala"
		name = (const gchar*) _tmp2_;
#line 249 "../src/panel/settings/themes.vala"
		info = (ThemeInfo*) _tmp3_;
#line 249 "../src/panel/settings/themes.vala"
		if (!_tmp4_) {
#line 249 "../src/panel/settings/themes.vala"
			break;
#line 2315 "themes.c"
		}
#line 250 "../src/panel/settings/themes.vala"
		_tmp5_ = name;
#line 250 "../src/panel/settings/themes.vala"
		_tmp6_ = g_strconcat ("", _tmp5_, NULL);
#line 250 "../src/panel/settings/themes.vala"
		_vala_array_add8 (&t, &t_length1, &_t_size_, _tmp6_);
#line 2323 "themes.c"
	}
#line 252 "../src/panel/settings/themes.vala"
	_tmp7_ = t;
#line 252 "../src/panel/settings/themes.vala"
	_tmp7__length1 = t_length1;
#line 252 "../src/panel/settings/themes.vala"
	if (result_length1) {
#line 252 "../src/panel/settings/themes.vala"
		*result_length1 = _tmp7__length1;
#line 2333 "themes.c"
	}
#line 252 "../src/panel/settings/themes.vala"
	result = _tmp7_;
#line 252 "../src/panel/settings/themes.vala"
	return result;
#line 2339 "themes.c"
}

static void
theme_scanner_maybe_add_icon_theme_data_free (gpointer _data)
{
	ThemeScannerMaybeAddIconThemeData* _data_;
	_data_ = _data;
#line 45 "../src/panel/settings/themes.vala"
	_g_free0 (_data_->path);
#line 45 "../src/panel/settings/themes.vala"
	_g_free0 (_data_->theme_name);
#line 45 "../src/panel/settings/themes.vala"
	_g_object_unref0 (_data_->self);
#line 45 "../src/panel/settings/themes.vala"
	g_slice_free (ThemeScannerMaybeAddIconThemeData, _data_);
#line 2355 "themes.c"
}

static void
theme_scanner_maybe_add_icon_theme (ThemeScanner* self,
                                    const gchar* path,
                                    const gchar* theme_name,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	ThemeScannerMaybeAddIconThemeData* _data_;
	ThemeScanner* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 45 "../src/panel/settings/themes.vala"
	g_return_if_fail (self != NULL);
#line 45 "../src/panel/settings/themes.vala"
	g_return_if_fail (path != NULL);
#line 45 "../src/panel/settings/themes.vala"
	g_return_if_fail (theme_name != NULL);
#line 45 "../src/panel/settings/themes.vala"
	_data_ = g_slice_new0 (ThemeScannerMaybeAddIconThemeData);
#line 45 "../src/panel/settings/themes.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 45 "../src/panel/settings/themes.vala"
	g_task_set_task_data (_data_->_async_result, _data_, theme_scanner_maybe_add_icon_theme_data_free);
#line 45 "../src/panel/settings/themes.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 45 "../src/panel/settings/themes.vala"
	_data_->self = _tmp0_;
#line 45 "../src/panel/settings/themes.vala"
	_tmp1_ = g_strdup (path);
#line 45 "../src/panel/settings/themes.vala"
	_g_free0 (_data_->path);
#line 45 "../src/panel/settings/themes.vala"
	_data_->path = _tmp1_;
#line 45 "../src/panel/settings/themes.vala"
	_tmp2_ = g_strdup (theme_name);
#line 45 "../src/panel/settings/themes.vala"
	_g_free0 (_data_->theme_name);
#line 45 "../src/panel/settings/themes.vala"
	_data_->theme_name = _tmp2_;
#line 45 "../src/panel/settings/themes.vala"
	theme_scanner_maybe_add_icon_theme_co (_data_);
#line 2399 "themes.c"
}

static void
theme_scanner_maybe_add_icon_theme_finish (ThemeScanner* self,
                                           GAsyncResult* _res_)
{
	ThemeScannerMaybeAddIconThemeData* _data_;
#line 45 "../src/panel/settings/themes.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2409 "themes.c"
}

/**
 * Attempt to add cursor/icon theme to the set
 */
static void
theme_scanner_maybe_add_icon_theme_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_)
{
	ThemeScannerMaybeAddIconThemeData* _data_;
#line 282 "../src/panel/settings/themes.vala"
	_data_ = _user_data_;
#line 282 "../src/panel/settings/themes.vala"
	_data_->_source_object_ = source_object;
#line 282 "../src/panel/settings/themes.vala"
	_data_->_res_ = _res_;
#line 282 "../src/panel/settings/themes.vala"
	theme_scanner_maybe_add_icon_theme_co (_data_);
#line 2429 "themes.c"
}

static gboolean
theme_scanner_maybe_add_icon_theme_co (ThemeScannerMaybeAddIconThemeData* _data_)
{
#line 258 "../src/panel/settings/themes.vala"
	switch (_data_->_state_) {
#line 258 "../src/panel/settings/themes.vala"
		case 0:
#line 2439 "themes.c"
		goto _state_0;
#line 258 "../src/panel/settings/themes.vala"
		case 1:
#line 2443 "themes.c"
		goto _state_1;
#line 258 "../src/panel/settings/themes.vala"
		case 2:
#line 2447 "themes.c"
		goto _state_2;
		default:
#line 258 "../src/panel/settings/themes.vala"
		g_assert_not_reached ();
#line 2452 "themes.c"
	}
	_state_0:
#line 259 "../src/panel/settings/themes.vala"
	_data_->_tmp0_ = g_strdup_printf ("%s%s%s", _data_->path, G_DIR_SEPARATOR_S, "index.theme");
#line 259 "../src/panel/settings/themes.vala"
	_data_->test_path = _data_->_tmp0_;
#line 260 "../src/panel/settings/themes.vala"
	_data_->_tmp1_ = _data_->test_path;
#line 260 "../src/panel/settings/themes.vala"
	if (!g_file_test (_data_->_tmp1_, G_FILE_TEST_EXISTS)) {
#line 261 "../src/panel/settings/themes.vala"
		_g_free0 (_data_->test_path);
#line 261 "../src/panel/settings/themes.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 261 "../src/panel/settings/themes.vala"
		if (_data_->_state_ != 0) {
#line 261 "../src/panel/settings/themes.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 261 "../src/panel/settings/themes.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2473 "themes.c"
			}
		}
#line 261 "../src/panel/settings/themes.vala"
		g_object_unref (_data_->_async_result);
#line 261 "../src/panel/settings/themes.vala"
		return FALSE;
#line 2480 "themes.c"
	}
#line 263 "../src/panel/settings/themes.vala"
	_data_->icon_theme = TRUE;
#line 265 "../src/panel/settings/themes.vala"
	_data_->_tmp2_ = g_key_file_new ();
#line 265 "../src/panel/settings/themes.vala"
	_data_->f = _data_->_tmp2_;
#line 2488 "themes.c"
	{
#line 268 "../src/panel/settings/themes.vala"
		_data_->_tmp3_ = _data_->f;
#line 268 "../src/panel/settings/themes.vala"
		_data_->_tmp4_ = _data_->test_path;
#line 268 "../src/panel/settings/themes.vala"
		g_key_file_load_from_file (_data_->_tmp3_, _data_->_tmp4_, G_KEY_FILE_NONE, &_data_->_inner_error0_);
#line 268 "../src/panel/settings/themes.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2498 "themes.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 267 "../src/panel/settings/themes.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 270 "../src/panel/settings/themes.vala"
		_g_key_file_unref0 (_data_->f);
#line 270 "../src/panel/settings/themes.vala"
		_g_free0 (_data_->test_path);
#line 270 "../src/panel/settings/themes.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 270 "../src/panel/settings/themes.vala"
		if (_data_->_state_ != 0) {
#line 270 "../src/panel/settings/themes.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 270 "../src/panel/settings/themes.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2519 "themes.c"
			}
		}
#line 270 "../src/panel/settings/themes.vala"
		g_object_unref (_data_->_async_result);
#line 270 "../src/panel/settings/themes.vala"
		return FALSE;
#line 2526 "themes.c"
	}
	__finally0:
#line 267 "../src/panel/settings/themes.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 267 "../src/panel/settings/themes.vala"
		_g_key_file_unref0 (_data_->f);
#line 267 "../src/panel/settings/themes.vala"
		_g_free0 (_data_->test_path);
#line 267 "../src/panel/settings/themes.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 267 "../src/panel/settings/themes.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 267 "../src/panel/settings/themes.vala"
		g_object_unref (_data_->_async_result);
#line 267 "../src/panel/settings/themes.vala"
		return FALSE;
#line 2543 "themes.c"
	}
	{
#line 274 "../src/panel/settings/themes.vala"
		_data_->_tmp6_ = _data_->f;
#line 274 "../src/panel/settings/themes.vala"
		_data_->_tmp5_ = g_key_file_has_key (_data_->_tmp6_, "Icon Theme", "Directories", &_data_->_inner_error0_);
#line 274 "../src/panel/settings/themes.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2552 "themes.c"
			goto __catch1_g_error;
		}
#line 274 "../src/panel/settings/themes.vala"
		if (!_data_->_tmp5_) {
#line 275 "../src/panel/settings/themes.vala"
			_data_->icon_theme = FALSE;
#line 2559 "themes.c"
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
#line 273 "../src/panel/settings/themes.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 278 "../src/panel/settings/themes.vala"
		_data_->icon_theme = FALSE;
#line 2569 "themes.c"
	}
	__finally1:
#line 273 "../src/panel/settings/themes.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 273 "../src/panel/settings/themes.vala"
		_g_key_file_unref0 (_data_->f);
#line 273 "../src/panel/settings/themes.vala"
		_g_free0 (_data_->test_path);
#line 273 "../src/panel/settings/themes.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 273 "../src/panel/settings/themes.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 273 "../src/panel/settings/themes.vala"
		g_object_unref (_data_->_async_result);
#line 273 "../src/panel/settings/themes.vala"
		return FALSE;
#line 2586 "themes.c"
	}
#line 281 "../src/panel/settings/themes.vala"
	if (_data_->icon_theme) {
#line 282 "../src/panel/settings/themes.vala"
		_data_->_state_ = 1;
#line 282 "../src/panel/settings/themes.vala"
		theme_scanner_maybe_add_icons (_data_->self, _data_->path, _data_->theme_name, theme_scanner_maybe_add_icon_theme_ready, _data_);
#line 282 "../src/panel/settings/themes.vala"
		return FALSE;
#line 2596 "themes.c"
		_state_1:
#line 282 "../src/panel/settings/themes.vala"
		theme_scanner_maybe_add_icons_finish (_data_->self, _data_->_res_);
#line 2600 "themes.c"
	}
#line 286 "../src/panel/settings/themes.vala"
	_data_->_tmp7_ = g_strdup_printf ("%s%s%s", _data_->path, G_DIR_SEPARATOR_S, "cursors");
#line 286 "../src/panel/settings/themes.vala"
	_data_->cursor_path = _data_->_tmp7_;
#line 287 "../src/panel/settings/themes.vala"
	_data_->_tmp8_ = _data_->cursor_path;
#line 287 "../src/panel/settings/themes.vala"
	if (g_file_test (_data_->_tmp8_, G_FILE_TEST_EXISTS)) {
#line 288 "../src/panel/settings/themes.vala"
		_data_->_state_ = 2;
#line 288 "../src/panel/settings/themes.vala"
		theme_scanner_maybe_add_cursors (_data_->self, _data_->path, _data_->theme_name, theme_scanner_maybe_add_icon_theme_ready, _data_);
#line 288 "../src/panel/settings/themes.vala"
		return FALSE;
#line 2616 "themes.c"
		_state_2:
#line 288 "../src/panel/settings/themes.vala"
		theme_scanner_maybe_add_cursors_finish (_data_->self, _data_->_res_);
#line 2620 "themes.c"
	}
#line 258 "../src/panel/settings/themes.vala"
	_g_free0 (_data_->cursor_path);
#line 258 "../src/panel/settings/themes.vala"
	_g_key_file_unref0 (_data_->f);
#line 258 "../src/panel/settings/themes.vala"
	_g_free0 (_data_->test_path);
#line 258 "../src/panel/settings/themes.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 258 "../src/panel/settings/themes.vala"
	if (_data_->_state_ != 0) {
#line 258 "../src/panel/settings/themes.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 258 "../src/panel/settings/themes.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2636 "themes.c"
		}
	}
#line 258 "../src/panel/settings/themes.vala"
	g_object_unref (_data_->_async_result);
#line 258 "../src/panel/settings/themes.vala"
	return FALSE;
#line 2643 "themes.c"
}

static void
theme_scanner_maybe_add_cursors_data_free (gpointer _data)
{
	ThemeScannerMaybeAddCursorsData* _data_;
	_data_ = _data;
#line 45 "../src/panel/settings/themes.vala"
	_g_free0 (_data_->path);
#line 45 "../src/panel/settings/themes.vala"
	_g_free0 (_data_->theme_name);
#line 45 "../src/panel/settings/themes.vala"
	_g_object_unref0 (_data_->self);
#line 45 "../src/panel/settings/themes.vala"
	g_slice_free (ThemeScannerMaybeAddCursorsData, _data_);
#line 2659 "themes.c"
}

static void
theme_scanner_maybe_add_cursors (ThemeScanner* self,
                                 const gchar* path,
                                 const gchar* theme_name,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_)
{
	ThemeScannerMaybeAddCursorsData* _data_;
	ThemeScanner* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 45 "../src/panel/settings/themes.vala"
	g_return_if_fail (self != NULL);
#line 45 "../src/panel/settings/themes.vala"
	g_return_if_fail (path != NULL);
#line 45 "../src/panel/settings/themes.vala"
	g_return_if_fail (theme_name != NULL);
#line 45 "../src/panel/settings/themes.vala"
	_data_ = g_slice_new0 (ThemeScannerMaybeAddCursorsData);
#line 45 "../src/panel/settings/themes.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 45 "../src/panel/settings/themes.vala"
	g_task_set_task_data (_data_->_async_result, _data_, theme_scanner_maybe_add_cursors_data_free);
#line 45 "../src/panel/settings/themes.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 45 "../src/panel/settings/themes.vala"
	_data_->self = _tmp0_;
#line 45 "../src/panel/settings/themes.vala"
	_tmp1_ = g_strdup (path);
#line 45 "../src/panel/settings/themes.vala"
	_g_free0 (_data_->path);
#line 45 "../src/panel/settings/themes.vala"
	_data_->path = _tmp1_;
#line 45 "../src/panel/settings/themes.vala"
	_tmp2_ = g_strdup (theme_name);
#line 45 "../src/panel/settings/themes.vala"
	_g_free0 (_data_->theme_name);
#line 45 "../src/panel/settings/themes.vala"
	_data_->theme_name = _tmp2_;
#line 45 "../src/panel/settings/themes.vala"
	theme_scanner_maybe_add_cursors_co (_data_);
#line 2703 "themes.c"
}

static gboolean
theme_scanner_maybe_add_cursors_finish (ThemeScanner* self,
                                        GAsyncResult* _res_)
{
	gboolean result;
	ThemeScannerMaybeAddCursorsData* _data_;
#line 45 "../src/panel/settings/themes.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 45 "../src/panel/settings/themes.vala"
	result = _data_->result;
#line 45 "../src/panel/settings/themes.vala"
	return result;
#line 2718 "themes.c"
}

/**
 * Try adding unique cursor theme
 */
static gboolean
theme_scanner_maybe_add_cursors_co (ThemeScannerMaybeAddCursorsData* _data_)
{
#line 295 "../src/panel/settings/themes.vala"
	switch (_data_->_state_) {
#line 295 "../src/panel/settings/themes.vala"
		case 0:
#line 2731 "themes.c"
		goto _state_0;
		default:
#line 295 "../src/panel/settings/themes.vala"
		g_assert_not_reached ();
#line 2736 "themes.c"
	}
	_state_0:
#line 296 "../src/panel/settings/themes.vala"
	_data_->_tmp0_ = _data_->self->priv->cursor_themes;
#line 296 "../src/panel/settings/themes.vala"
	_data_->_tmp1_ = g_hash_table_lookup (_data_->_tmp0_, _data_->theme_name);
#line 296 "../src/panel/settings/themes.vala"
	_data_->info = (ThemeInfo*) _data_->_tmp1_;
#line 297 "../src/panel/settings/themes.vala"
	_data_->_tmp2_ = _data_->info;
#line 297 "../src/panel/settings/themes.vala"
	if (_data_->_tmp2_ == NULL) {
#line 298 "../src/panel/settings/themes.vala"
		_data_->_tmp3_ = theme_info_new (THEME_TYPE_CURSOR_THEME);
#line 298 "../src/panel/settings/themes.vala"
		_data_->ninfo = _data_->_tmp3_;
#line 299 "../src/panel/settings/themes.vala"
		_data_->_tmp4_ = _data_->self->priv->cursor_themes;
#line 299 "../src/panel/settings/themes.vala"
		_data_->_tmp5_ = g_strdup (_data_->theme_name);
#line 299 "../src/panel/settings/themes.vala"
		_data_->_tmp6_ = _data_->ninfo;
#line 299 "../src/panel/settings/themes.vala"
		_data_->_tmp7_ = _g_object_ref0 (_data_->_tmp6_);
#line 299 "../src/panel/settings/themes.vala"
		g_hash_table_insert (_data_->_tmp4_, _data_->_tmp5_, _data_->_tmp7_);
#line 300 "../src/panel/settings/themes.vala"
		_data_->_tmp8_ = _data_->self->priv->cursor_themes;
#line 300 "../src/panel/settings/themes.vala"
		_data_->_tmp9_ = g_hash_table_lookup (_data_->_tmp8_, _data_->theme_name);
#line 300 "../src/panel/settings/themes.vala"
		_data_->info = (ThemeInfo*) _data_->_tmp9_;
#line 297 "../src/panel/settings/themes.vala"
		_g_object_unref0 (_data_->ninfo);
#line 2771 "themes.c"
	}
#line 302 "../src/panel/settings/themes.vala"
	_data_->_tmp10_ = _data_->info;
#line 302 "../src/panel/settings/themes.vala"
	if (theme_info_add_path (_data_->_tmp10_, _data_->path)) {
#line 303 "../src/panel/settings/themes.vala"
		_data_->result = TRUE;
#line 303 "../src/panel/settings/themes.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 303 "../src/panel/settings/themes.vala"
		if (_data_->_state_ != 0) {
#line 303 "../src/panel/settings/themes.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 303 "../src/panel/settings/themes.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2787 "themes.c"
			}
		}
#line 303 "../src/panel/settings/themes.vala"
		g_object_unref (_data_->_async_result);
#line 303 "../src/panel/settings/themes.vala"
		return FALSE;
#line 2794 "themes.c"
	}
#line 305 "../src/panel/settings/themes.vala"
	_data_->result = FALSE;
#line 305 "../src/panel/settings/themes.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 305 "../src/panel/settings/themes.vala"
	if (_data_->_state_ != 0) {
#line 305 "../src/panel/settings/themes.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 305 "../src/panel/settings/themes.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2806 "themes.c"
		}
	}
#line 305 "../src/panel/settings/themes.vala"
	g_object_unref (_data_->_async_result);
#line 305 "../src/panel/settings/themes.vala"
	return FALSE;
#line 2813 "themes.c"
}

static void
theme_scanner_maybe_add_icons_data_free (gpointer _data)
{
	ThemeScannerMaybeAddIconsData* _data_;
	_data_ = _data;
#line 45 "../src/panel/settings/themes.vala"
	_g_free0 (_data_->path);
#line 45 "../src/panel/settings/themes.vala"
	_g_free0 (_data_->theme_name);
#line 45 "../src/panel/settings/themes.vala"
	_g_object_unref0 (_data_->self);
#line 45 "../src/panel/settings/themes.vala"
	g_slice_free (ThemeScannerMaybeAddIconsData, _data_);
#line 2829 "themes.c"
}

static void
theme_scanner_maybe_add_icons (ThemeScanner* self,
                               const gchar* path,
                               const gchar* theme_name,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_)
{
	ThemeScannerMaybeAddIconsData* _data_;
	ThemeScanner* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 45 "../src/panel/settings/themes.vala"
	g_return_if_fail (self != NULL);
#line 45 "../src/panel/settings/themes.vala"
	g_return_if_fail (path != NULL);
#line 45 "../src/panel/settings/themes.vala"
	g_return_if_fail (theme_name != NULL);
#line 45 "../src/panel/settings/themes.vala"
	_data_ = g_slice_new0 (ThemeScannerMaybeAddIconsData);
#line 45 "../src/panel/settings/themes.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 45 "../src/panel/settings/themes.vala"
	g_task_set_task_data (_data_->_async_result, _data_, theme_scanner_maybe_add_icons_data_free);
#line 45 "../src/panel/settings/themes.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 45 "../src/panel/settings/themes.vala"
	_data_->self = _tmp0_;
#line 45 "../src/panel/settings/themes.vala"
	_tmp1_ = g_strdup (path);
#line 45 "../src/panel/settings/themes.vala"
	_g_free0 (_data_->path);
#line 45 "../src/panel/settings/themes.vala"
	_data_->path = _tmp1_;
#line 45 "../src/panel/settings/themes.vala"
	_tmp2_ = g_strdup (theme_name);
#line 45 "../src/panel/settings/themes.vala"
	_g_free0 (_data_->theme_name);
#line 45 "../src/panel/settings/themes.vala"
	_data_->theme_name = _tmp2_;
#line 45 "../src/panel/settings/themes.vala"
	theme_scanner_maybe_add_icons_co (_data_);
#line 2873 "themes.c"
}

static gboolean
theme_scanner_maybe_add_icons_finish (ThemeScanner* self,
                                      GAsyncResult* _res_)
{
	gboolean result;
	ThemeScannerMaybeAddIconsData* _data_;
#line 45 "../src/panel/settings/themes.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 45 "../src/panel/settings/themes.vala"
	result = _data_->result;
#line 45 "../src/panel/settings/themes.vala"
	return result;
#line 2888 "themes.c"
}

/**
 * Try adding unique icon theme
 */
static gboolean
theme_scanner_maybe_add_icons_co (ThemeScannerMaybeAddIconsData* _data_)
{
#line 311 "../src/panel/settings/themes.vala"
	switch (_data_->_state_) {
#line 311 "../src/panel/settings/themes.vala"
		case 0:
#line 2901 "themes.c"
		goto _state_0;
		default:
#line 311 "../src/panel/settings/themes.vala"
		g_assert_not_reached ();
#line 2906 "themes.c"
	}
	_state_0:
	{
#line 312 "../src/panel/settings/themes.vala"
		_data_->index = 0;
#line 2912 "themes.c"
		{
#line 312 "../src/panel/settings/themes.vala"
			_data_->_tmp0_ = TRUE;
#line 312 "../src/panel/settings/themes.vala"
			while (TRUE) {
#line 312 "../src/panel/settings/themes.vala"
				if (!_data_->_tmp0_) {
#line 312 "../src/panel/settings/themes.vala"
					_data_->_tmp1_ = _data_->index;
#line 312 "../src/panel/settings/themes.vala"
					_data_->index = _data_->_tmp1_ + 1;
#line 2924 "themes.c"
				}
#line 312 "../src/panel/settings/themes.vala"
				_data_->_tmp0_ = FALSE;
#line 312 "../src/panel/settings/themes.vala"
				_data_->_tmp2_ = _data_->self->priv->icon_theme_blacklist;
#line 312 "../src/panel/settings/themes.vala"
				_data_->_tmp2__length1 = _data_->self->priv->icon_theme_blacklist_length1;
#line 312 "../src/panel/settings/themes.vala"
				if (!(_data_->index < _data_->_tmp2__length1)) {
#line 312 "../src/panel/settings/themes.vala"
					break;
#line 2936 "themes.c"
				}
#line 313 "../src/panel/settings/themes.vala"
				_data_->_tmp3_ = _data_->self->priv->icon_theme_blacklist;
#line 313 "../src/panel/settings/themes.vala"
				_data_->_tmp3__length1 = _data_->self->priv->icon_theme_blacklist_length1;
#line 313 "../src/panel/settings/themes.vala"
				_data_->_tmp4_ = _data_->_tmp3_[_data_->index];
#line 313 "../src/panel/settings/themes.vala"
				_data_->_tmp5_ = g_strdup (_data_->_tmp4_);
#line 313 "../src/panel/settings/themes.vala"
				_data_->blacklisted_item = _data_->_tmp5_;
#line 315 "../src/panel/settings/themes.vala"
				_data_->_tmp7_ = _data_->blacklisted_item;
#line 315 "../src/panel/settings/themes.vala"
				if (g_strcmp0 (_data_->_tmp7_, _data_->theme_name) == 0) {
#line 315 "../src/panel/settings/themes.vala"
					_data_->_tmp6_ = TRUE;
#line 2954 "themes.c"
				} else {
#line 315 "../src/panel/settings/themes.vala"
					_data_->_tmp8_ = _data_->blacklisted_item;
#line 315 "../src/panel/settings/themes.vala"
					_data_->_tmp6_ = string_index_of (_data_->theme_name, _data_->_tmp8_, 0) != -1;
#line 2960 "themes.c"
				}
#line 315 "../src/panel/settings/themes.vala"
				if (_data_->_tmp6_) {
#line 316 "../src/panel/settings/themes.vala"
					_data_->result = FALSE;
#line 316 "../src/panel/settings/themes.vala"
					_g_free0 (_data_->blacklisted_item);
#line 316 "../src/panel/settings/themes.vala"
					g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 316 "../src/panel/settings/themes.vala"
					if (_data_->_state_ != 0) {
#line 316 "../src/panel/settings/themes.vala"
						while (!g_task_get_completed (_data_->_async_result)) {
#line 316 "../src/panel/settings/themes.vala"
							g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2976 "themes.c"
						}
					}
#line 316 "../src/panel/settings/themes.vala"
					g_object_unref (_data_->_async_result);
#line 316 "../src/panel/settings/themes.vala"
					return FALSE;
#line 2983 "themes.c"
				}
#line 312 "../src/panel/settings/themes.vala"
				_g_free0 (_data_->blacklisted_item);
#line 2987 "themes.c"
			}
		}
	}
#line 320 "../src/panel/settings/themes.vala"
	_data_->_tmp9_ = _data_->self->priv->icon_themes;
#line 320 "../src/panel/settings/themes.vala"
	_data_->_tmp10_ = g_hash_table_lookup (_data_->_tmp9_, _data_->theme_name);
#line 320 "../src/panel/settings/themes.vala"
	_data_->info = (ThemeInfo*) _data_->_tmp10_;
#line 321 "../src/panel/settings/themes.vala"
	_data_->_tmp11_ = _data_->info;
#line 321 "../src/panel/settings/themes.vala"
	if (_data_->_tmp11_ == NULL) {
#line 322 "../src/panel/settings/themes.vala"
		_data_->_tmp12_ = theme_info_new (THEME_TYPE_ICON_THEME);
#line 322 "../src/panel/settings/themes.vala"
		_data_->ninfo = _data_->_tmp12_;
#line 323 "../src/panel/settings/themes.vala"
		_data_->_tmp13_ = _data_->self->priv->icon_themes;
#line 323 "../src/panel/settings/themes.vala"
		_data_->_tmp14_ = g_strdup (_data_->theme_name);
#line 323 "../src/panel/settings/themes.vala"
		_data_->_tmp15_ = _data_->ninfo;
#line 323 "../src/panel/settings/themes.vala"
		_data_->_tmp16_ = _g_object_ref0 (_data_->_tmp15_);
#line 323 "../src/panel/settings/themes.vala"
		g_hash_table_insert (_data_->_tmp13_, _data_->_tmp14_, _data_->_tmp16_);
#line 324 "../src/panel/settings/themes.vala"
		_data_->_tmp17_ = _data_->self->priv->icon_themes;
#line 324 "../src/panel/settings/themes.vala"
		_data_->_tmp18_ = g_hash_table_lookup (_data_->_tmp17_, _data_->theme_name);
#line 324 "../src/panel/settings/themes.vala"
		_data_->info = (ThemeInfo*) _data_->_tmp18_;
#line 321 "../src/panel/settings/themes.vala"
		_g_object_unref0 (_data_->ninfo);
#line 3023 "themes.c"
	}
#line 326 "../src/panel/settings/themes.vala"
	_data_->_tmp19_ = _data_->info;
#line 326 "../src/panel/settings/themes.vala"
	if (theme_info_add_path (_data_->_tmp19_, _data_->path)) {
#line 327 "../src/panel/settings/themes.vala"
		_data_->result = TRUE;
#line 327 "../src/panel/settings/themes.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 327 "../src/panel/settings/themes.vala"
		if (_data_->_state_ != 0) {
#line 327 "../src/panel/settings/themes.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 327 "../src/panel/settings/themes.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3039 "themes.c"
			}
		}
#line 327 "../src/panel/settings/themes.vala"
		g_object_unref (_data_->_async_result);
#line 327 "../src/panel/settings/themes.vala"
		return FALSE;
#line 3046 "themes.c"
	}
#line 329 "../src/panel/settings/themes.vala"
	_data_->result = FALSE;
#line 329 "../src/panel/settings/themes.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 329 "../src/panel/settings/themes.vala"
	if (_data_->_state_ != 0) {
#line 329 "../src/panel/settings/themes.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 329 "../src/panel/settings/themes.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3058 "themes.c"
		}
	}
#line 329 "../src/panel/settings/themes.vala"
	g_object_unref (_data_->_async_result);
#line 329 "../src/panel/settings/themes.vala"
	return FALSE;
#line 3065 "themes.c"
}

static void
theme_scanner_class_init (ThemeScannerClass * klass,
                          gpointer klass_data)
{
#line 45 "../src/panel/settings/themes.vala"
	theme_scanner_parent_class = g_type_class_peek_parent (klass);
#line 45 "../src/panel/settings/themes.vala"
	g_type_class_adjust_private_offset (klass, &ThemeScanner_private_offset);
#line 45 "../src/panel/settings/themes.vala"
	G_OBJECT_CLASS (klass)->finalize = theme_scanner_finalize;
#line 3078 "themes.c"
}

static void
theme_scanner_instance_init (ThemeScanner * self,
                             gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar** _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar** _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar** _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar** _tmp26_;
#line 45 "../src/panel/settings/themes.vala"
	self->priv = theme_scanner_get_instance_private (self);
#line 46 "../src/panel/settings/themes.vala"
	self->priv->xdg_paths = NULL;
#line 46 "../src/panel/settings/themes.vala"
	self->priv->xdg_paths_length1 = 0;
#line 46 "../src/panel/settings/themes.vala"
	self->priv->_xdg_paths_size_ = self->priv->xdg_paths_length1;
#line 48 "../src/panel/settings/themes.vala"
	_tmp0_ = g_strdup ("Adwaita");
#line 48 "../src/panel/settings/themes.vala"
	_tmp1_ = g_strdup ("Breeze");
#line 48 "../src/panel/settings/themes.vala"
	_tmp2_ = g_strdup ("Clearlooks");
#line 48 "../src/panel/settings/themes.vala"
	_tmp3_ = g_strdup ("Crux");
#line 48 "../src/panel/settings/themes.vala"
	_tmp4_ = g_strdup ("Default");
#line 48 "../src/panel/settings/themes.vala"
	_tmp5_ = g_strdup ("Emacs");
#line 48 "../src/panel/settings/themes.vala"
	_tmp6_ = g_strdup ("Industrial");
#line 48 "../src/panel/settings/themes.vala"
	_tmp7_ = g_strdup ("Kv");
#line 48 "../src/panel/settings/themes.vala"
	_tmp8_ = g_strdup ("Mist");
#line 48 "../src/panel/settings/themes.vala"
	_tmp9_ = g_strdup ("Murrina");
#line 48 "../src/panel/settings/themes.vala"
	_tmp10_ = g_strdup ("Raleigh");
#line 48 "../src/panel/settings/themes.vala"
	_tmp11_ = g_strdup ("Redmond");
#line 48 "../src/panel/settings/themes.vala"
	_tmp12_ = g_strdup ("ThinIce");
#line 48 "../src/panel/settings/themes.vala"
	_tmp13_ = g_new0 (gchar*, 13 + 1);
#line 48 "../src/panel/settings/themes.vala"
	_tmp13_[0] = _tmp0_;
#line 48 "../src/panel/settings/themes.vala"
	_tmp13_[1] = _tmp1_;
#line 48 "../src/panel/settings/themes.vala"
	_tmp13_[2] = _tmp2_;
#line 48 "../src/panel/settings/themes.vala"
	_tmp13_[3] = _tmp3_;
#line 48 "../src/panel/settings/themes.vala"
	_tmp13_[4] = _tmp4_;
#line 48 "../src/panel/settings/themes.vala"
	_tmp13_[5] = _tmp5_;
#line 48 "../src/panel/settings/themes.vala"
	_tmp13_[6] = _tmp6_;
#line 48 "../src/panel/settings/themes.vala"
	_tmp13_[7] = _tmp7_;
#line 48 "../src/panel/settings/themes.vala"
	_tmp13_[8] = _tmp8_;
#line 48 "../src/panel/settings/themes.vala"
	_tmp13_[9] = _tmp9_;
#line 48 "../src/panel/settings/themes.vala"
	_tmp13_[10] = _tmp10_;
#line 48 "../src/panel/settings/themes.vala"
	_tmp13_[11] = _tmp11_;
#line 48 "../src/panel/settings/themes.vala"
	_tmp13_[12] = _tmp12_;
#line 48 "../src/panel/settings/themes.vala"
	self->priv->gtk_theme_blacklist = _tmp13_;
#line 48 "../src/panel/settings/themes.vala"
	self->priv->gtk_theme_blacklist_length1 = 13;
#line 48 "../src/panel/settings/themes.vala"
	self->priv->_gtk_theme_blacklist_size_ = self->priv->gtk_theme_blacklist_length1;
#line 64 "../src/panel/settings/themes.vala"
	_tmp14_ = g_strdup ("Adwaita");
#line 64 "../src/panel/settings/themes.vala"
	_tmp15_ = g_strdup ("HighContrast");
#line 64 "../src/panel/settings/themes.vala"
	_tmp16_ = g_strdup ("Papirus-Adapta");
#line 64 "../src/panel/settings/themes.vala"
	_tmp17_ = g_strdup ("Papirus-Adapta-Nokto");
#line 64 "../src/panel/settings/themes.vala"
	_tmp18_ = g_strdup ("breeze");
#line 64 "../src/panel/settings/themes.vala"
	_tmp19_ = g_strdup ("solus-sc");
#line 64 "../src/panel/settings/themes.vala"
	_tmp20_ = g_new0 (gchar*, 6 + 1);
#line 64 "../src/panel/settings/themes.vala"
	_tmp20_[0] = _tmp14_;
#line 64 "../src/panel/settings/themes.vala"
	_tmp20_[1] = _tmp15_;
#line 64 "../src/panel/settings/themes.vala"
	_tmp20_[2] = _tmp16_;
#line 64 "../src/panel/settings/themes.vala"
	_tmp20_[3] = _tmp17_;
#line 64 "../src/panel/settings/themes.vala"
	_tmp20_[4] = _tmp18_;
#line 64 "../src/panel/settings/themes.vala"
	_tmp20_[5] = _tmp19_;
#line 64 "../src/panel/settings/themes.vala"
	self->priv->icon_theme_blacklist = _tmp20_;
#line 64 "../src/panel/settings/themes.vala"
	self->priv->icon_theme_blacklist_length1 = 6;
#line 64 "../src/panel/settings/themes.vala"
	self->priv->_icon_theme_blacklist_size_ = self->priv->icon_theme_blacklist_length1;
#line 73 "../src/panel/settings/themes.vala"
	_tmp21_ = g_strdup ("themes");
#line 73 "../src/panel/settings/themes.vala"
	_tmp22_ = g_strdup ("icons");
#line 73 "../src/panel/settings/themes.vala"
	_tmp23_ = g_new0 (gchar*, 2 + 1);
#line 73 "../src/panel/settings/themes.vala"
	_tmp23_[0] = _tmp21_;
#line 73 "../src/panel/settings/themes.vala"
	_tmp23_[1] = _tmp22_;
#line 73 "../src/panel/settings/themes.vala"
	self->priv->normal_suffixes = _tmp23_;
#line 73 "../src/panel/settings/themes.vala"
	self->priv->normal_suffixes_length1 = 2;
#line 73 "../src/panel/settings/themes.vala"
	self->priv->_normal_suffixes_size_ = self->priv->normal_suffixes_length1;
#line 78 "../src/panel/settings/themes.vala"
	_tmp24_ = g_strdup (".themes");
#line 78 "../src/panel/settings/themes.vala"
	_tmp25_ = g_strdup (".icons");
#line 78 "../src/panel/settings/themes.vala"
	_tmp26_ = g_new0 (gchar*, 2 + 1);
#line 78 "../src/panel/settings/themes.vala"
	_tmp26_[0] = _tmp24_;
#line 78 "../src/panel/settings/themes.vala"
	_tmp26_[1] = _tmp25_;
#line 78 "../src/panel/settings/themes.vala"
	self->priv->legacy_suffixes = _tmp26_;
#line 78 "../src/panel/settings/themes.vala"
	self->priv->legacy_suffixes_length1 = 2;
#line 78 "../src/panel/settings/themes.vala"
	self->priv->_legacy_suffixes_size_ = self->priv->legacy_suffixes_length1;
#line 83 "../src/panel/settings/themes.vala"
	self->priv->gtk_theme_paths = NULL;
#line 83 "../src/panel/settings/themes.vala"
	self->priv->gtk_theme_paths_length1 = 0;
#line 83 "../src/panel/settings/themes.vala"
	self->priv->_gtk_theme_paths_size_ = self->priv->gtk_theme_paths_length1;
#line 85 "../src/panel/settings/themes.vala"
	self->priv->gtk_themes = NULL;
#line 86 "../src/panel/settings/themes.vala"
	self->priv->cursor_themes = NULL;
#line 87 "../src/panel/settings/themes.vala"
	self->priv->icon_themes = NULL;
#line 3256 "themes.c"
}

static void
theme_scanner_finalize (GObject * obj)
{
	ThemeScanner * self;
#line 45 "../src/panel/settings/themes.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_THEME_SCANNER, ThemeScanner);
#line 46 "../src/panel/settings/themes.vala"
	self->priv->xdg_paths = (_vala_array_free (self->priv->xdg_paths, self->priv->xdg_paths_length1, (GDestroyNotify) g_free), NULL);
#line 48 "../src/panel/settings/themes.vala"
	self->priv->gtk_theme_blacklist = (_vala_array_free (self->priv->gtk_theme_blacklist, self->priv->gtk_theme_blacklist_length1, (GDestroyNotify) g_free), NULL);
#line 64 "../src/panel/settings/themes.vala"
	self->priv->icon_theme_blacklist = (_vala_array_free (self->priv->icon_theme_blacklist, self->priv->icon_theme_blacklist_length1, (GDestroyNotify) g_free), NULL);
#line 73 "../src/panel/settings/themes.vala"
	self->priv->normal_suffixes = (_vala_array_free (self->priv->normal_suffixes, self->priv->normal_suffixes_length1, (GDestroyNotify) g_free), NULL);
#line 78 "../src/panel/settings/themes.vala"
	self->priv->legacy_suffixes = (_vala_array_free (self->priv->legacy_suffixes, self->priv->legacy_suffixes_length1, (GDestroyNotify) g_free), NULL);
#line 83 "../src/panel/settings/themes.vala"
	self->priv->gtk_theme_paths = (_vala_array_free (self->priv->gtk_theme_paths, self->priv->gtk_theme_paths_length1, (GDestroyNotify) g_free), NULL);
#line 85 "../src/panel/settings/themes.vala"
	_g_hash_table_unref0 (self->priv->gtk_themes);
#line 86 "../src/panel/settings/themes.vala"
	_g_hash_table_unref0 (self->priv->cursor_themes);
#line 87 "../src/panel/settings/themes.vala"
	_g_hash_table_unref0 (self->priv->icon_themes);
#line 45 "../src/panel/settings/themes.vala"
	G_OBJECT_CLASS (theme_scanner_parent_class)->finalize (obj);
#line 3285 "themes.c"
}

static GType
theme_scanner_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ThemeScannerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) theme_scanner_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ThemeScanner), 0, (GInstanceInitFunc) theme_scanner_instance_init, NULL };
	GType theme_scanner_type_id;
	theme_scanner_type_id = g_type_register_static (G_TYPE_OBJECT, "ThemeScanner", &g_define_type_info, 0);
	ThemeScanner_private_offset = g_type_add_instance_private (theme_scanner_type_id, sizeof (ThemeScannerPrivate));
	return theme_scanner_type_id;
}

GType
theme_scanner_get_type (void)
{
	static volatile gsize theme_scanner_type_id__once = 0;
	if (g_once_init_enter (&theme_scanner_type_id__once)) {
		GType theme_scanner_type_id;
		theme_scanner_type_id = theme_scanner_get_type_once ();
		g_once_init_leave (&theme_scanner_type_id__once, theme_scanner_type_id);
	}
	return theme_scanner_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

